// SysNames.h -- 2010 January 14

#ifndef MOS_SysNames
#define MOS_SysNames

#include <stdlib.h>
#include <string.h>

#ifdef __MSL__ // so we can test-compile it on the Mac
#include "Windows.h"
#else
#define STRICT
#include <windows.h>
// #include <commctrl.h> // DLL not available on Win95
#endif

////////////////////////////////////////////////////////////////////////

// Forwards defined in TurkFrame.h ..

// Standard type conversions and other built-ins..

typedef int* IntArray;
typedef int* DraCliPkg;
#define WinWindow HWND
#define WinFile HANDLE

// int* _tmp_0_; // temp widely used in pointer allocation (moved to user code)

inline int LoWord(int x) {return (x&0x7FFF)-(x&0x8000);}
// inline int HiWord(int x) {return x >> 16;}
// inline int LoHalf(int x) {return x&0xFFFF;}
// inline int Pack2ints(int V, int H) {return (H&0xFFFF)+(V<<16);}
// inline int MaskInts(int a, int b, int m) {return (a&~m)+(b&m);}

inline int MAX(int x, int y) {if (x>y) return x; else return y;}
inline int MIN(int x, int y) {if (x<y) return x; else return y;}
inline int ABS(int x) {if (x<0) return -x; else return x;}

// #define LoWord(xx) (((xx)&0x7FFF)-((xx)&0x8000))
#define HiWord(xx) ((xx)>>16)
#define LoHalf(xx) ((xx)&0xFFFF)
#define Pack2ints(a,b) (((b)&0xFFFF)+((a)<<16))
#define MaskInts(a,b,m) ((a)&~(m)|(b)&(m))

// #define MAX(a,b) ((a)<(b)?(b):(a))
// #define MIN(a,b) ((a)>(b)?(b):(a))
// #define ABS(xx) ((xx)<0?-(xx):(xx))

#define Capitize(xx) (((xx)<'a')?(xx):(((xx)>'z')?(xx):(char)(((int)(xx))-32)))
#define IgnoreBool(xx) xx
#define IgnoreInt(xx) xx
#define Int_CAST(xx) (int)xx

#define HiBit (1<<31)
#define boolean bool
#define null NULL

#define TabKey '\t'
#define EnterKey '\n'
#define BSkey ((char)8)
#define DelKey ((char)127)
#define EscKey ((char)27)
#define LfArKy ((char)28)
#define RtArKy ((char)29)
#define UpArKy ((char)30)
#define DnArKy ((char)31)

// ORD() returns an integer cast of its parameter
inline int ORD(bool b) {if (b) return 1; else return 0;}
inline int ORD(char c) {return (((int)c)&255);}
inline int ORD(const char* st) { // nominally Big-Endian, like Char4
  int n = strlen(st);
  if (n==0) return 0;
  if (n==1) return (int)st[0];
  if (n==2) return (((int)st[0])<<8)+((int)st[1]);
  if (n==3) return (((int)st[0])<<16)+(((int)st[1])<<8)+((int)st[2]);
  return (((int)st[0])<<24)+(((int)st[1])<<16)+(((int)st[2])<<8)+((int)st[3]);}
inline char CHR(int c) {return (char)c;}

//inline char Capitize(char ch) { // POST: result is not lower-case letter
//  if (ch<'a') return ch;
//  if (ch>'z') return ch;
//  return CHR(ORD(ch)-32);}

inline int _PEEK_(int iPtr) { // Dangerous.PEEK()
  int* xptr = (int*)iPtr;
  return *xptr;}
inline void _POKE_(int iPtr, int val) { // Dangerous.POKE()
  int* xptr = (int*)iPtr;
  *xptr = val;}
inline void _2POKE0_(int* xptr) {*xptr++ = 0; *xptr = 0;} // StringArrayZap

// Some type-casts for sending complex events..
#define int_2_ptr(i) (int*)((long)(i))
#define ptr_2_int(p) (int)((long)((void*)(p)))

// array/pointer management routines..

namespace  _FrameWork_ {void my_free(int* ary, int whom);} // end  _FrameWork_
// namespace  _System_ {void Cache_Done(int* ary, int whom);} // end  _System_

void set_ary_size(void* aptr, int siz);
int* my_int_ary(int lnx, int whom); // int* new_int_ary(int lnx);
#define new_int_ary(lnx) my_int_ary(lnx,_BASE_+__LINE__)

int* up__ptr(void* aptr);
int* dn__ptr(void* aptr, int whom);

inline int LENGTH(int* ary) {return *ary;}

#define FILL_0(ary,offs,nwds) _FrameWork_::FILL0((int*)ary,offs,nwds)
#define DeadPointerCheck(xx) // _FrameWork_::ViewArrayInDebugger(xx)

#define down__ptr(ary) dn__ptr(ary,_BASE_+__LINE__)
// void DoneWith(int* aPtr);
#define DoneWith(ary) {} // _System_::Cache_Done(ary,_BASE_+__LINE__)
// #define Done_With(ary,whom) dn__ptr(ary)
// #define Done_With(x) {}

#define SameArray(a,b) (a==b)

#define _Bounds_ChkL_(ary,aix) if(((__aiy__=(aix))<0)||(((__aiz__=*ary)>0)&&(__aiy__>=__aiz__))) _Array_Bounds_Fail_(__aiy__,__aiz__); else ary[2+__aiy__]

#define _Bounds_ChkR_(ary,aix) ((((__aix__=(aix))>=0)&&((__aiz__=*ary)>__aix__)) ? ary[2+__aix__] : _Array_Bounds_Fail_(__aix__,__aiz__))

////////////////////////////////////////////////////////////////////////

// Opaque Point type, implemented as an int..

typedef int Point;
#define Nowhere 0x80008000   // final Point Nowhere = &0x80008000;

inline int Point2int(Point x) {return (int)x;}
inline Point Point4int(int x) {return (Point)x;}
inline Point MakePoint(int V, int H) {return Point4int(Pack2ints(V,H));}
inline int PointV(Point pt) {return HiWord(Point2int(pt));}
inline int PointH(Point pt) {return LoWord(Point2int(pt));}

inline Point AddPt(Point a, Point b) { // PRE: a+b not outside 32K range
  return (Point)MaskInts((((int)a)&~0xFFFF)+(int)b,((int)a)+(int)b,0xFFFF);}

inline Point NegPt(Point pt) {
  return (Point)MaskInts(-(((int)pt)&~0xFFFF),-((int)pt),0xFFFF);}

inline boolean EqPt(Point a, Point b) {return (a==b);}

// Predefined Rectangle class (base class for all widgits)

struct _RectAngle_ {int _00_,_000_;
  int rTop;  int rLeft;  int rBotm;  int rRite;
  _RectAngle_() { /* _00_ = 4; */ set_ary_size((void*)this,4);
    }}; typedef _RectAngle_* RectAngle;

////////////////////////////////////////////////////////////////////////

// 4-character-as-int (Char4) class, intrinsic to Turk/2..

class Char4 {
  int cccc;
public:
  Char4();
  Char4(int x);
  Char4(const char* st); // usually constructed from literal string
  Char4 operator=(const int x);
  Char4 operator=(const char* st);
  bool operator==(const char* st); // most often compared for equal to lit str
  bool operator!=(const char* st);
  bool operator<=(const char* st); // the rest of these for completeness..
  bool operator>=(const char* st);
  bool operator<(const char* st);
  bool operator>(const char* st);
  bool operator<(Char4 st);
  bool operator>(Char4 st);
  bool operator<=(Char4 st);
  bool operator>=(Char4 st);
  bool operator==(Char4 st);
  bool operator!=(Char4 st);
  friend int ORD(Char4 x); // type-cast functions Char4 <-> int
  friend Char4 CHR4(int x);};

Char4 CHR4(int x);
int ORD(Char4 x);
Char4 Up4Char(Char4 Num4);
boolean Is4chars(int val);

////////////////////////////////////////////////////////////////////////

// Global declarations used in WinMain/InitializeAll..

class _Event_;
typedef _Event_* Event;
class _T2F_Process_;
typedef _T2F_Process_* Process;
typedef _T2F_Process_* T2F_Process;

struct _Widgit_;
typedef _Widgit_* Widgit;
struct _WindInfo_;
typedef _WindInfo_* Window;
typedef _WindInfo_* WindInfo;
typedef _WindInfo_* MenuBar; // type MenuBar; // see class WindInfo for contents

#define CapsLockKey 0x10000 // in the "KeyI" message datum
#define ShiftKey 0x20000
#define ControlKey 0x40000
#define AppMenuKey 0x80000 // = Cmd
#define WinKey 0x100000 // = Opt
#define AltKey 0x100000

////////////////////////////////////////////////////////////////////////

// ref-counted String class, intrinsic to Turk/2..

//  String is a 1-word reference to the string value, =0 is ""
//  String compare in T2 is not case-sensitive in the ASCII range

class String {
  char* stp;
  int cmpr_(const char* st);
  int cmpr_(String st);
public:
  String();
  String(const char* st);
  String(const char* st, int ln);
  String(const String& st);
  String(int i);
  String(char c);
  String(bool b);
  String(Char4 x);
  String operator=(const char* st);
  String operator+(const char* st);
  bool operator<(const char* st);
  bool operator>(const char* st);
  bool operator<=(const char* st);
  bool operator>=(const char* st);
  bool operator==(const char* st);
  bool operator!=(const char* st);
  String operator=(String st);
  String operator+(String st);
  bool operator<(String st);
  bool operator>(String st);
  bool operator<=(String st);
  bool operator>=(String st);
  bool operator==(String st);
  bool operator!=(String st);
  String operator=(char c);
  String operator=(int i);
  String operator+(int i);
  ~String();
  int length_();
  void valid_();
  char* text_();};

String GetPstr(int* ary);
void AppPstr(int* ary, const char* st);
void AppPstr(int* ary, String st);
void AppChar(int* ary, char chx);

// String Manager Operations..
inline int LENGTH(String st) {return st.length_();}

Char4 Chr4Str(String st);
char CharAt(int i, String st);
String Substring(int offs, int len, String st);
String TxtBlok2Str(int offs, int nch, int* ary);
void Str2TxtBlok(String st, int offs, int mxln, int* ary);
int FindStTxBlk(String st, int offs, int mxln, int* ary);
int* Text_Ary_Str(String st);

// Turk/2 compiled code access..
inline int _len_(String st) {return st.length_();}
inline String _cat_(String sta, String stb) {return sta+stb;}
inline String _cat_(String sta, char* stb) {return sta+stb;}
inline String _cat_(char* sta, String stb) {return String(sta)+stb;}
inline String _cat_(char* sta, char* stb) {return String(sta)+stb;}

////////////////////////////////////////////////////////////////////////

#ifdef FrameWork_Body

String Null_Str(""), One_Dot("."), Two_Dots(".."); // some string "constants"
Char4 Null4 = CHR4(0);

int MonthDays[] = {13,-1, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31, 365};
String MonthNames[] = {Null_Str,Null_Str,
    String("Jan"), String("Feb"), String("Mar"), String("Apr"),
    String("May"), String("Jun"), String("Jul"), String("Aug"),
    String("Sep"), String("Oct"), String("Nov"), String("Dec")};

int BibleBooks[] = {69,-1, 0x20202020, 0x47656E2E, 0x45786F2E, 0x4C65762E, 0x4E756D2E, 0x2044742E, 0x4A73682E, 
    0x4A64672E, 0x5274682E, 0x31536D2E, 0x32536D2E, 0x20314B2E, 0x20324B2E, 0x3143682E, 0x3243682E, 
    0x457A722E, 0x4E65682E, 0x4573742E, 0x4A6F622E, 0x5073612E, 0x50726F2E, 0x4563632E, 0x536F532E, 
    0x4973612E, 0x4A65722E, 0x4C616D2E, 0x457A6B2E, 0x44616E2E, 0x486F732E, 0x4A6F652E, 0x416D6F2E, 
    0x4F62642E, 0x4A6E682E, 0x4D69632E, 0x4E61682E, 0x4861672E, 0x5A70682E, 0x4861672E, 0x5A65632E, 
    0x4D616C2E, 0x204D742E, 0x204D6B2E, 0x204C6B2E, 0x204A6E2E, 0x2041632E, 0x526F6D2E, 0x31436F2E, 
    0x32436F2E, 0x47616C2E, 0x4570682E, 0x5068702E, 0x436F6C2E, 0x3154682E, 0x3254682E, 0x31546D2E, 
    0x32546D2E, 0x5469742E, 0x50686D2E, 0x4865622E, 0x4A616D2E, 0x3150652E, 0x3250652E, 0x314A6E2E, 
    0x324A6E2E, 0x334A6E2E, 0x204A752E, 0x5265762E, 0x44656D2E, 0x20202020};

String MsgBxMsgs[] = {Null_Str,Null_Str,
    String("Resume"), String("OK"), String("Cancel"), String("No"),
    String("Yes"), String("Save"), String("Discard"), String("Yes All")};

#else

extern String Null_Str, One_Dot, Two_Dots; // some string "constants"
extern Char4 Null4;

extern int* BibleBooks;
extern int* MonthDays;
extern String* MonthNames;
extern String* MsgBxMsgs;

#endif // FrameWork_Body

////////////////////////////////////////////////////////////////////////

// Opaque File type, implemented as a pointer to a _File_ class..

class _File_;
typedef _File_* File;
class _File_ { // mostly same subfields as MOS record..
  String FilNamLnk, DirPath;
  File FileLink;
  WinFile FileInodN;
  File ParDirLnk;
  int FiFlagCnt, FilePosnO, FileRefNum;
  HANDLE Find_Hand;
public:
  void flush_() {FlushFileBuffers(FileInodN);} // don't use, interminable delays!
  int GetRefNum() {return FileRefNum;}
  File GetLink() {return FileLink;}
  WinFile GetWn32_File() {return FileInodN;}
  void File_w32_Zap() {FileInodN = NULL;}
  String myFileName() {return FilNamLnk;}
  String myFullPath() {return DirPath;}
  int GetFlagz() {return FiFlagCnt;}
  void SetFlagz(int flagz) {FiFlagCnt = flagz;}
  HANDLE GetFiHand() {return Find_Hand;}
  void SetFiHand(HANDLE theH) {Find_Hand = theH;}
  _File_(String pth, WinFile wfi, int flg);
  _File_();
  ~_File_();}; // ~_File_

#define FileErr (-256) // default, others +
#define FileEOF (FileErr+1) // only in InfoFil
#define NoSuchFile (FileErr+2)
#define Fi_Find_32 WIN32_FIND_DATA
#define WriteOnly 2
#define Append 3 // =WriteOnly, but starts at end
#define BinaryFile 8
#define Directory 16 // otherwise (create/open) a file
#define ResFileTy (BinaryFile+Directory)
#define DirecOnly ResFileTy // mask for separating Dir from ResFi
#define MakeFiRef 64
#define FlagMask 0xFFF // ref count is above that in dirs

#define File_Destructor(f) delete f

void SystemDebugLog(String theSt); // fwd, used soonly
int FiSize_If_0(File aFile, int nby); // fwd, defined in FrameWork.t2..

int GetFileFlags(File aFile);
String GetFileName(File aFile);
String FullPath(File aFile);
int GetFiRefNum(File aFile);
int ReadData(File aFile, int* ary);
String ReadText(File aFile, int nby);
String ReadLine(File aFile);
int WriteData(File aFile, int* ary);
void WriteBytes(File aFile, int* ary, int bgn, int ln);
void WriteChar(File aFile, char ch);
void WriteLn(File aFile);
void WriteText(File aFile, String theSt);
void WriteChr4(File aFile, Char4 cx);
String GetCurWinDirName(void);
String ProgFileName(void);

////////////////////////////////////////////////////////////////////////

// #ifdef MOS_System

String FormDateTime(int theNum, int opt);
String FormBibleRef(int ref);
String FormInt(int theNum);
void AsyncMsg(Char4 EvNo, int eInfo, int EvLoc, int EvDat, Process toPro);
void CloseWindow(Window aWin); // used in FW

// #endif // MOS_System

int _Array_Bounds_Fail_(int aix, int aiz);

////////////////////////////////////////////////////////////////////////

// Process management stuff..

#define Sem32 HANDLE

class _T2F_Process_ {public: // base class for processes
  int _00_,_000_; // memory block length, reference count
  Process _link_; // was: PIBlink
  Sem32 _wait_event_, // was: PIBeventQ = where we wait for events
    _reply_wait_; // was: EvWaits, wait for a reply when sending msg to other proc
  Event _event_list_;
  String _my_name_;   // was: myName
  Char4 _my_ID_;      // was: PIBprocID
  int _Delay_Time_, _Pend_Bitz_; // see also PkgPending
  DWORD WinThread_ID; // was: WinThreadID;
  HANDLE Thread_32;   // was: theThread;
  void T2F_Quit();
  Process Resume(); // returns next link in sem_Q
  // ~_T2F_Process_();
  _T2F_Process_();
  _T2F_Process_(String pname, Char4 pnam4);}; //~T2F_Process

// Predefined Event class, implemented as a pointer to class _Event_

class _Event_ {
  int _00_,_000_;
  int _ev_state_; // 0 no reply; 1 queued; 2 seen, waiting reply; 3 removed
  Event _ev_link_;
public: 
  Char4 EventNo;
  int EvInfo;       // EvInfo is size or click time
  int EvLocn;       // EvLocn is mem addr or mouse loc
  int EvDatum;
  Process EvSend;
  int GetState() {return _ev_state_;}
  // _Event_();
  void EnQueue(Process whom, bool state);
  friend Event De_Queue(Process whom);
  friend void Valid8_Event(Event theEv);}; //~_Event_

// Opaque Window type, implemented as a pointer to a WindInfo class..

// class _WindInfo_;
// typedef _WindInfo_* Window; // defined and used above
// struct _Widgit_;
// typedef _Widgit_* Widgit;

// wFlags bit masks:
#define wiVisble 1
#define wiHilit 2
#define wiHasFocus 4 // takes keystrokes
#define wiActive 8 // takes/reports clicks
#define wiMousIn 16
#define wiDrugIn 32
#define wiClikIn 64 // chkbx checked
#define wiRollOver 128 // reports rollovers
#define wiClicker 256 // reports clicks to owner
#define wi2clicks 512 // reports 2-clicks
#define wiDragble 1024 // dragable
#define wiDropble 2048 // takes drops
#define wiOwnDraw 0x1000 // owner draws it
#define wiDefalt 0x2000 // default [button] auto-close [window]
#define wiTxRight 0x4000 // right-just text
#define wiTxLeft 0x8000 // left-just text
#define wiTxCenter 0xC000 // centered text =0 if not Texty
#define wiAutoSizeM 0xF0000 // auto-size bits: TBLR
#define wiAutoFill 0x50000 // all 4 edges track their edge
  // 00 no mods (stay with TL), 01 fill win, 11 stay with BR, 10 center?
#define wiUserBits 0x3F00000 // specific to the wigit
#define wiUsrBitShft 20 // for positioning wiUserBits
#define wiFloat 0x80000000 // (negative)
#define wiMenuF 0x40000000 // always with wiFloat
#define wUpdating 0x10000000
#define wManaged 0x20000000 // window manager handles clicks/updates
#define MBarHeight 18
#define SysFontHite 12
#define SysFontAsc 8
#define SysFontInfo ((SysFontHite<<16)+SysFontAsc) // Ascent=8, LineHeight=12

struct _Widgit_: _RectAngle_ {
  Char4 wKind;  Char4 wName;  int wFlags;
  Widgit wLink; // wLink is siblings, in Z-order for widg
  Widgit wParent;  Widgit wChild;
  Window wWindo; // if Window, master window list link
  int FoBgColo; // see TexBgColo for info (unused, repurposed to PreScro)
  String theText; // formerly in Texty
  int MoInfo; // formerly winFont in Texty, hilit in Dial, ResNo in FormDoc
  int HostInfo; /// Win32Window; // private:  IDropTarget* wDropTarg;
public: // methods..
  WinWindow Win32Win() {return (WinWindow)((void*)HostInfo);}
  void Win32set(WinWindow w32) {HostInfo = (int)w32;}
  _Widgit_() { /* _00_ = 15; */ set_ary_size((void*)this,15);}
  _Widgit_(Window inW, Widgit par, String tx, Char4 kin,
      RectAngle rc, WinWindow aWin);
  ~_Widgit_();}; // typedef _Widgit_* Widgit;

struct _WindInfo_: _Widgit_ {
  Char4 wOwner; // wOwner is program ID; wName is related/user-spec
  Char4 wNxID; // next window being redrawn in Widgit.wLink
  Widgit wFocus; // wFocus is not a counted reference
  Point wTextVH; // Widgit.theText is title
  int wUserData, wMoreInfo, wCoverR;
  void Link_Me_In(Char4 kin);
  void Un_Link_Me(bool Add2Free);
  _WindInfo_();
  _WindInfo_(String tx, Char4 kin, Char4 owner, WinWindow aWin, RectAngle rc);
  ~_WindInfo_();
  Widgit Get_Wgt(int parm);
  int Win_Get(int parm);
  void Set_Wgt(Widgit datum, int parm);
  void Set_Title(String title);
  void Win_Set(int datum, int parm);};

Char4 GetWindID(Window theWin);
String GetWinTitle(Window theWin);
void SetWinTitle(Window theWin, String theTx);

////////////////////////////////////////////////////////////////////////

// Utility Functions not elsewhere defined..

Process NewProgram(String prName, File dir, Char4 pnm4); // fwd decl'n
Char4 Unique_ProcessID(Char4 pnam4);
int GetTime(void);
int GetMilliSecs(void);
Char4 ProcID(Process whom);

// Win32 Registry Access.. -- note: this is #ifdef'd out if no System.h

String GetRegistryItem(String RegName, String ItemName);
void SaveRegistryItem(String datum, String RegName, String ItemName);
String AskText(String msg, String txt, int opt);
int MsgBox(String msg, Char4 icn, int opt);
void SetCursor(int whom, Window win, RectAngle rc);

String Replace(String NuSt, int offs, int nch, String theSt);
String WordOf(int ordn, String theSt);
String LineOf(int ordn, String theSt);
String TokenOf(int ordn, String theSt);
String ItemOf(char sep, int ordn, String theSt);
String PutWordOf(String NuSt, int ordn, String theSt);
String PutLineOf(String NuSt, int ordn, String theSt);
String PutTokenOf(String NuSt, int ordn, String theSt);
String PutItemOf(String NuSt, char sep, int ordn, String theSt);
String InsertB4Word(String NuSt, int ordn, String theSt);
String InsertB4Line(String NuSt, int ordn, String theSt);
String InsertB4Token(String NuSt, int ordn, String theSt);
String InsertB4Item(String NuSt, char sep, int ordn, String theSt);
String DeleteWordOf(int ordn, String theSt);
String DeleteLineOf(int ordn, String theSt);
String DeleteTokenOf(int ordn, String theSt);
String DeleteItemOf(char sep, int ordn, String theSt);
int nWords(String theSt);
int nTokens(String theSt);
int nLines(String theSt);
int n0Lines(String theSt);
int nItems(char sep, String theSt);
int n0Items(char sep, String theSt);
boolean ParseBool(String stx);
int ParseInt(String stx);
int Offset(String sot, String instr);
String LastItem(String name, char delim);
String ReplacAll(String nust, String seek, String theStr);

int GetFilePosn(File aFile);
int GetSizeFile(File aFile);
int GetFileErr();
bool FileAtEOF(File aFile);
File CloneFileRef(File aFile);
void Seek(File aFile, int offs);
File Close2Ref(File aFile);
void FileClose(File aFile);
void FileDelete(File aFile);
void SetEOF(File fi);
void Beep();
Process MySelf();
Process Proc4ch(Char4 pnam);
void Stop4Debug(Char4 msg);
void MonitorStrings(bool doWhat);

#define Offs2ItemOf(ch,n,st) _FrameWork_::Tokenize(((int)ch)&255,n,st,0)

////////////////////////////////////////////////////////////////////////

// Forwards & data defined/used in System.h ..

struct _Dial_; typedef _Dial_* Dial;
struct _Dial_: _Widgit_ {
  int value;
  int base;
  int limit;
  int pcnt;
  int prior;
  int thumb;
  _Dial_() { /* _00_ = 21; */ set_ary_size((void*)this,21);  }};

struct _FormDoc_; typedef _FormDoc_* FormDoc;
struct _FormDoc_: _Widgit_ {
  File ResFi;
  File ActFi;
  Char4 AcImPro;
  int LineHi;
  int HotHit;
  int imTall;
  int imWide;
  int* Pixels;
  int* HotSpots;
  _FormDoc_() { /* _00_ = 24; */ set_ary_size((void*)this,24);  }};

struct _ShoImage_; typedef _ShoImage_* ShoImage;
struct _ShoImage_: _FormDoc_ {
  int* imImage;
  int* imIcons;
  int LineWi;
  int ImSelec;
  int VirtImSz;
  _ShoImage_() { /* _00_ = 29; */ set_ary_size((void*)this,29);  }};

struct _BigTextEd_; typedef _BigTextEd_* BigTextEd;
struct _BigTextEd_: _FormDoc_ {
  Char4 TxFont;
  int** TextBlox;
  int TxtLns;
  int LinOffs2Pix;
  int nPixLines;
  int SelCarat;
  int SeleBgn;
  int SeleEnd;
  int OtherData;
  _BigTextEd_() { /* _00_ = 33; */ set_ary_size((void*)this,33);  }};

struct _Texty_; typedef _Texty_* Texty;
struct _Texty_: _Widgit_ {
  int TxFace;
  _Texty_() { /* _00_ = 16; */ set_ary_size((void*)this,16);  }};

struct _EditField_; typedef _EditField_* EditField;
struct _EditField_: _Texty_ {
  int cFill;
  int cTake;
  _EditField_() { /* _00_ = 18; */ set_ary_size((void*)this,18);  }};

struct _IconButn_; typedef _IconButn_* IconButn;
struct _IconButn_: _Texty_ {
  int* IcnBits;
  _IconButn_() { /* _00_ = 17; */ set_ary_size((void*)this,17);  }};

struct _Menu_; typedef _Menu_* Menu;
struct _Menu_: _Texty_ {
  HMENU theMenuHandle;
  Point mSize;
  int* mItems;
  _Menu_() { /* _00_ = 19; */ set_ary_size((void*)this,19);  }};

////////////////////////////////////////////////////////////////////////

// #ifdef MOS_System // can't, gotta depend on linker to fail

Window WindowFromID(Char4 id);
void InitPstr(int* theAry);
void AppHex(int* theAry, int theNum, int nd);
void AppNum(int* theAry, int theNum);
void AppCh4(int* theAry, Char4 nm4);
int JulianOf(int theTime);
int YearOf(int theTime);
int HourOf(int theTime);
int MinitOf(int theTime);
int SecOf(int theTime);
int MonDate(int theTime);
String FormHexNum(int num, int dgs);
String FormLogStr(int theLen, String theStr);
int MakeEventStr(String theStr);
String GetEventStr(int str);
String EncodeIntArray(int* ary);
int* DecodeIntArray(String theStr);
File OpenInDir(String name, int opt, File dir);
File FileOpen(String name, int opt);
File OpenFileRef(File ref, int opt);
File FileDialog(String Prompt, File iDir, Char4 fty);
File NewFileDlog(String Prompt, File iDir, String fnm);
File FileFromID(int theNum);
Char4 WhoAmI();
RectAngle NewRect(int tp, int lf, int bt, int rt);
bool EmptyRect(RectAngle rc);
RectAngle SectRect(RectAngle ra, RectAngle rb);
bool PtInRect(Point pt, RectAngle rc);
void StuffRect(RectAngle rc, int tp, int lf, int bt, int rt);
void OffsetRect(RectAngle rc, int ver, int hor);
bool InsetRect(RectAngle rc, int TB, int LR);
// int* GetResource(File theFi, Char4 rty, int rno);
int* Get__Resource(File theFi, Char4 rty, int rno, int lino);
#define GetResource(theFi,rty,rno) Get__Resource(theFi,rty,rno,_BASE_+__LINE__)
void DebugResCache(boolean flush);
void InitResFile(File ResFi);
void NewResource(File ResFi, Char4 theTy, int theId, String nm, int* AryPtr);
void ReplaceRes(File ResFi, Char4 theTy, int theId, String nm, int* AryPtr);
void NewStrRes(File ResFi, Char4 theTy, int theId, String nm, String theStr);
void DeleteResource(File ResFi, Char4 theTy, int theId, String nm);
int SeeResource(File ResFi, Char4 theTy, int theId, String nm, int* AryPtr);
int CountResTypes(File ResFi);
Char4 GetIxResType(File ResFi, int ix);
int NumResources(File ResFi, Char4 theTy);
int GetIxResource(File ResFi, Char4 theTy, int ix, int* AryPtr);
int GetIxResID(File ResFi, Char4 theTy, int ix);
void UpdateResFile(File ResFi);
String GetStrRes(File theFi, Char4 rty, int rno);
Window NextWindow(Window theWin);
Widgit InitWidgit(Window inWin, Char4 kn, RectAngle rc, String tx, Widgit par);
void WidgitDraw(Widgit wgt);
Widgit GetMyWidgits(Window theWin);
Widgit GetMbarWidgits(Window theWin);
Widgit WgtFromID(Window theWin, Char4 id);
Widgit FindThisWgt(int wID, String theStr, Window theWin);
FormDoc FormDoc4wgt(Widgit wgt);
ShoImage ShoImage4wgt(Widgit wgt);
BigTextEd BigText4wgt(Widgit wgt);
Texty Texty4wgt(Widgit wgt);
Menu Menu4wgt(Widgit wgt);
Dial Dial4wgt(Widgit wgt);
Window EventWindow(Event evp);
Widgit ClickedWidgit(Event evp);
void AsyncFiMsg(Char4 EvNo, File fi, int EvLoc, int EvDat, Process toPro);
void ReplyFile(Event evp, File fi);
File EventFile(Event evp);
void DrawOnWin(Window win);
int StdFontInfo(Char4 fx);
int FontChrWidth(char str, Char4 fo);
void ScreenChar(char ch);
int FontStrWidth(String str, Char4 fo);
void ScreenSet(int bgc, int txc, int V, int H);
void FillRect(int tp, int lf, int bt, int rt, int colo);
void FrameRect(RectAngle rc, int colo, int wid);
void DrawLine(int tp, int lf, int bt, int rt, int colo);
void ScrnBytes(int offs, int txnd, int* txar);
void ScreenText(String theSt);
void DrawImage(RectAngle rc, Point scr, int* icn);
Window NewWindow(Char4 kin, RectAngle rc, String stx);
void ShowWindow(Window theWin);
void HideWindow(Window theWin);
void CloseWindow(Window theWin);
void MoveWind(Window theWin, Point loc);
void SizeWind(Window theWin, Point loc);
void SetWinFlag(Window theWin, int val, int flg);
Point GetWinLoc(Window theWin);
Point GetWinSize(Window theWin);
int GetWinData(Window theWin, int offs);
void SetWinData(Window theWin, int val, int offs);
int GetWinFlag(Window theWin, int flg);
void InvalRect(Window theWin, RectAngle rc);
int GetButtons();
Point GetMouse(Window aWin);
String SortIt(String theStr, char sep, int flgs);
String SortLns(String str);
String SortWords(String str);
String SortItems(String str, char sep);
String SortGen(String str, char sep, bool desc, bool irev, bool nemt);
Window NewProgress(int vx, String tx);
Window ProgressMsg(Window theWin, int vx, String tx);
Window ProgressBar(Window theWin, int vx);
void EndProgress(Window theWin);
Window FindTxtWin(int id);
Window FindImgWin(int id);
Window FindDocWin(int id);
void SetDocScroll(Window theWin, int loc);
int GetDocScroll(Window theWin);
Window NewDocWin(File ResFi, int rn, String tx);
Window NewImgWin(File ResFi, int rn, String tx);
Window NewTxtWin(File ResFi, int rn, String tx);
String GetBigText(BigTextEd txWg);
int BigLnOff2Pt(int lnoff, BigTextEd txWg);
int BigPt2LnOff(Point loc, BigTextEd txWg);
void CantUndo();
void NewUndoEsz(String lbl, int ni);
void NewUndo(String lbl);
void UndoAdd(Char4 ms, int inf, int loc, int dat);
void RedoAdd(Char4 ms, int inf, int loc, int dat);
void UndoText(String txt, int loc, Window win);
void RedoText(String txt, int loc, Window win);
void UndoTxAdd(Char4 ms, String txt, int loc, int dat);
void RedoTxAdd(Char4 ms, String txt, int loc, int dat);
void RedoMenu(String txt);
void UndoFile(File fi, int loc, Window win);
void RedoFile(File fi, int loc, Window win);
bool BeganUndoPkg(Char4 sgn, int inf, String lbl, bool fize);
void DoUndo(Window myWin);
int* DragClipEvent(Event theEv, int esz, int imc, String itxt);
int FromPkg(int* thePkg, Char4 ty, int* ary);
int GetPkgInt(int* thePkg, Char4 ty);
String GetPkgTxt(int* thePkg);
int* NewDragSelec(Event theEv, int sz);
int* NewDragSelStr(Event theEv, int sz, String im);
int* NewDragColoStr(Event theEv, int sz, String im, int co);
int* NewDragImg(Event theEv, int sz, int* im);
int* NewClip(Event theEv, int sz);
int* DroPastEvent(Event theEv);
void PkgAdd(int* thePkg, Char4 ty, int* ary);
void PkgItem(int* thePkg, Char4 ty, int val);
void PkgText(int* thePkg, String txt);
void PkgDone(int* thePkg);
bool IsRecording();
void PkgFile(int* id, File fi);
void DragFrom(int* id, Point loc);
void Record(Char4 ms, int inf, int loc, int dat);
void RecoWin(Char4 ms, int inf, Widgit loc, Window win);
void RecoTxtWin(Char4 ms, String txt, Widgit loc, Window win);
void RecoFile(Char4 ms, File fi, int loc, Window win);
void RecoText(Char4 ms, String txt, int loc, Window win);
File GetPkgFi(int* thePkg);
Point PkgLoc(int* thePkg, bool drp);
int PkgInfo(int* thePkg);
void SetMenuItem(Char4 mID, Char4 msg, String mtx, char cky, int pos);
void CheckMenu(Char4 mID, int pos, bool ckd);
void MenuDisable(Char4 mID, int pos, bool ckd);
Window NewMenuBar(String tx);
int* Imag4Ints(int* theIm);
int Next2pow(int valu);
int Log2(int theNum);
int HashTo(int tbsz, int valu);
int Sign(int nn);
bool InRange(int theVal, int LoBound, int HiBound);
int NullTextFill(int wrd, char fil);
void InstallUserFont(Char4 whom, IntArray fnt, int inx, IntArray krn);
String GetProgName(Process whom);
Process ProcByName(String stx);
int MaxProcIx(); // actually the number of Processes, including Sys!
Char4 GetIxProc(int ix); // 0 is self

void GetEvent(Event evp); // formerly segmented..
void SendEvent(Event evp, Process toPro);
int SendMsg(Char4 EvNo, int eInfo, int EvLoc, int EvDat, Process toPro);
int SendFiMsg(Char4 EvNo, File fi, int EvLoc, int EvDat, Process toPro);
int PopupMenu(Point pt, String stm, int pre);
void Delay(int ms);
void Quit();
void SplashVersion(String msg);
void DebugIntArray(String pLine, IntArray ary);

#define GetWin4Mbar(win) win

#if 0
int MakeEv_Str(String theStr);
#endif

// #endif // MOS_System

////////////////////////////////////////////////////////////////////////
void DebugResCache(bool flush);
void DebugIntArray(String pLine, int* ary);

#endif // MOS_SysNames

////////////////////////////////////////////////////////////////////////
