// TurkFrame.h, Win32 threads version -- 2009 September 24
/// Win32 removed or #ifdef'd out -- 2009 October 14; DebugLog 10 Jan 15
/// (int)(void*) 09 Dec 15; FilePathDelim 2010 Jan 6; CR_LF 2010 Jan 14

#define Debug_Trace "DebugLog.txt" // enables DebugLogFile
#define _Crash_and_Burn_ true // div/0 in Array_Bounds_Fail and elsewhere
#define SigWait_Trace 0 // C++ doesn't like: true; =2 to div/0
#define Malloc_Log 0 // =3 logs malloc cache for leakage; =5 logs Res; =0 normal

#define Drag_Trace true
#define Draw_Trace false // traces image items in DrawImag
#define Sys_Trace 0 // turns message traffic on/off
#define Post_Trace 0 // logs Post_Ev (Send/Async) only
#define Panic_Log 0 // 1024; =2^n; >0 logs recent stuff (evts only)
#define Event_Log 2048 // =2^n; >1 logs recent Win32 evts

// #define PEEK_OFTEN _System_::System_Peek_Address(81)

#ifndef MOS_FrameWork  // _FrameWork_::xxx
#define MOS_FrameWork
#define FrameWork_Body

// ------------------------------------------------ Platform-specific stuff..
#define Debug_Trace_File "D:\\Thowe\\DebugLog.txt"
#define FilePathDelim '\\' // '\\' for Win32, '/' for unix, ':' for Mac
#define CR_LF "\r\n" // "\r" for Mac, "\n" for eunuchs, "\r\n" for Windoze
#define CRLF_LEN 2 // 1 for Mac/eunuchs, 2 for Windoze

#include "SysNamesC.h" // all the MOS framework prototypes

#define _BASE_ 0x10000

// This symbol needs to be defined before this header is #included:
//  char* ProgramName = "IttyBittyComputer"; // or whatever
//
// StartNewProg needs to be defined somewhere:
//  DWORD StartNewProg(void* whom); // whom is really a Process

#define _String_Log_ 1 // =256 if using MonitorStrings(), else =1

// bool My_Hold_Off = false, My_Test_Flag = false; // for testing D&D

// #define _w32RECT_ RECT
// #define _wPOINT_ POINT
// #define wPOINT POINT*
// #define w32RECT RECT*

// _wPOINT_ _1pint_, *w1pint = &_1pint_;
// _w32RECT_ _1rect_, *w1rect = &_1rect_, _2rect_, *w2rect = &_2rect_;

// inline w32RECT Win32Rect(RectAngle rx) { // trims off size,ref-count
//   int* rw = (int*)rx; ++rw; return (w32RECT)(++rw);}

// inline wPOINT Win32Point(RectAngle rx) { // trims off size,ref-count,rTop
//   int* rw = (int*)rx; ++rw; ++rw; return (wPOINT)(++rw);}

// #define PathSize (MAX_PATH*4)

// #define App_Icon 1001
// #define Ask_Text 129
// #define IDC_EdLn 1000
// #define IDC_AskLabel 1002

// char MsgBoxTitle[sizeof(ProgramName)+16];

////////////////////////////////////////////////////////////////////////

// Thread synchronization, implemented as a Win32 semaphore object

// #define NewSem32(sem,pre,snam) sem = CreateSemaphore(NULL,pre,0xFFFFF,snam)
// #define Signal32(sem) ReleaseSemaphore(sem,1,NULL)
// #define Wait32(sem) WaitForSingleObject(sem,INFINITE)

// #define Str_Signal(sem) Signal32(sem) // could also try it without these..
// #define Str_Wait(sem) Wait32(sem) // (insignificantly faster)

#define DebugLogFile _FrameWork_::DebugLogFileOpen // used as a boolean
#define SysDebugLogging() (_FrameWork_::DebugLogFileOpen)

namespace  _FrameWork_ { // for private library functions..

int Mouse_Buttons = 0; // captured from recent button messages; see ControlKey
int Modifier_Keys = 0; // modifiers: lock:0, shft:1, ctrl:2, cmd:3, opt:4

File DebugLogFileOpen = NULL;

void DebugTracer(char* str, int whom, int lino) { // logs process ID
  if (DebugLogFile) // only from Log_Sig/Log_Wai if SigWait_Tr=true
    SystemDebugLog(String(str)+whom+" "+FormInt(lino));}

// Sem32 MoveOK = NULL, ResFiLok = NULL, DebugLok = NULL, StrnLok = NULL,
  //   GooLok = NULL, EvenLok = NULL, PanicLok = NULL;
  // MoveOK protects my_malloc's Chunk_List
  // ResFiLok protects PIBfiles in _File_ constructor/destructor,
  //   also in System.h, Buf_Root and ResCache in resource manager
  // DebugLok protects DebugLogFile in SystemDebugLog
  // StrnLok protects String ref count in UpDownStr, also the_String_Log
  // GooLok protects Xfer_xx through DoGooey
  // EvenLok protects T2F_Process _event_list_ and n_Timers
  // PanicLok protects Panic_Log trace data (if enabled)

int SemRefHisto = 0; // SemRefLockt = 0, SemRefCount = 0, // used only here..

// void Log_Signal(Sem32& s, int whom, int lino) {} // only by System.h;
// void Log_Wait(Sem32& s, int whom, int lino) {} // only by System.h; whom: 1..7

} // (temply) end namespace  _FrameWork_

DWORD StartNewProg(void* whom); // forward decl'n for funct in main prog
DWORD Gooey_Thread_ID; // was: GooeyThreadID;

////////////////////////////////////////////////////////////////////////

// Standard type conversions and other built-ins [moved to SysNames.h]..

namespace  _FrameWork_ { // resume

/// Process MainProgram = NULL, Ready_List = NULL; // we need this soon
bool LogTextWrites = false; // initially disabled

int Logged_Events[Event_Log];
int Ev_Log_Ix = 0;

void FILL0(int* ary, int offs, int nwds) { // adjusts for array size+cnt words
  ++offs; while (nwds-- >0) ary[++offs] = 0;} // offs in words

void copy_bytes(char* frm, char* too, int nby) {
  while (nby-- >0) *too++ = *frm++;}
inline void BlockMove(int frm, int too, int nby) {
  copy_bytes((char*)frm,(char*)too,nby);}

void Fill_Block(int valu, int* addr, int nwds) { // skips over size,ref wrds
  addr++;
  *(++addr) = valu;
  char* thar = (char*)addr;
  _FrameWork_::copy_bytes(thar,thar+4,nwds*4-4);}

inline int PeekByte(int cPtr) {
  char* xptr = (char*)cPtr;
  return ((int)*xptr)&255;}
inline void PokeByte(int cPtr, int val) {
  char* xptr = (char*)cPtr;
  *xptr = (char)(val&255);}

// My Own Memory Allocation Manager (cuz Microsoft's bombs)..

#ifdef Debug_Trace
#define fronx (Malloc_Log+2) // links to prior w/odometer
//#define fronx 2
#else
#define fronx 0
#endif

#define Chunk_Tag 0x804D4D00 // "`MM#"
//        each size:  16  32  64 128 256 512 1K 2K 4K 8K 16 32 64 // max save
int Enuff_Chunx[] = {200,100,100,100,100,100,80,50,20,20,10,10,10};
#define Num_Chunks 12 // 13 chunk sizes
#define Min_Chunk 0x10 // 16 ints in smallest chunk
#define Max_Chunk (Min_Chunk<<Num_Chunks) // = 64K
int* Chunk_Linx[Num_Chunks+1]; // all alloc list heads, if Malloc_Log !=0
int* Chunk_List[Num_Chunks+1]; // free lists
int Chunk_Free[Num_Chunks+1]; // how many we have of that size free
int Chunk_Count[Num_Chunks+1]; // how many of that size in use
int Chunk_Nops[Num_Chunks+1]; // actual high idle
int Chunk_Tops[Num_Chunks+1]; // actual high usages
#define Chunk_Hist 512
#define Chunk_Mast (Chunk_Hist-1)
int Chunk_Acts[Chunk_Hist];  int Recent_Chunk = 0;  int Net_Chunx = 0;
  int Chunx_Odom = 0;  int Chunx_Stop = 0;
#define Chunk_Freeze 0x5100 // >0 stops Chunk_Act when Chunx_Odom=Freeze
#define Chunk_Bitz 32
int Chunk_Bits[Chunk_Bitz+4]; // each bit: 1MB in memory space
#define Chunk_Edge 1

void Init_MOMAM() {
  int ix;
  for (ix=0;ix<Num_Chunks;ix++) {
    Chunk_List[ix] = NULL;
    Chunk_Linx[ix] = NULL;
    Chunk_Count[ix] = 0;
    Chunk_Free[ix] = 0;
    Chunk_Nops[ix] = 0;
    Chunk_Tops[ix] = 0;}
  for (ix=0; ix <= Chunk_Bitz; ix++) Chunk_Bits[ix] = 0;
  for (ix=0;ix<Chunk_Hist;ix++) Chunk_Acts[ix] = 0;} //~Init_MOMAM

int* Record_Chunk(int* where) {
  int aBit = (int)(void*)where, here = aBit>>25;
  if (aBit<0) here = Chunk_Bitz+3; // shouldn't hap
  else if (here>Chunk_Bitz) here = Chunk_Bitz;
  aBit = 1 << ((aBit>>20)&31);
  Chunk_Bits[here] = Chunk_Bits[here] | aBit;
  return where;} //~Record_Chunk

int* my_malloc(int lnx, int whom) { // _FrameWork_::my_malloc()
  int abit = Min_Chunk, chn = 0, size = ((lnx+11)>>2)+fronx;
  int* thePtr = NULL;            // size is fronx+2 ints bigger than req'd
  if (lnx==0) return NULL;
  Net_Chunx++;
  try {
    if (size >= Max_Chunk) {
      thePtr = (int*)malloc(size<<2);
      if ((Chunx_Odom<Chunk_Freeze) || (Chunk_Freeze==0)) {
        Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = size+0x51000000;
        Chunk_Acts[(Recent_Chunk++)&Chunk_Mast]
            = ((int)(void*)thePtr)&0xFFFFFFC | 0xF0000000;              // F..0
        if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
        Chunk_Acts[Recent_Chunk&Chunk_Mast] = -1;}
      if (Malloc_Log) {
        *thePtr++ = 0;
        *thePtr++ = whom;
        *thePtr++ = ++Chunx_Odom;
        if (Malloc_Log==5) {*thePtr++ = 0; *thePtr++ = 0;}}
      if (fronx) {
        Fill_Block(0xDEADBEEF,--thePtr,size-2); // fills all but link and fence
        thePtr[size] = 0xBAD1DEA5; // sets the no-touchum fence
        thePtr++;}
      *thePtr++ = Chunk_Tag+Num_Chunks;
      if (fronx) {
        *thePtr++ = size;
        *thePtr++ = 0xBAD1DEA5;}
      return Record_Chunk(thePtr);}
    while (abit<size) {
      abit = abit<<1;
      chn++;}
    if (chn <= Num_Chunks) {
      // Wait32(MoveOK);
      Chunk_Count[chn]++;
      Chunk_Tops[chn] = MAX(Chunk_Tops[chn],Chunk_Count[chn]);
      thePtr = Chunk_List[chn]; // non-raw pointer
      if (Chunk_Free[chn]>0 && thePtr != NULL) {
        if ((Chunx_Odom<Chunk_Freeze) || (Chunk_Freeze==0))
            if (chn >= Chunk_Edge) {
          Chunk_Acts[(Recent_Chunk++)&Chunk_Mast]
              = ((int)(void*)thePtr)&0xFFFFFFC | (chn<<28) | 1;          // n..1
          if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
          Chunk_Acts[Recent_Chunk&Chunk_Mast] = -1;}
        Chunk_List[chn] = (int*)(*thePtr);
        Chunk_Free[chn]--;
        // Signal32(MoveOK);
        if (Malloc_Log) {
          if (Malloc_Log==5) {thePtr--;  thePtr--;}
          thePtr--;  thePtr--;
          *thePtr++ = whom;
          *thePtr++ = ++Chunx_Odom;
          if (Malloc_Log==5) {*thePtr++ = 0; *thePtr++ = 0;}}}
      else {
        lnx = Recent_Chunk++;
        Recent_Chunk++;
        // Signal32(MoveOK);
        thePtr = Record_Chunk((int*)malloc(abit<<2));
        if ((Chunx_Odom<Chunk_Freeze) || (Chunk_Freeze==0)) {
          Chunk_Acts[(lnx++)&Chunk_Mast]
              = ((int)(void*)thePtr)&0xFFFFFFC | (chn<<28);              // n..0
          if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
          Chunk_Acts[lnx&Chunk_Mast] = -1;}
        if (Malloc_Log) {
          *thePtr = (int)(void*)Chunk_Linx[chn]; // other thr cd race, so what?
          Chunk_Linx[chn] = thePtr++;
          *thePtr++ = whom;
          *thePtr++ = ++Chunx_Odom;
          if (Malloc_Log==5) {*thePtr++ = 0; *thePtr++ = 0;}}}
      if (fronx) {
        Fill_Block(0,--thePtr,abit-2); // unused part of block
        Fill_Block(0xDEADBEEF,thePtr,size-2); // bogus but recognizable values
        thePtr[size] = 0xBAD1DEA5; // sets the no-touchum fence
        thePtr[abit] = 0xBAD1DEA5; // another fence at physical end
        thePtr++;}
      *thePtr++ = Chunk_Tag+chn;
      if (fronx) {
        *thePtr++ = size;
        *thePtr++ = 0xBAD1DEA5;}}
    else if (_Crash_and_Burn_) abit = abit/(chn>>6); // div/0
      else throw abit;}
    catch (...) {
      if (_Crash_and_Burn_) abit = abit/(chn>>6); // div/0: I still want to see
      thePtr = NULL;}
  return thePtr;} //~my_malloc

boolean Die__Politely(int why, int* ary, int whom) { // get out & quit, if log..
  int rept = Chunx_Stop;
  if (Malloc_Log != 5) return false;
  Chunx_Stop = why;
  Chunk_Acts[(Recent_Chunk++)&Chunk_Mast]
      = ((int)(void*)ary)&0xFFFFFFC | 0xF0000000 | why;              // F..1/2/3
  if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
  Chunk_Acts[Recent_Chunk&Chunk_Mast] = -1;
  Chunx_Odom++;
///   if (rept==0) AsyncMsg("FAIL",why,whom,(int)ary,MainProgram);
  return true;}

void my_free(int* ary, int whom) { // does not look at user data space
  int tag = (int)(void*)(ary--), az = tag-tag;
  if ((tag&-32)==0) return; // huh??
  if ((tag&3) !=0) return; // huh??
  Net_Chunx--;
  if (fronx) {
    tag = *ary; // front fence, at [-1]
    *ary-- = whom; // record deletor there
    ary--; // now at actual block front
    if (tag != 0xBAD1DEA5) { // validate front fence
      if (Die__Politely(1,ary,whom)) return;                             // F..1
        else az = tag/az;} // div/0
    tag = ary[1]; // allocation size
    if (ary[tag-1] != 0xBAD1DEA5) { // back fence
      if (Die__Politely(2,ary,whom)) return;                             // F..2
        else az = tag/az;}} // div/0
  tag = (*ary)^Chunk_Tag; // if unchanged, this is chunk # in low byte
  whom = whom+0x87000000; // file ID,line#
  if ((tag&-256)==0) {
    if (tag >= Num_Chunks) {
      if (Malloc_Log) {
        if (Malloc_Log==5) {ary--;  ary--;}
        ary--;  ary--;  ary--;}
      if ((Chunx_Odom<Chunk_Freeze) || (Chunk_Freeze==0)) {
        Chunk_Acts[(Recent_Chunk++)&Chunk_Mast]
            = ((int)(void*)ary)&0xFFFFFFC | 0xF0000003;                  // F..3
        if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
        Chunk_Acts[Recent_Chunk&Chunk_Mast] = -1;
        Chunx_Odom++;}
      free(ary);
      return;}
    if (fronx) if (ary[(Min_Chunk<<tag)-1] != 0xBAD1DEA5) az = tag/az;
    // Wait32(MoveOK);
    Chunk_Count[tag]--;
    if (Chunk_Free[tag]<Enuff_Chunx[tag]) {
      ary[2] = whom; // file ID,line#
      *ary = (int)(void*)Chunk_List[tag];
      Chunk_List[tag] = ary;
      if (Malloc_Log) {
        if (Malloc_Log==5) {ary--;  ary--;}
        ary--;  ary--;  ary--;}
      if ((Chunx_Odom<Chunk_Freeze) || (Chunk_Freeze==0)) if (tag>=Chunk_Edge) {
        Chunk_Acts[(Recent_Chunk++)&Chunk_Mast]
            = ((int)(void*)ary)&0xFFFFFFC | (tag<<28) | 2;               // n..2
        if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
        Chunk_Acts[Recent_Chunk&Chunk_Mast] = -1;
        Chunx_Odom++;}
      Chunk_Free[tag]++;
      Chunk_Nops[tag] = MAX(Chunk_Nops[tag],Chunk_Free[tag]);
      // Signal32(MoveOK);
      }
    else {
      if ((Chunx_Odom<Chunk_Freeze) || (Chunk_Freeze==0)) {
        Chunk_Acts[(Recent_Chunk++)&Chunk_Mast]
            = ((int)(void*)ary)&0xFFFFFFC | (tag<<28) | 3;               // n..3
        if (whom !=0) Chunk_Acts[(Recent_Chunk++)&Chunk_Mast] = whom;
        Chunk_Acts[Recent_Chunk&Chunk_Mast] = -1;
        Chunx_Odom++;}
      // Signal32(MoveOK);
      if (Malloc_Log) return; // shouldn't happen in test
      free(ary);}}
  else if (_Crash_and_Burn_) az = tag/az;} // div/0 //~my_free

String KorN(int n) {
  if (n<1024) return String(n)+String(":");
  return String(n>>10)+String("K:");} //~KorN

void Log_MOMAM() { // [only if lock: shft+1, ctrl+2, menu+4]
  int nx = Num_Chunks, ix; // = (Modifier_Keys>>1)&3; // =0??
  String aLine; // = String("-- ")+FormInt(ix)+String(" ");
  int* here; // = Chunk_Linx[1];
  int ChunkActs[Chunk_Hist];
  for (ix=0;ix<Chunk_Hist;ix++)
    ChunkActs[ix] = Chunk_Acts[(Recent_Chunk-Chunk_Hist+ix)&Chunk_Mast];
  if (Net_Chunx>666) nx = 1;
  for (nx=nx;nx>=0;nx--) {
    aLine = FormHexNum(nx,1)+String("+");
    here = Chunk_Linx[nx];
    while (here) {
      aLine = aLine+FormHexNum((int)(void*)here,8)+String(":");
      for (ix=1;ix<16;ix++) aLine = aLine+String(" ")+FormInt(here[ix]);
      SystemDebugLog(aLine);
      aLine = String("  ");
      here = (int*)(*here);} //~while
    if (Net_Chunx>666) break;} //~for
  aLine = String("++");
  for (ix=0;ix<Chunk_Hist;ix++) {
    aLine = aLine+String(" ")+FormHexNum(ChunkActs[ix],8);
    if ((ix&7)<7) continue;
    SystemDebugLog(aLine);
    aLine = String("  ");}} //~for //~Log_MOMAM

void Exit_MOMAM() {
  int ix, zx = 0, abit = Min_Chunk;
  String aLine = "*MOMAM +";
  aLine = aLine+String(Net_Chunx);
  for (ix=0;ix<Num_Chunks;ix++) {
    if (Chunk_Tops[ix]+Chunk_Nops[ix]>0)
      aLine = aLine+String(" ")+KorN(abit)+String(Chunk_Tops[ix])
          + String("/")+String(Chunk_Nops[ix]);
    abit = abit<<1;}
  SystemDebugLog(aLine);
  abit = Min_Chunk;
  aLine = "    ";
  for (ix=0;ix<Num_Chunks;ix++) {
    if (Chunk_Count[ix]+Chunk_Free[ix]>0)
      aLine = aLine+String(" ")+KorN(abit)+String(Chunk_Count[ix])
          + String("/")+String(Chunk_Free[ix]);
    abit = abit<<1;}
  SystemDebugLog(aLine);
  abit = 0;
  for (ix=Chunk_Bitz+3;ix>=0;ix--) {
    if (Chunk_Bits[ix] == 0) continue;
    if (abit==0) abit = ix|3;
    zx = ix&-4;} //~for
  aLine = " ";
  for (ix=abit;ix>=zx;ix--) {
    aLine = aLine+" "+FormHexNum(ix<<5,3)+"M: "+FormHexNum(Chunk_Bits[ix],8);
    if ((ix&3) !=0) continue;
    SystemDebugLog(aLine);
    aLine = " ";} //~for
  if (Malloc_Log) Log_MOMAM();} //~Exit_MOMAM

void Log_Res_Info(int rez, int rty, int FiNo) {
  int* aptr = (int*)(rez-16);
  if (Malloc_Log<5) return;
  *aptr-- = FiNo;
  *aptr = rty;}

#undef fronx
#undef Chunk_Tag
#undef Num_Chunks
#undef Min_Chunk
#undef Max_Chunk

#if _String_Log_>1 // enable string log for unit tests..
void Log_Str_Cash(int whom, bool doWhat);
#define _Str_Logit_(whom) Log_Str_Cash(whom,true)
#define _Str_unLog_(whom) Log_Str_Cash(whom,false)
#else
#define _Str_Logit_(whom)
#define _Str_unLog_(whom)
#endif

int _Strings_Count_ = -1; // initially disabled
int the_String_Log[_String_Log_];

 } // (temply) end namespace  _FrameWork_

// array/pointer management routines..

int* my_int_ary(int lnx, int whom) { // int* new_int_ary(int lnx) {
  int* ptr = (int*)_FrameWork_::my_malloc((lnx+2)*sizeof(int),whom);
  if (ptr==NULL) return NULL;
  _FrameWork_::FILL0(ptr,0,lnx);
  *ptr++ = lnx;
  *ptr-- = 1; // always precounted
  return ptr;}

void set_ary_size(void* aptr, int siz) { // siz<0 for static alloc (uncounted)
  int isiz = ABS(siz); // data size in int's (not including size,ref-count)
  int* ptr = (int*)aptr;
  _FrameWork_::FILL0(ptr,0,isiz);
  *ptr++ = isiz;
  if (siz<0) *ptr = -256;
    else *ptr = 1;}

boolean Valid_Ptr_Verify(void* ptr) { // check for memory corruption often..
#ifdef PEEK_OFTEN
  int* aptr = (int*)PEEK_OFTEN;
  if (aptr) if (*(--aptr) != 0xBAD1DEA5) if (_FrameWork_::Chunx_Stop==0)
    if (!_FrameWork_::Die__Politely(3,(int*)(++aptr),_BASE_+__LINE__))   // F..3
      aptr = NULL;
  aptr = (int*)ptr;
#else
  int* aptr = (int*)ptr;
#endif
  --aptr;
  if (*aptr-- == 0xBAD1DEA5) {
    if (aptr[(*aptr)-2] == 0xBAD1DEA5) return false;}
  else if (*aptr-- == 0xBAD1DEA5) // Text_Ary_Str ptr is offset +1..
    if (aptr[(*aptr)-2] == 0xBAD1DEA5) return false;
  if (!_FrameWork_::Die__Politely(3,(int*)ptr,_BASE_+__LINE__))          // F..3
    aptr = NULL;
  return true;} // retn true if failed

#if Malloc_Log == 5
#define Verify_Valid_Ptr(ptr) Valid_Ptr_Verify(ptr)
#else
#define Verify_Valid_Ptr(ptr)
#endif

void Stop_n_Look(int* ptr) { // can set breakpoint here, cuz shouldn't happen..
  ptr--;}

int* up__ptr(void* aptr) {
  int* ptr = (int*)aptr;
  if ((((int)(void*)ptr)&-32) !=0) if (*(++ptr) >= 0) { // not if stack alloc
    Verify_Valid_Ptr(aptr);
    if ((*ptr)==12) Stop_n_Look(ptr);
    (*ptr)++;}
  return (int*)aptr;}

int* dn__ptr(void* aptr, int whom) { // normally called as void, except in expn
  int* ptr = (int*)aptr;
  if ((((int)(void*)ptr)&-32)==0) return (int*)0; // huh?
  if (*(++ptr)<0) return (int*)aptr; // stack allocated: do nothing
  Verify_Valid_Ptr(aptr);
  if (*ptr) (*ptr)--; // could have 2 threads looking at same ptr if res,
  if ((*ptr)==0)             // but cache holds a copy, so never hits 0
    _FrameWork_::my_free(--ptr,whom);
  return (int*)aptr;}

////////////////////////////////////////////////////////////////////////

// 4-character-as-int (Char4) class, intrinsic to Turk/2..

// class String; // forward ref in Char4

Char4::Char4() {cccc = 0;}
Char4::Char4(int x) {cccc = x;}
bool Char4::operator<(Char4 st) {return (bool)(this->cccc < st.cccc);}
bool Char4::operator>(Char4 st) {return (bool)(this->cccc > st.cccc);}
bool Char4::operator<=(Char4 st) {return (bool)(this->cccc <= st.cccc);}
bool Char4::operator>=(Char4 st) {return (bool)(this->cccc >= st.cccc);}
bool Char4::operator==(Char4 st) {return (bool)(this->cccc == st.cccc);}
bool Char4::operator!=(Char4 st) {return (bool)(this->cccc != st.cccc);}
Char4::Char4(const char* st) {
  int ix = 0, ch;
  cccc = 0;
  if (st) while (ix<4) {
    ch = ((int)st[ix++])&255;
    if (ch<32) ch = ch+32;
    cccc = (cccc<<8)+ch;}}
Char4 Char4::operator=(const int x) {
  *this = Char4(x);
  return *this;}
Char4 Char4::operator=(const char* st) {
  *this = Char4(st);
  return *this;}
bool Char4::operator<(const char* st) {
  Char4 x(st);
  return (bool)(*this < x);}
bool Char4::operator>(const char* st) {
  Char4 x(st);
  return (bool)(*this > x);}
bool Char4::operator<=(const char* st) {
  Char4 x(st);
  return (bool)(*this <= x);}
bool Char4::operator>=(const char* st) {
  Char4 x(st);
  return (bool)(*this >= x);}
bool Char4::operator==(const char* st) {
  Char4 x(st);
  return (bool)(*this == x);}
bool Char4::operator!=(const char* st) {
  Char4 x(st);
  return (bool)(*this != x);}
Char4 CHR4(int x) {return Char4(x);}
int ORD(Char4 x) {return x.cccc;}

// Char4 Null4 = CHR4(0);
Char4 NoName = "    ";

Char4 Up4Char(Char4 Num4) { // increment Num4 decimally
  int pnam = ORD(Num4), digit = pnam&127;
  if (digit <= ORD('0')) return CHR4((pnam&-256)+ORD('1'));
  if (digit>ORD('9')) return CHR4((pnam&-256)+ORD('1'));
  if (digit<ORD('9')) return CHR4(pnam+1);
  digit = (pnam>>8)&127;
  if (digit <= ORD('0')) return CHR4((pnam&~0xFFFF)|ORD("  10")&0xFFFF);
  if (digit>ORD('9')) return CHR4((pnam&~0xFFFF)|ORD("  10")&0xFFFF);
  if (digit<ORD('9')) return CHR4(pnam+247);
  digit = (pnam>>16)&127;
  if (digit <= ORD('0')) return CHR4((pnam&-0x1000000)|ORD(" 100")&0xFFFFFF);
  if (digit>ORD('9')) return CHR4((pnam&-0x1000000)|ORD(" 100")&0xFFFFFF);
  if (digit<ORD('9')) return CHR4(pnam+65536-0x909);
  return CHR4((pnam&-0x1000000)+(ORD("1000")&0x1FFFFFF));}

boolean Is4chars(int val) {
  if ((val&0x80808080) !=0) return false; // disallows option chars
  if (((val+0x01010101)&0x80808080) !=0) return false; // disallows del
  return (((val+0x60606060)&0x80808080) == 0x80808080);} // disallow ctls

////////////////////////////////////////////////////////////////////////

// Global declarations used in WinMain/InitializeAl..

#define Cast_Proc(p) p
#define Proc_Cast(p) p

namespace  _FrameWork_ { // resume name space protection..

Char4 DocX4 = "DocX", Imag4 = "Imag", PrgB4 = "PrgB", TxtD4 = "TxtD";
Char4 Next_ProcID = "@000", Typ4 = "Type";

// Process MainProgram = NULL, Ready_List = NULL; // was: AllProgP
/// HINSTANCE Main_Context = NULL; // context passed to main from Win32
/// HWND GooeyWin = NULL, HasSplash = NULL; // something to send messages to
/// HWND FrontedWin = NULL; // force this to the front if not NULL
/// HWND theFrontWin = NULL; // this win is on top (sometimes we care)
/// HBRUSH StockWhiteBrush;  HBRUSH StockBlackPen;
/// HBRUSH PreProgBrush;     HBRUSH ProgressBrush;
/// HCURSOR HourGlass = NULL; HCURSOR OldCursor = NULL; // used in win redraw
/// HCURSOR CrossHair = NULL; HCURSOR Ibeam = NULL; HCURSOR PlainArrow = NULL;
/// HCURSOR EastWest = NULL; HCURSOR NorthSouth = NULL;
/// int my_Cursor = 0, Tenth_Seconds = 0; // used to blink caret
/// unsigned char eTrsCan[268], FullCan[268]; 
/// boolean Drag_Is_Busy = false;

/// struct {
///   BITMAPINFOHEADER BitMapStuff;
///   int ColorTbl[216];} MyBitMap; // RGBQUAD
/// BITMAPINFO* theBitMap = (BITMAPINFO*)(&MyBitMap);

int ScreenTall, ScreenWide; // used in BitMapStuff and for pixelating
unsigned char* theScreen = NULL; // 8 bytes of IntArray o'hed at front

/// WNDCLASS Wind_type;

int FlushClix = 0; // >0 to flush spurious clicks from file dlg
Point ClikPt, ScroRefLoc; // used to reconstruct over-range scroll thumb
Point Mouse_Locn = Nowhere; // captured from recent WM_MOUSEMOVE
bool Fresh_Mods = false; // true if might be stale
bool New_MsgBx = false; // true when open MsgBx, to set FrontedWin
bool Menu_Is_Open = false; // to override mouse in win cursor display
Char4 Next_Win_ID = "#000";
int Window_Count = 0; // quit when it reaches 0 again // Popup_Result = 0,

// Some timers..
int Tix_Now = 0, Tix_100ms = 0; // <0 while splash win is visible
int n_Timers = 0; // number of processes in Delay
int Zap_Time = 0; // zap drag when decrements to 0 (ref'd but unused)

// early forward declarations..

void Down_Win_Cnt(void);
String FormTimeMS(void); // in FrameWork.h

Window PIB_wins = NULL, Free_Wins = NULL; // master window list, closed spares
Window Progress_o = NULL; // cached progress bar win, cuz deleting it bombs
Window Pacify_wins = NULL; // window(s) being redrawn
Window Cursor_Win = NULL; // last known window showing cursor

// #define Menu_LineHeight 20
// #define Menu_Comm_base 3333
// #define Max_Menus 256
// struct Menu_Com_ {Process whose; Char4 say;};
// Char4 Menu_Comms[Max_Menus];
// int Num_Menus = 0;
// #define BaseM_LineHgt 17 // ad hoc as observed, to be adjusted (NOT)
// int Menu_Hi_Chek = 2222, Menu_Preselect = -1, Menu_LineHeight = BaseM_LineHgt;

#if Panic_Log

int the_Panic[Panic_Log];
int Log_at = 0;

void Panic_See(int whom) {
  // Wait32(PanicLok);
  the_Panic[Log_at&(Panic_Log-1)] = whom;
  Log_at++;
  // Signal32(PanicLok);
  }

void Log_Panic(String aLine) {if (DebugLogFile) {
  int here;
  SystemDebugLog(aLine+" "+FormHexNum(_FrameWork_::SemRefHisto,8));
  // Wait32(PanicLok);
  here = MAX(Log_at-Panic_Log,0);
  while (here<Log_at) {
    if (((Log_at-here)&7)==0) aLine = "  ";
    aLine = aLine + " " + FormInt(the_Panic[here&(Panic_Log-1)]);
    here++;
    if (((Log_at-here)&7)==0) SystemDebugLog(aLine);}
  // Signal32(PanicLok);
  }} //~Log_Panic

#define See_Panic(x) Panic_See(x)
#else
void Log_Panic(String aLine) {}
#define See_Panic(x)
#endif // Panic_Log

////////////////////////////////////////////////////////////////////////

// ref-counted String class, intrinsic to Turk/2..

//  String is a 1-word reference to the string value, =0 is ""
//  String compare in T2 is not case-sensitive in the ASCII range

int FindText(char* xPtr, int xLen, char* aPtr, int aLen) { // find xPtr in aPtr
  int ix, offs = 0, xCh;
  while (aLen >= xLen) {
    xCh = 0;
    for (ix=0;ix<xLen;ix++) {
      xCh = ((int)xPtr[ix])&255;
      if (xCh==0) break; // end of lookfor, must be =
      xCh = (((int)Capitize(aPtr[offs+ix]))&255)-((int)Capitize((char)xCh));
      if (xCh !=0) break;} // not equal here
    if (xCh==0) return offs;
    offs++;
    aLen--;}
  return -1;} // ~FindText

int CompareText(char* xPtr, int xLen, const char* aPtr, int aLen) { // xPtr:aPtr
  int ix, offs = MIN(xLen,aLen), xCh = 0;
  for (ix=0;ix<offs;ix++) {
    xCh = ((int)aPtr[ix])&255;
    if (xCh==0) return ((int)xPtr[ix])&255;
    xCh = (((int)Capitize(xPtr[ix]))&255)-((int)Capitize((char)xCh));
    if (xCh !=0) return xCh;} // not equal
  if (xLen>offs) return ((int)xPtr[ix])&255;
  if (aLen>offs) return -(((int)aPtr[ix])&255);
  return 0;} // ~CompareText

char* AllocStr(int len) {
  int nby = (len+16)&-4;
  int* ipt = my_malloc(nby,0);
  if (ipt==NULL) return NULL;
  *ipt = len; // string len
  ipt[1] = -1; // temp ref count
  _Str_Logit_((int)(void*)ipt); // ref-count in wrong place
  nby = (nby>>2)-3;
  *(++ipt) = nby; // int array size
  *(++ipt) = 1; // string ref count
  *(++ipt) = 0; // initialize null
  ipt[--nby] = 0;
  if (nby) ipt[--nby] = 0;
  return (char*)ipt;} //~AllocStr

char* NewStrText(const char* st) {
  char* sptr = NULL;
  if (st) if (*st) {
    sptr = AllocStr(strlen(st));
    if (sptr) strcpy(sptr,st);}
  return sptr;} //~NewStrText

char* UpDownStr(char* sptr, int upby) {
  int* ipt = (int*)sptr;
  if (((int)(void*)ipt)&-32) {
    ipt--;
    // Wait32(StrnLok);
    ipt[0] = ipt[0]+upby;
    // Signal32(StrnLok);
    if (*(ipt--)>0) return sptr; // no other threads have a ref if =0
    upby = *(ipt--); // int length, now "ref-count"
    _Str_unLog_((int)(void*)ipt);
    // ipt[0] = ++upby; // corrected int length (nobody looks)
    my_free(ipt,_BASE_+__LINE__);}
  return NULL;} //~UpDownStr

void SetActualStrLen(char* sptr) {
  int* ipt = (int*)sptr;
  if (((int)(void*)ipt)&-32) {
    ipt--;  ipt--;  ipt--;
    ipt[0] = strlen(sptr);}} //~SetActualStrLen

 } // (temporarily) end namespace  _FrameWork_

String::String() {
  stp = NULL;}
String::String(const char* st) {
  stp = _FrameWork_::NewStrText(st);}
String::String(const char* st, int len) {
  stp = _FrameWork_::AllocStr(len);
  if (stp==NULL) return;
  if (st) {
    while (len-- >0) stp[len] = st[len];
    _FrameWork_::SetActualStrLen(stp);}}
String::String(const String& st) {
  stp = _FrameWork_::UpDownStr(st.stp,1);}
String::String(int i) {
  int dg = -1, ix = 0;
  char cxi[16], cxs[16];
  char* cp = (char*)(14+cxi);
  if (i<0) {
    cxs[ix++] = '-';
    i = -i;
    if (i<0) {
      cxs[ix++] = '2';
      i = i-2000000000;}
    dg = 0;}
  cxs[ix] = '\0';
  *cp = '\0';
  while (i>0) {
    dg = i%10;
    i = (i-dg)/10;
    *(--cp) = (char)(dg+48);}
  if (dg<0) *(--cp) = '0';
  strcat(cxs,cp);
  stp = _FrameWork_::NewStrText(cxs);}
String::String(char c) {
  char cxc[2];
  cxc[0] = c;
  cxc[1] = '\0';
  stp = _FrameWork_::NewStrText(cxc);}
String::String(Char4 x) {
  int ix = ORD(x);
  char cxc[5];
  cxc[0] = (char)MAX((ix>>24)&127,32);
  cxc[1] = (char)MAX((ix>>16)&127,32);
  cxc[2] = (char)MAX((ix>>8)&127,32);
  cxc[3] = (char)MAX(ix&127,32);
  cxc[4] = '\0';
  stp = _FrameWork_::NewStrText(cxc);}
String::String(bool b) {
  char* cp;
  if (b) cp = "true";
    else cp = "false";
  stp = _FrameWork_::NewStrText(cp);}
String String::operator=(const char* st) {
  _FrameWork_::UpDownStr(stp,-1);
  stp = _FrameWork_::NewStrText(st);
  return *this;}
String String::operator=(String st) {
  if (stp==st.stp) return *this;
  _FrameWork_::UpDownStr(stp,-1);
  stp = _FrameWork_::UpDownStr(st.stp,1);
  return *this;}
String String::operator=(char c) {
  char cxc[2];
  cxc[0] = c;
  cxc[1] = '\0';
  _FrameWork_::UpDownStr(stp,-1);
  stp = _FrameWork_::NewStrText(cxc);
  return *this;}
String String::operator=(int i) {
  String st = i;
  _FrameWork_::UpDownStr(stp,-1);
  stp = _FrameWork_::UpDownStr(st.stp,1);
  return *this;}
String String::operator+(const char* st) {
  int sz = 0, len = this->length_();
  String res;
  if (st) sz = strlen(st);
  if (sz==0) return *this;
  if (len==0) {
    res.stp = _FrameWork_::NewStrText(st);
    return res;}
  sz = this->length_()+sz;
  if (sz==0) return Null_Str;
  res.stp = _FrameWork_::AllocStr(sz);
  if (res.stp==NULL) return *this;
  strcpy(res.stp,this->stp);
  strcat(res.stp,st);
  return res;}
String String::operator+(String st) {
  int sz = st.length_(), len = this->length_();
  String res;
  if (sz==0) return *this;
  if (st.stp==NULL) return *this; // shoulda: sz=0
  if (len==0) return st;
  sz = sz+len;
  res.stp = _FrameWork_::AllocStr(sz);
  strcpy(res.stp,this->stp);
  strcat(res.stp,st.stp);
  return res;}
String String::operator+(int i) {
  String res, st = i;
  int sz = this->length_();
  if (sz==0) return st;
  res.stp = _FrameWork_::AllocStr(st.length_()+sz);
  if (res.stp) {
    strcpy(res.stp,this->stp);
    if (st.stp) strcat(res.stp,st.stp);}
  return res;}
String::~String() { // we have a problem with near-null pointers..
  stp = _FrameWork_::UpDownStr(stp,-1);}

void String::valid_() {_FrameWork_::SetActualStrLen(stp);}
int String::length_() {
  int* ipt = (int*)stp;
  if (((int)(void*)ipt)&-32) {
    ipt--;  ipt--;  ipt--;
    return *ipt;}
  return 0;}
char* String::text_() {
  if (stp==NULL) return "";
  return stp;}
int String::cmpr_(const char* st) {
  int len = this->length_();
  if (len==0) {
    if (st==NULL) return 0;
    if (*st == '\0') return 0;
    return -1;}
  if (st==NULL) return 1;
  if (*st == '\0') return 1;
  return _FrameWork_::CompareText(stp,len,st,~HiBit);}
int String::cmpr_(String st) {
  int len = this->length_(), sz = st.length_();
  if (len==0) {
    if (sz==0) return 0;
    return -1;}
  if (sz==0) return 1;
  return _FrameWork_::CompareText(this->stp,len,st.stp,sz);}

bool String::operator<(const char* st) {return (bool)(this->cmpr_(st) < 0);}
bool String::operator>(const char* st) {return (bool)(this->cmpr_(st) > 0);}
bool String::operator<=(const char* st) {return (bool)(this->cmpr_(st) <= 0);}
bool String::operator>=(const char* st) {return (bool)(this->cmpr_(st) >= 0);}
bool String::operator==(const char* st) {return (bool)(this->cmpr_(st) == 0);}
bool String::operator!=(const char* st) {return (bool)(this->cmpr_(st) != 0);}
bool String::operator<(String st) {return (bool)(this->cmpr_(st) < 0);}
bool String::operator>(String st) {return (bool)(this->cmpr_(st) > 0);}
bool String::operator<=(String st) {return (bool)(this->cmpr_(st) <= 0);}
bool String::operator>=(String st) {return (bool)(this->cmpr_(st) >= 0);}
bool String::operator==(String st) {return (bool)(this->cmpr_(st) == 0);}
bool String::operator!=(String st) {return (bool)(this->cmpr_(st) != 0);}

String GetPstr(int* ary) { // P-string operators: no memory allocation..
  if (ary==NULL) return Null_Str;
  ary++; // PC is Little-Endian, but no matter..
  char* cptr = (char*)(++ary);
  int stl = ((int)(*cptr++))&255;
  return String(cptr,stl);} // not a cast, so OK
void AppPstr(int* ary, const char* st) {
  if (ary==NULL) return;
  int alx, aln = (*ary++)*4-2;
  if ((*ary)>0) (*ary)--; // should be static, but just in case
  int asl = (*(++ary))&255; // Little-Endian
  char* cptr = (char*)ary;
  if (st==NULL) return;
  if (*st == '\0') return;
  alx = asl+strlen(st);
  if (alx>aln) return;
  if (alx>254) return;
  cptr[0] = (char)alx;
  cptr[++asl] = '\0';
  strcat(cptr,st);}
void AppPstr(int* ary, String st) {
  if (st.length_()>0) AppPstr(ary,st.text_());}
void AppChar(int* ary, char chx) {
  if (ary==NULL) return;
  int aln = (*ary++)*4-2;
  if ((*ary)>0) (*ary)--;
  int asl = ((*(++ary))&255)+1; // Little-Endian
  char* cptr = (char*)ary;
  if (asl>aln) return;
  if (asl>254) return;
  cptr[0] = (char)asl;
  cptr[asl++] = chx;
  cptr[asl] = '\0';}

// char* TextOf(String st) {return st.text_();} // unused

// String Manager Operations..
// int LENGTH(String st) {return st.length_();} // in SysNames.h

Char4 Chr4Str(String st) {
  if (st.length_() == 0) return CHR4(0);
  if (st.length_() < 4) st = st+String("    ");
  return Char4(st.text_());}

char CharAt(int i, String st) {
  char* here = st.text_();
  if (i<0) return '\0';
  if (st.length_() <= i) return '\0';
  return here[i];}

String Substring(int offs, int len, String st) {
  String nu;
  if (offs<0) return Null_Str;
  len = MIN(st.length_()-offs,len);
  if (len<=0) return Null_Str;
  nu = String((char*)(st.text_()+offs),len);
  return nu;}

String TxtBlok2Str(int offs, int nch, int* ary) { // nch<0 omits copy
  // PRE: offs >=0, nch >=0, offs+nch <= ary.len  // nch=0 takes all
  if (ary==NULL) return Null_Str;
  if (offs<0) offs = 0;
  char* chad = (char*)(((char*)ary)+offs+sizeof(int)*2);
  offs = (*ary)*sizeof(int)-offs;
  if (offs>0) {
    if (nch<0) { // don't copy (nor even look at) array contents..
      offs = MIN(offs,-nch);
      chad = NULL;}
    else {
      offs = MIN((int)strlen(chad),offs);
      if (nch>0) offs = MIN(offs,nch);}}
  if (offs <= 0) {
    if (ary[1]>0) ary[1]--;
    return Null_Str;}
  String res(chad,offs);
  if (ary[1]>0) ary[1]--;
  if (nch >= 0) return res;
  if (LENGTH(res)==0) return Null_Str;
  return res;}

void Str2TxtBlok(String st, int offs, int mxln, int* ary) {
  // PRE: offs >=0, offs+MIN(st.len,mxln-1) < ary.len (both checked)
  if (ary==NULL) return;
  char* chad = (char*)(((char*)ary)+offs+sizeof(int)*2);
  int nby = (*ary)*sizeof(int)-offs;
  if (offs >= 0) if (nby>0) while (true) { // funnel all exits thru down-ref..
    if (mxln>0) nby = MIN(nby,mxln); // mxln>0 truncates or fills to mxln
    if (st.length_() >= nby) {
      _FrameWork_::copy_bytes(st.text_(),chad,nby);
      break;}
    strcpy(chad,st.text_());
    if (mxln==0) break; // mxln<0 fills to end of array with nulls
    nby = nby-1-st.length_(); // if length is given, fill it out with nulls..
    chad = (char*)(chad+st.length_());
    if (nby>0) _FrameWork_::copy_bytes(chad,(char*)(chad+1),nby);
    break;}
  if (ary[1]>0) ary[1]--;}

int FindStTxBlk(String st, int offs, int mxln, int* ary) {
  // PRE: offs >=0, offs < MIN(ary.len,mxln)
  if (ary==NULL) return -1;
  int aoff = ABS(offs), nby = (*ary)*sizeof(int)-aoff;
  char* here = (char*)(((char*)ary)+aoff+sizeof(int)*2);
  if (mxln>0) nby = MIN(nby,mxln);
  mxln = st.length_();
  if (mxln==0) {
    if (ary[1]>0) ary[1]--;
    if (offs<0) if (nby>0) return -1;
    return 0;}
  if (nby <= 0) nby = -1;
  else if (offs >= 0) {
    nby = _FrameWork_::FindText(st.text_(),mxln,here,nby);
    if (nby<0) nby = -1;
      else nby = nby+aoff;}           // special case, must =
  else nby = -ABS(_FrameWork_::CompareText(st.text_(),mxln,here,nby));
  if (ary[1]>0) ary[1]--;
  return nby;}


int* Text_Ary_Str(String st) {
  if (st.length_()==0) return NULL;
  return (int*)up__ptr((int*)(st.text_()-8));}

// Turk/2 compiled code access..
#define C_string char*
#define EXTRACT_Cstr(s) s.text_()
#define MAKE_Cstr(s) String(s)
#define Literal_Cstr(s) s

////////////////////////////////////////////////////////////////////////

// Opaque File type, implemented as a pointer to a _File_ class..

namespace  _FrameWork_ { // resume

int FilnIx = 511;
bool IsValidFile(File aFile); // fwd, defined in FrameWork.t2..
File Open_In_Dir(String name, int opt, File dir);

File PIBfiles = NULL, PIBwDir = NULL;
File Using_ResFi = NULL; // used in System.h, but checked by Close2Ref

File Make_File(String nam, String pth, WinFile wfi, int flg) {
  File aFile;
  if (PIBfiles==NULL) if (flg != Directory) return NULL;
  try {aFile = new _File_(pth,wfi,flg);} catch (...) {aFile = NULL;}
  return aFile;}

File Next_File(File aFile) { // PRE: aFile is valid or null
  if (aFile==NULL) return PIBfiles;
  return aFile->GetLink();}

WinFile Get_File_w32(File aFile) {return aFile->GetWn32_File();} // valid aFile

void Set_File_Flagz(File aFile, int flagz) {
  if (IsValidFile(aFile)) aFile->SetFlagz(flagz);}

int Write_Data(File aFile, char* ary, int nby) {
  // write nby bytes of data from ary to open file fi, return actual # written
  int bitz = aFile->GetFlagz(); // =0 if invalid
  if (bitz==0) return 0;
  if (nby>0) if ((bitz&FlagMask) != 0) if ((bitz&DirecOnly) != Directory)
    if (((bitz&(MakeFiRef+Append))^WriteOnly) < Append)
      return (int)fwrite(ary,1,nby,aFile->GetWn32_File());
  return 0;} //~Write_Data

int Read_Data(File aFile, char* ary, int nby) {
  // read up to nby bytes of data into ary from open file fi, return actual #
  int bitz = aFile->GetFlagz(); // =0 if invalid
  if (bitz==0) return 0;
  if (nby>0) if ((bitz&FlagMask) != 0) if ((bitz&DirecOnly) != Directory)
    if ((bitz&(MakeFiRef+WriteOnly)) ==0)
      return (int)fread(ary,1,nby,aFile->GetWn32_File());
  return 0;} //~Read_Data

void Win32FindClose(File aFile) {
  if (aFile->GetFiHand() != null) fclose(aFile->GetFiHand());
  aFile->SetFiHand(NULL);}

 } // (temporarily) end namespace  _FrameWork_

#define Zap_File_w32(aFile) aFile->File_w32_Zap()

_File_::~_File_() { // Note: #define File_Destructor(f) delete f
  File lnk, prior = NULL;
  if (DebugLogFile) if (DebugLogFile != this)
    SystemDebugLog(String("FiDestruct -")+String(FileRefNum));
  if (Find_Hand != NULL) fclose(Find_Hand);
  Find_Hand = NULL;
  // Wait32(_FrameWork_::ResFiLok);
  lnk = _FrameWork_::PIBfiles;
  while (lnk != NULL) {
    if (lnk==this) {
      if (prior == NULL) _FrameWork_::PIBfiles = lnk->FileLink;
        else prior->FileLink = lnk->FileLink;
      break;}
    prior = lnk;
    lnk = lnk->FileLink;}}
  // Signal32(_FrameWork_::ResFiLok);}

_File_::_File_() {
  FileRefNum = ++_FrameWork_::FilnIx;
  Find_Hand = NULL;
  FileLink = NULL;
  FileInodN = NULL;
  ParDirLnk = NULL;
  FiFlagCnt = 0;
  FilePosnO = 0;}

_File_::_File_(String pth, WinFile wfi, int flg) {
  // _File_();
  FileRefNum = ++_FrameWork_::FilnIx;
  Find_Hand = NULL;
  FileLink = NULL;
  ParDirLnk = NULL;
  FilePosnO = 0;
  // Wait32(_FrameWork_::ResFiLok);
  if (_FrameWork_::PIBfiles != NULL) {
    FileLink = _FrameWork_::PIBfiles->FileLink;
    _FrameWork_::PIBfiles->FileLink = this;}
  else _FrameWork_::PIBfiles = this;
  // Signal32(_FrameWork_::ResFiLok);
  FileInodN = wfi;
  FiFlagCnt = flg&FlagMask;
  DirPath = pth;
  FilNamLnk = LastItem(pth, FilePathDelim);}

int GetFileFlags(File aFile) { // see bits above
  if (!_FrameWork_::IsValidFile(aFile)) return 0;
  return aFile->GetFlagz();}
String GetFileName(File aFile) {
  if (!_FrameWork_::IsValidFile(aFile)) return Null_Str;
  return aFile->myFileName();}
String FullPath(File aFile) {
  if (!_FrameWork_::IsValidFile(aFile)) return Null_Str;
  return aFile->myFullPath();}
int GetFiRefNum(File aFile) {
  if (!_FrameWork_::IsValidFile(aFile)) return 0;
  return aFile->GetRefNum();}

void SystemDebugLog(String theSt) {if (DebugLogFile) { // adds \r\n at end
  char* here = theSt.text_();
  char* crlf = CR_LF; // char* crlf = "\r\n";
  int ix = theSt.length_();
  // if (DebugLogFile) {
  // Wait32(_FrameWork_::DebugLok);
  _FrameWork_::Write_Data(DebugLogFile,here,ix);
  _FrameWork_::Write_Data(DebugLogFile,crlf,CRLF_LEN);
  // Signal32(_FrameWork_::DebugLok);
  }} //~SystemDebugLog
    // DebugLogFile->flush_(); // incredibly slow!!

int ReadData(File aFile, int* ary) { // returns a byte count
  if (ary==NULL) return 0;
  int nby = *ary++;
  if ((*ary)>0) (*ary)--; // doesn't dispose, but shouldn't need to
  return _FrameWork_::Read_Data(aFile,(char*)++ary,nby<<2);}
String ReadText(File aFile, int nby) { // read nby bytes of text, dele \0,\r
  int ix = 0, sz = FiSize_If_0(aFile,nby); // nby=0 gets all; never: sz<0
  if (sz==0) return Null_Str;
  String res(NULL,sz);
  char* here = res.text_();
  char ch;
  sz = _FrameWork_::Read_Data(aFile,here,sz);
  if (sz==0) return Null_Str;
  nby = 0;
  while (ix<sz) {
    ch = here[ix++];
    if (ch == '\r') {
      if (here[ix] == '\n') ix++;
      here[nby++] = '\n';}
    else if (ch != '\0') here[nby++] = ch;}
  if (nby==res.length_()) return res;
  return String(here,nby);}
String ReadLine(File aFile) { // read text to end of line
  int nby = 0;
  char ch, bf[260];
  // Fi_Find_32 FindInfo;
  String stx;
  if (!_FrameWork_::IsValidFile(aFile)) return Null_Str;
  // if (aFile->GetFiHand() != NULL) { // directory search already open..
  //   if (FindNextFile(aFile->GetFiHand(),&FindInfo))
  //     return String(FindInfo.cFileName);}
  // else if ((aFile->GetFlagz()&DirecOnly) == Directory) {
  //   stx = aFile->myFullPath()+"\\*";
  //   aFile->SetFiHand(FindFirstFile(stx.text_(),&FindInfo));
  //   if (aFile->GetFiHand() == INVALID_HANDLE_VALUE) aFile->SetFiHand(NULL);
  //     else return String(FindInfo.cFileName);}
  // else while (_FrameWork_::Read_Data(aFile,&ch,1)>0) {
  while (_FrameWork_::Read_Data(aFile,&ch,1)>0) {
    if (ch == '\0') break;
    if (ch == '\r') break;
    if (ch == '\n') {
      if (nby==0) continue;
      break;}
    bf[nby++] = ch;
    if (nby>255) break;}
  if (nby==0) return Null_Str;
  return String(bf,nby);} // ~ReadLine

int WriteData(File aFile, int* ary) { // returns a byte count
  if (ary==NULL) return 0;
  int nby = *ary++;
  if (nby>0) {
    nby = _FrameWork_::Write_Data(aFile,(char*)++ary,nby<<2);
    --ary;}
  down__ptr(--ary); // dispose if done
  return nby;}
void WriteBytes(File aFile, int* ary, int bgn, int ln) {
  if (ary==NULL) return;
  int nby = MAX(MIN(((*ary++)<<2)-bgn,ln),0);
  if (nby>0) {
    nby = _FrameWork_::Write_Data(aFile,(char*)(((int)(++ary))+bgn),nby<<2);
    --ary;}
  down__ptr(--ary);} // dispose if done
void WriteChar(File aFile, char ch) {
  _FrameWork_::Write_Data(aFile,&ch,1);}
void WriteLn(File aFile) {
  char* crlf = CR_LF;
  _FrameWork_::Write_Data(aFile,crlf,CRLF_LEN);}
void WriteText(File aFile, String theSt) { // write text or line break..
  char* here = theSt.text_();
  char* crlf = CR_LF;
  int ix = 0, mx = theSt.length_(), zx = -1;
  if (mx==0) return;
  if (DebugLogFile) if (_FrameWork_::LogTextWrites) if (aFile != DebugLogFile) {
    WriteChar(DebugLogFile,'\'');
    zx = 80;}
  while (ix<mx) {
    if (here[ix] == '\n') {
      if (ix>0) {
        if (zx>0) {
          _FrameWork_::Write_Data(DebugLogFile,here,MIN(ix,zx));
          if (ix <= zx) WriteChar(DebugLogFile,'\\');
          zx = MAX(zx-1-ix,0);}
        if (_FrameWork_::Write_Data(aFile,here,ix)<ix) break;}
      if (_FrameWork_::Write_Data(aFile,crlf,CRLF_LEN)<CRLF_LEN) break;
      here = (char*)(here+ix+1);
      mx = mx-1-ix;
      ix = 0;}
    else ix++;}
  if (ix>0) {
    if (zx>0) _FrameWork_::Write_Data(DebugLogFile,here,MIN(ix,zx));
    _FrameWork_::Write_Data(aFile,here,ix);}
  if (zx<0) return;
  WriteChar(DebugLogFile,'\'');
  WriteLn(DebugLogFile);}
  // DebugLogFile->flush_(); // incredibly slow!!
void WriteChr4(File aFile, Char4 cx) {WriteText(aFile,String(cx));} //~WriteText

String GetCurWinDirName(void) {return Null_Str;} // Std C doesn't do directories

String ProgFileName(void) { // returns full path name
  // char thename[2222]; // plenty big
  // if (GetModuleFileName(NULL,thename,2220)<2222) return String(thename);
  return Null_Str;} //~ProgFileName

////////////////////////////////////////////////////////////////////////

// Forward function declarations, mostly defined in System.h ..

#ifdef MOS_System

String FormInt(int theNum); // these also declared in SysNames.h (used above)
String FormHexNum(int num, int dgs);
String FormBibleRef(int ref);
String FormDateTime(int theNum, int opt);
/// void CloseWindow(Window aWin); // used in FW

#else // if no MOS_System, no '#include System.h'..

String FormInt(int theNum) {return String(theNum);}
String FormHexNum(int num, int dgs) {return String(num);}
String FormDateTime(int theNum, int opt) {return _FrameWork_::FormTimeMS();}
/// void CloseWindow(Window aWin) {}
/// void AsyncMsg(Char4 EvNo, int eInfo, int EvLoc, int EvDat, Process toPro) {}

#endif // (not) MOS_System

// MsgBox constants and fwds..
Char4 QuestIcon = "Qstn";
Char4 InfoIcon = "Bang";
Char4 StopIcon = "Stop";

// array bounds check..

int* _tmp_0_; int* _tmp_00_;
int __aix__, __aiy__, __aiz__;

int _Array_Bounds_Fail_(int aix, int aiz) { // never returns
  int aiy = 0;
  // MsgBox(String("Array bounds check ")+String(aix)+"<"+String(aiz)
  //     +" {"+ProcID(NULL)+"}",StopIcon,0);
  // Asyn_Msg("AB_Q",aix,aiz,0,_FrameWork_::MainProgram);
  if (_Crash_and_Burn_) {aiy = 0; aiy = aix/aiy;}
///   _FrameWork_::Asyn_Msg("Died",aix,aiz,0,_FrameWork_::MainProgram);
  exit(1); // Quit();
  return 0;} // ~_Array_Bounds_Fail_

// #define _Bounds_ChkL_(ary,aix) ary[2+(aix)] // moved to SysNames.h
// #define _Bounds_ChkR_(ary,aix) ary[2+(aix)] // moved to SysNames.h

////////////////////////////////////////////////////////////////////////

// Process management stuff.. (mostly removed)

Process NewProgram(String pname, File dir, Char4 pnam4) {
  // open program file pname in dir, give it (suggested) process ID pnam4
  StartNewProg(NULL);
  return (Process)ORD(pnam4);} // ~NewProgram

// DragonDrop data and functions (still inside _FrameWork_ namespace).. (removed)
// Graphics-related operations.. (removed)
// Opaque Window type, implemented as a pointer to a WindInfo class.. (removed)

////////////////////////////////////////////////////////////////////////

// Utility Functions not elsewhere defined..

int GetTime(void) { // returns seconds since midnight 2000 Jan 01
  tm* info;
  time_t now;
  int secs, days;
  char* mo = " 01/001123344"; // cumulative, relative to '0' (not leap year)
    // assuming a 30-day month model, each character of mo[] encodes
    // the number of days it differs from the model; '0' exactly matches
  time(&now);
  info = localtime(&now);
  days = (info->tm_year -2001);
  days = (days+1)*365+(days>>2); // days since Y2K to Jan this year
  days = days+((int)mo[info->tm_mon])+info->tm_mon*30-48+info->tm_mday;
    // add +30 for each prior month in year, + current day + diff in mo[],
    // -48 [which is (int)'0'] // NOT: -30 because wMonth is 1-based
    // -1 because wDay is 1-based, +1 after 2000 for Y2K leap day
  if (info->tm_mon>2) if ((info->tm_year&3)==0) days++; // fix leap year
  secs = days*86400+info->tm_hour*3600+info->tm_min*60+info->tm_sec;
  return secs;}

int GetMilliSecs(void) { // returns milliseconds since midnight today
  tm* info;
  time_t now;
  time(&now);
  info = localtime(&now);
  return (info->tm_hour*3600+info->tm_min*60+info->tm_sec)*1000;}

namespace  _FrameWork_ { // resume

#ifdef MOS_System // these following not needed otherwise

// low-level functions used by Sortit.. -- this is #ifdef'd out if no System.h

inline void Exchange(int& Ap, int& Bp) {int med = Ap; Ap = Bp; Bp = med;}
inline void Byte_Store(int* ary, int Ap, char xCh) {
  char* theStr = (char*)ary;
  if (ary==NULL) return;
  if (ary[1]>0) ary[1]--; // doesn't dispose, but shouldn't need to
  theStr[Ap+8] = xCh;}
inline bool Dis_Order(int* ary, int Ap, int Bp) { // true if theStr[a]>theStr[b]
  unsigned char* theStr = (unsigned char*)ary;
  unsigned char xCh, zCh;
  if (ary==NULL) return false;
  if (ary[1]>0) ary[1]--; // doesn't dispose, but shouldn't need to
  Ap = Ap+8;
  Bp = Bp+8;
  while (true) {
    xCh = theStr[Ap++];
    if (xCh=='\0') return false;
    zCh = theStr[Bp++];
    if (xCh == zCh) continue;
    xCh = Capitize(xCh);
    zCh = Capitize(zCh);
    if (xCh != zCh) return (xCh>zCh);}}

////////////////////////////////////////////////////////////////////////

// Win32 Registry Access.. -- note: this is #ifdef'd out if no System.h (removed)

#endif // MOS_System

////////////////////////////////////////////////////////////////////////

/// void Log_This_Evt(int msg) { // called also from Sys
///   Logged_Events[(Ev_Log_Ix++)&(Event_Log-1)] = msg;
///   Logged_Events[Ev_Log_Ix&(Event_Log-1)] = -1;} // ~Log_This_Evt

// MsgBox and AskText.. (removed)

////////////////////////////////////////////////////////////////////////

boolean InitializeAll(bool& GotOle) { // HINSTANCE hx,
  int ix, rx = 0, gx = 0, bx = 0, colo;
  NoName = "    "; // dunno why init constructor fails, but this works..
  Typ4 = "Type";
#ifdef Debug_Trace
#ifdef Debug_Trace_File
  DebugLogFile = Open_In_Dir(Debug_Trace_File,WriteOnly,NULL);
#else
  DebugLogFile = Open_In_Dir(Debug_Trace,WriteOnly,NULL);
#endif
  if (DebugLogFile)
    SystemDebugLog(String("---- ")+FormDateTime(GetTime(),0)+String(" ----"));
#endif
  return true;} // ~InitializeAll

 } // (temporarily) end namespace  _FrameWork_

////////////////////////////////////////////////////////////////////////

namespace _FrameWork_ { // _FrameWork_::xxx

int* _tmp_0_; int* _tmp_00_;
int __aix__, __aiy__, __aiz__;




  int PIBsysErr = 0;

bool IsAlphaNum(char ch)
 { int* _tmp_00_; bool _tmp__;
  if ((ch < '0'))  { return 0;}
  if ((ch <= '9'))  { return 1;}
  if ((ch > 'z'))  { return 0;}
  if ((ch < 'A'))  { return 0;}
  if ((ch == '_'))  { return 1;}
  if ((ch < 'a'))  if ((ch > 'Z'))  { return 0;}
  { return 1;}} // ~IsAlphaNum

int Tokenize(int kin, int orn, String stx, int theLn)
 { int* _tmp_00_; int _tmp__;
  int ordn = MAX(orn,-1);
  int here = _len_(stx);
  int ptln = 0;
  int offs = 0;
  int xch;
  int sep;
  if ((here == 0))  { _tmp__ = 0; return _tmp__;}
  if ((ordn > orn))  orn = 0;
  if ((kin == (-2)))  kin = 10;
  sep = (kin&127);
  here = 0;
  xch = ORD((char)CharAt(0, stx));
  while (1) {
  if ((kin <= 0))  while ((xch <= 32)) {
  if ((xch == 0))  break;
  here++;
  xch = ORD((char)CharAt(here, stx));}
  if ((xch == 0)) {
  if ((ordn < 0))  { _tmp__ = MIN((orn-ordn),here); return _tmp__;}
  offs = here;
  break;}
  ordn--;
  if ((ordn == 0))  offs = here;
  if ((kin == 0))  while ((xch > 32)) {
  here++;
  xch = ORD((char)CharAt(here, stx));}
  else  if ((kin < 0)) {
  if (IsAlphaNum(CHR((xch&255))))  while (IsAlphaNum(CHR((xch&255)))) {
  here++;
  xch = ORD((char)CharAt(here, stx));}
  else {
  here++;
  xch = ORD((char)CharAt(here, stx));}}
  else  while ((xch != sep)) {
  here++;
  xch = ORD((char)CharAt(here, stx));
  if ((xch == 0))  break;}
  if ((ordn == 0)) {
  ptln = (here-offs);
  break;}
  if ((xch == 0)) {
  if ((ordn < 0))  if ((orn == 0))  orn = -1;
  continue;}
  if ((kin < 0))  continue;
  here++;
  xch = ORD((char)CharAt(here, stx));}
  if ((theLn != 0))  _POKE_((int)theLn,(int)ptln);
  { _tmp__ = offs; return _tmp__;}} // ~Tokenize

String Replace_Del(String NuSt, int offs, int nch, String theSt, bool del2)
 { int* _tmp_00_; String _tmp__;
  int ln1 = _len_(theSt);
  int ln2 = _len_(NuSt);
  if ((offs < 0))  offs = 0;
  if ((nch < 0))  nch = 0;
  if (del2) {
  if ((offs > 0))  offs--;
  nch++;}
  if ((ln1 == 0))  { _tmp__ = NuSt; return _tmp__;}
  if ((offs >= ln1))  { _tmp__ = _cat_(theSt, NuSt); return _tmp__;}
  if ((nch == 0))  if ((offs == 0))
    { _tmp__ = _cat_(NuSt, theSt); return _tmp__;}
  if ((offs == 0))  if ((nch >= ln1))  { _tmp__ = NuSt; return _tmp__;}
  nch = MIN(nch,(ln1-offs));
  if (((ln2+nch) == 0))  { _tmp__ = theSt; return _tmp__;}
  { _tmp__ = _cat_(_cat_(Substring(0, offs, theSt), NuSt), Substring((offs+nch), ln1, theSt)); return _tmp__;}} // ~Replace_Del

String Pos_Time(String prefx)
 { int* _tmp_00_; String _tmp__;
  int now = ((GetMilliSecs()/100)%36000);
  prefx = _cat_(_cat_(_cat_(prefx, String((int)(now/600))), String(":")), String((int)((now%600)+1000)));
  now = _len_(prefx);
  prefx = Replace_Del(Null_Str, (now-4), 1, prefx, 0);
  { _tmp__ = Replace_Del(String("."), (now-2), 0, prefx, 0); return _tmp__;}} // ~Pos_Time

String FormTimeMS()
 { int* _tmp_00_; String _tmp__;
  { return Pos_Time(String(" -- "));}}
 
 } // (temporarily) end namespace  _FrameWork_

String Replace(String NuSt, int offs, int nch, String theSt)
 { int* _tmp_00_; String _tmp__;
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, offs, nch, theSt, 0); return _tmp__;}}

String WordOf(int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(0, ordn, theSt, ((int)(&sz)));
  if ((sz > 0))  { _tmp__ = Substring(here, sz, theSt); return _tmp__;}
  { _tmp__ = Null_Str; return _tmp__;}}

String LineOf(int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-2, ordn, theSt, ((int)(&sz)));
  if ((sz > 0))  { _tmp__ = Substring(here, sz, theSt); return _tmp__;}
  { _tmp__ = Null_Str; return _tmp__;}}

String TokenOf(int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-1, ordn, theSt, ((int)(&sz)));
  if ((sz > 0))  { _tmp__ = Substring(here, sz, theSt); return _tmp__;}
  { _tmp__ = Null_Str; return _tmp__;}}

String ItemOf(char sep, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(ORD((char)sep), ordn, theSt, ((int)(&sz)));
  if ((sz > 0))  { _tmp__ = Substring(here, sz, theSt); return _tmp__;}
  { _tmp__ = Null_Str; return _tmp__;}}

String PutWordOf(String NuSt, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(0, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, sz, theSt, 0); return _tmp__;}}

String PutLineOf(String NuSt, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-2, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, sz, theSt, 0); return _tmp__;}}

String PutTokenOf(String NuSt, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-1, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, sz, theSt, 0); return _tmp__;}}

String PutItemOf(String NuSt, char sep, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(ORD((char)sep), ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, sz, theSt, 0); return _tmp__;}}

String InsertB4Word(String NuSt, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(0, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, 0, theSt, 0); return _tmp__;}}

String InsertB4Line(String NuSt, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-2, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, 0, theSt, 0); return _tmp__;}}

String InsertB4Token(String NuSt, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-1, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, 0, theSt, 0); return _tmp__;}}

String InsertB4Item(String NuSt, char sep, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(ORD((char)sep), ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(NuSt, here, 0, theSt, 0); return _tmp__;}}

String DeleteWordOf(int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(0, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(Null_Str, here, sz, theSt, 1); return _tmp__;}}

String DeleteLineOf(int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-2, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(Null_Str, here, sz, theSt, 1); return _tmp__;}}

String DeleteTokenOf(int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(-1, ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(Null_Str, here, sz, theSt, 1); return _tmp__;}}

String DeleteItemOf(char sep, int ordn, String theSt)
 { int* _tmp_00_; String _tmp__;
  int sz = 0;
  int here = _FrameWork_::Tokenize(ORD((char)sep), ordn, theSt, ((int)(&sz)));
  { _tmp__ = _FrameWork_::Replace_Del(Null_Str, here, sz, theSt, 1); return _tmp__;}}

int nWords(String theSt)
 { int* _tmp_00_; int _tmp__;
  { _tmp__ = _FrameWork_::Tokenize(0, -1, theSt, 0); return _tmp__;}}

int nTokens(String theSt)
 { int* _tmp_00_; int _tmp__;
  { _tmp__ = _FrameWork_::Tokenize(-1, -1, theSt, 0); return _tmp__;}}

int nLines(String theSt)
 { int* _tmp_00_; int _tmp__;
  { _tmp__ = _FrameWork_::Tokenize(-2, -1, theSt, 0); return _tmp__;}}

int n0Lines(String theSt)
 { int* _tmp_00_; int _tmp__;
  { _tmp__ = _FrameWork_::Tokenize(-2, -2, theSt, 0); return _tmp__;}}

int nItems(char sep, String theSt)
 { int* _tmp_00_; int _tmp__;
  { _tmp__ = _FrameWork_::Tokenize(ORD((char)sep), -1, theSt, 0); return _tmp__;}}

int n0Items(char sep, String theSt)
 { int* _tmp_00_; int _tmp__;
  { _tmp__ = _FrameWork_::Tokenize(ORD((char)sep), -2, theSt, 0); return _tmp__;}}

bool ParseBool(String stx)
 { int* _tmp_00_; bool _tmp__;
  int here = 0;
  int back = _len_(stx);
  char xch;
  while (1) {
  if ((here >= back))  { _tmp__ = 0; return _tmp__;}
  xch = CharAt(here, stx);
  here++;
  switch (xch) {
case 32:
case 44:
case 10:
case 13:
case 9:
  continue;
case 84:
case 116:
case 49:
  { _tmp__ = 1; return _tmp__;}
default:
  { _tmp__ = 0; return _tmp__;}
  } //~switch
  }} // ~ParseBool

int ParseInt(String stx)
 { int* _tmp_00_; int _tmp__;
  int parm = 0;
  int ndigs = 0;
  int here = 0;
  int sgn = 1;
  int nx = 5;
  int back = _len_(stx);
  char xch;
  while (1) {
  if ((here >= back))  break;
  xch = CharAt(here, stx);
  here++;
  switch (xch) {
case 32:
case 44:
case 10:
case 13:
case 9:
  if ((ndigs != 0))  break;
  continue;
case 45:
  if ((ndigs != 0))  break;
  sgn = -1;
  continue;
case 88:
case 120:
  if ((parm != 0))  break;
  if ((nx == 8))  break;
  nx = 8;
  continue;
case 48:
case 49:
case 50:
case 51:
case 52:
case 53:
case 54:
case 55:
case 56:
case 57:
  parm = (((parm << 1)*nx)+(ORD((char)xch)&15));
  ndigs++;
  continue;
case 65:
case 66:
case 67:
case 68:
case 69:
case 70:
case 97:
case 98:
case 99:
case 100:
case 101:
case 102:
  if ((nx == 5))  break;
  parm = (((parm << 4)+(ORD((char)xch)&15))+9);
  ndigs++;
  continue;
default:
  break;  } //~switch
    break;}
  if ((parm > 0))  if ((sgn < 0))  { _tmp__ = (-parm); return _tmp__;}
  { _tmp__ = parm; return _tmp__;}} // ~ParseInt

int Offset(String sot, String instr)
 { int* _tmp_00_; int _tmp__;
  int sotl = _len_(sot);
  int insl = _len_(instr);
  if ((sotl == 0))  { _tmp__ = 0; return _tmp__;}
  if ((insl < sotl))  { _tmp__ = -1; return _tmp__;}
  { _tmp__ = _FrameWork_::FindText(EXTRACT_Cstr(sot), sotl, EXTRACT_Cstr(instr), insl); return _tmp__;}} // ~Offset

String LastItem(String name, char delim)
 { int* _tmp_00_; String _tmp__;
  int nitms = _FrameWork_::Tokenize(ORD((char)delim), -1, name, 0);
  int sz = 0;
  int here = _FrameWork_::Tokenize(ORD((char)delim), (nitms-1), name, ((int)(&sz)));
  if ((nitms < 2))  { return name;}
  { _tmp__ = Substring(((here+sz)+1), _len_(name), name); return _tmp__;}} // ~LastItem

String ReplacAll(String nust, String seek, String theStr)
 { int* _tmp_00_; String _tmp__;
  int offs = 0;
  int olen = _len_(seek);
  int nlen = _len_(nust);
  int mxln;
  if ((olen == 0))  { _tmp__ = theStr; return _tmp__;}
  while (1) {
  mxln = _len_(theStr);
  if (((offs+olen) > mxln))  offs = -1;
  else  offs = FindStTxBlk(seek, offs, mxln, Text_Ary_Str(theStr));
  if ((offs < 0))  { _tmp__ = theStr; return _tmp__;}
  theStr = Replace(nust, offs, olen, theStr);
  offs = (offs+nlen);}} // ~ReplacAll

 
namespace  _FrameWork_ { // resuming

bool IsValidFile(File aFile)
 { int* _tmp_00_; bool _tmp__;
  File here = _FrameWork_::Next_File(0);
  if ((aFile == 0))  { return 0;}
  while ((here != 0)) {
  if ((here == aFile))  { return 1;}
  here = _FrameWork_::Next_File(here);}
  { return 0;}} // ~IsValidFile

File Find_Directry(String path, bool Sharon)
 { int* _tmp_00_; File _tmp__;
  int bitz;
  File aFile = 0;
  while (1) {
  aFile = Next_File(aFile);
  if ((aFile == 0))  { _tmp__ = 0; return _tmp__;}
  bitz = GetFileFlags(aFile);
  if (((bitz&64) != 0))  continue;
  if (((bitz&24) != 16)) {
  if ((!Sharon))  continue;
  if (((bitz&152) == 0))  continue;}
  if ((FullPath(aFile) == path))
    { _tmp__ = aFile; return _tmp__;}}} // ~Find_Directry

File Open_Fail(String why)
 { int* _tmp_00_; File _tmp__;
  if (DebugLogFile)  SystemDebugLog(_cat_(String("  -- fail: "), why));
  { _tmp__ = 0; return _tmp__;}} // ~Open_Fail

File Open_In_Dir(String name, int opt, File dir)
 { int* _tmp_00_; File _tmp__;
  int here;
  int sz;
  int nn;
  int nitms = 0;
  int abit = 0;
  File aFile = 0;
  WinFile wfi = 0;
  String thePath = Null_Str;
  String theMode;
  if ((opt == 0))  opt = 0x400;
  if ((dir == 0))  dir = PIBwDir;
  if (DebugLogFile) {
  if ((dir != 0)) {
  thePath = FullPath(dir);
  nitms = GetFiRefNum(dir);}
  SystemDebugLog(_cat_(_cat_(_cat_(_cat_(
    _cat_(_cat_(_cat_(String("OpenFi "), String((int)opt)), String(" '")),
   name), String("' +")), String((int)nitms)), String(" ")), thePath));}
  if ((Offset(String(FilePathDelim), name) > 0)) {
  here = Tokenize(ORD(FilePathDelim), 1, name, ((int)(&sz)));
  thePath = Substring(0, sz, name);
  if ((thePath == Null_Str)) {
  if ((dir == 0))  thePath = String("C:");
  else {
  thePath = FullPath(dir);
  here = Tokenize(ORD(FilePathDelim), 1, thePath, ((int)(&sz)));
  thePath = Substring(0, sz, thePath);}
  name = _cat_(thePath, name);}
  else  if ((thePath == Two_Dots)) {
  if ((dir == 0))  { _tmp__ = Open_Fail(Two_Dots); return _tmp__;}
  thePath = FullPath(dir);
  nitms = Tokenize(ORD(FilePathDelim), 0, thePath, 0);
  here = Tokenize(ORD(FilePathDelim), (nitms-1), thePath, ((int)(&sz)));
  thePath = Substring(0, (here+sz), thePath);
  name = _cat_(thePath, name);}
  else  if ((thePath == One_Dot)) {
  if ((dir == 0))  { _tmp__ = Open_Fail(One_Dot); return _tmp__;}
  thePath = FullPath(dir);
  name = _cat_(thePath, name);}
  nitms = Tokenize(ORD(FilePathDelim), 0, name, 0);
  here = Tokenize(ORD(FilePathDelim), nitms, name, ((int)(&sz)));
  nitms = (here+sz);
  thePath = Substring(0, nitms, name);
  name = Substring((nitms+1), _len_(name), name);
  dir = _FrameWork_::Find_Directry(thePath, 0);
  if ((dir == 0)) {
  dir = Make_File(LastItem(thePath, FilePathDelim), thePath, 0, 16);
  if ((dir == 0))  { _tmp__ = Open_Fail(String("new1")); return _tmp__;}}
  if ((_len_(name) == 0)) {
  if (DebugLogFile) {
  nitms = GetFiRefNum(dir);
  opt = GetFileFlags(aFile);
  thePath = FullPath(dir);
  SystemDebugLog(_cat_(_cat_(_cat_(_cat_(
    _cat_(String("  = "), String((int)nitms)), String(":")), String((int)opt)),
   String(" ")), thePath));}
  { _tmp__ = dir; return _tmp__;}}}
  if ((dir == 0)) {
  dir = Make_File(Null_Str, GetCurWinDirName(), 0, 16);
  if ((dir == 0))  { _tmp__ = Open_Fail(String("new2")); return _tmp__;}
  PIBwDir = dir;}
  else  if ((!IsValidFile(dir)))
    { _tmp__ = Open_Fail(String("IsVal")); return _tmp__;}
  nn = GetFileFlags(dir);
  if ((name == Null_Str)) {
  if (((opt&64) == 0))  if (((nn&64) == 0))
    { _tmp__ = Open_Fail(String("ref")); return _tmp__;}
  thePath = FullPath(dir);
  name = GetFileName(dir);}
  else  if (((nn&24) != 16))
    { _tmp__ = Open_Fail(_cat_(String("dir="), String((int)nn))); return _tmp__;}
  else  thePath = _cat_(_cat_(FullPath(dir), String(FilePathDelim)), name);
  if (((opt&152) == 152)) {
  aFile = _FrameWork_::Find_Directry(thePath, 1);
  if ((aFile != 0)) {
  if (DebugLogFile) {
  nitms = GetFiRefNum(aFile);
  thePath = FullPath(aFile);
  opt = GetFileFlags(aFile);
  SystemDebugLog(_cat_(_cat_(_cat_(_cat_(
    _cat_(String("  sh "), String((int)nitms)), String(":")), String((int)opt)),
   String(" ")), thePath));}
  { _tmp__ = aFile; return _tmp__;}}}
  if (((opt&16) != 0)) {
  aFile = _FrameWork_::Find_Directry(thePath, 0);
  if ((aFile != 0)) {
  if (DebugLogFile) {
  nitms = GetFiRefNum(aFile);
  thePath = FullPath(aFile);
  opt = GetFileFlags(aFile);
  SystemDebugLog(_cat_(_cat_(_cat_(_cat_(
    _cat_(String("  dir "), String((int)nitms)), String(":")), String((int)opt)),
   String(" ")), thePath));}
  { _tmp__ = aFile; return _tmp__;}}}
  if ((Next_File(0) == 0))
    { _tmp__ = Open_Fail(String("PIBfi")); return _tmp__;}
  if (((opt&24) != 16))  if (((opt&64) == 0)) {
  nitms = (opt&15);
  here = 0;
  switch (nitms) {
case 0:
  theMode = String("w+");
  break;
case 1:
  theMode = String("r");
  break;
case 2:
  theMode = String("w");
  break;
case 3:
  theMode = String("a");
  break;
case 4:
  theMode = String("r+");
  break;
case 5:
  theMode = String("r");
  break;
case 6:
  theMode = String("w");
  break;
case 7:
  theMode = String("r+");
  break;
case 8:
  theMode = String("w+b");
  break;
case 9:
  theMode = String("rb");
  break;
case 10:
  theMode = String("wb");
  break;
case 11:
  theMode = String("ab");
  break;
case 12:
  theMode = String("r+b");
  break;
case 13:
  theMode = String("rb");
  break;
case 14:
  theMode = String("wb");
  break;
case 15:
  theMode = String("r+b");
  break;  } //~switch
    wfi = fopen(EXTRACT_Cstr(thePath), EXTRACT_Cstr(theMode));
  if ((wfi == 0)) {
  File_Destructor(aFile);
  { _tmp__ = Open_Fail(String("fopen err")); return _tmp__;}}}
  aFile = Make_File(LastItem(thePath, FilePathDelim), thePath, wfi, opt);
  if ((aFile == 0))  { _tmp__ = Open_Fail(String("new3")); return _tmp__;}
  nitms = GetFiRefNum(aFile);
  thePath = FullPath(aFile);
  opt = GetFileFlags(aFile);
  if (DebugLogFile) {
  if ((abit == 0))  name = String("  rf ");
  else  name = String("  fi ");
  SystemDebugLog(_cat_(_cat_(_cat_(_cat_(
    _cat_(name, String((int)nitms)), String(":")), String((int)opt)), String(" ")),
   thePath));}
  { _tmp__ = aFile; return _tmp__;}} // ~Open_In_Dir

 
 } // (temporarily) end namespace  _FrameWork_

int GetFilePosn(File aFile)
 { int* _tmp_00_; int _tmp__;
  int bitz = GetFileFlags(aFile);
  if ((bitz == 0))  { return -1;}
  if (((bitz&24) != 16))  if (((bitz&64) == 0))
    { return Int_CAST((int*)ftell(_FrameWork_::Get_File_w32(aFile)));}
  { return -1;}} // ~GetFilePosn

int GetSizeFile(File aFile)
 { int* _tmp_00_; int _tmp__;
  int thar;
  int bitz = GetFileFlags(aFile);
  if ((bitz == 0))  { return -1;}
  if (((bitz&24) != 16))  if (((bitz&64) == 0)) {
  bitz = Int_CAST((int*)ftell(_FrameWork_::Get_File_w32(aFile)));
  thar = Int_CAST((int*)fseek(_FrameWork_::Get_File_w32(aFile), 0, SEEK_END));
  bitz = Int_CAST((int*)fseek(_FrameWork_::Get_File_w32(aFile), bitz, SEEK_SET));
  { return thar;}}
  { return -1;}} // ~GetSizeFile

int GetFileErr()
 { int* _tmp_00_; int _tmp__;
  { return _FrameWork_::PIBsysErr;}}

bool FileAtEOF(File aFile)
 { int* _tmp_00_; bool _tmp__;
  if ((!_FrameWork_::IsValidFile(aFile)))  { return 0;}
  { return feof(_FrameWork_::Get_File_w32(aFile));}} // ~FileAtEOF

int FiSize_If_0(File aFile, int nby)
 { int* _tmp_00_; int _tmp__;
  if ((nby > 0))  { return nby;}
  { return MAX((GetSizeFile(aFile)-GetFilePosn(aFile)),0);}} // ~FiSize_If_0

void SetEOF(File aFile)
 { int* _tmp_00_;
  if ((!_FrameWork_::IsValidFile(aFile)))  _FrameWork_::PIBsysErr = -254;
  else  if (((GetFileFlags(aFile)&24) == 16))  _FrameWork_::PIBsysErr = -252;
  else  if (((GetFileFlags(aFile)&64) != 0))  _FrameWork_::PIBsysErr = -252;
  else  _FrameWork_::PIBsysErr = -252;} // ~SetEOF

void Seek(File aFile, int offs)
 { int* _tmp_00_;
  if ((!_FrameWork_::IsValidFile(aFile)))  _FrameWork_::PIBsysErr = -254;
  else  if (((GetFileFlags(aFile)&24) == 16))  _FrameWork_::PIBsysErr = -252;
  else  if (((GetFileFlags(aFile)&64) != 0))  _FrameWork_::PIBsysErr = -252;
  else  if ((Int_CAST((int*)fseek(_FrameWork_::Get_File_w32(aFile), offs,
   SEEK_SET)) < 0))  _FrameWork_::PIBsysErr = -252;
  else  _FrameWork_::PIBsysErr = 0;} // ~Seek

File Close2Ref(File aFile)
 { int* _tmp_00_; File _tmp__;
  if ((!_FrameWork_::IsValidFile(aFile)))  { return 0;}
  if ((_FrameWork_::Using_ResFi == aFile))  _FrameWork_::Using_ResFi = 0;
  if (DebugLogFile)
    SystemDebugLog(_cat_(String("ClosFi +"), String((int)GetFiRefNum(aFile))));
  if (((GetFileFlags(aFile)&64) != 0))  { return aFile;}
  _FrameWork_::Win32FindClose(aFile);
  if (((GetFileFlags(aFile)&24) != 16))
    if (((GetFileFlags(aFile)&64) == 0)) {
  Zap_File_w32(aFile);}
  _FrameWork_::Set_File_Flagz(aFile, (GetFileFlags(aFile)|64));
  { return aFile;}} // ~Close2Ref

void FileClose(File aFile)
 { int* _tmp_00_;
  int flgz = GetFileFlags(aFile);
  if (((flgz&128) != 0))  { return;}
  aFile = Close2Ref(aFile);
  if (((flgz&24) == 16))  { return;}
  File_Destructor(aFile);} // ~FileClose

void FileDelete(File aFile)
 { int* _tmp_00_;
  String fiName = FullPath(aFile);
  if ((fiName == Null_Str))  { return;}
  if (((GetFileFlags(aFile)&192) != 64))  { return;}
  remove(EXTRACT_Cstr(fiName));
  File_Destructor(Close2Ref(aFile));} // ~FileDelete

void Beep()
 { int* _tmp_00_;
  if (DebugLogFile)  SystemDebugLog(String("!! --- Beep ---"));} // ~Beep

 
namespace  _FrameWork_ { // resuming
 
/*

void FrameWork_main()
 { int* _tmp_00_;
  Quit();}
*/

 } // (end namespace _FrameWork_) /// #include "FrameWork.h"

////////////////////////////////////////////////////////////////////////

int main() {
  // int WINAPI WinMain(HINSTANCE hx, HINSTANCE px, PSTR cx, int sho) {
  // Win32 startup procedure, calls MOS_main() after initializing
  bool GotOle = false;
  if (!_FrameWork_::InitializeAll(GotOle)) {
///     MessageBox(NULL,"Oops",ProgramName,0);
    return 0;}
  NewProgram(ProgramName,NULL,ProgramName);
  if (DebugLogFile) {
///     _FrameWork_::Exit_MOMAM();
    FileClose(DebugLogFile);}
  DebugLogFile = NULL;
  return 0;} // ~WinMain

#undef _BASE_

#ifdef Debug_Trace
#undef Debug_Trace
#endif
#undef Post_Trace
#undef Sys_Trace
#undef SigWait_Trace
#undef Draw_Trace
#undef _Str_Logit_
#undef _Str_unLog_
#undef _String_Log_
#undef WinFile
// #undef PathSize
// #undef App_Icon
// #undef Ask_Text
// #undef IDC_EdLn
// #undef IDC_AskLabel
#undef Int_CAST
// #undef Fi_Find_32
#undef FlagMask
#undef File_Destructor
#undef Zap_File_w32
//#undef BaseM_LineHgt

#undef Verify_Valid_Ptr

#if Malloc_Log == 5
#define Verify_Valid_Ptr(ptr) Valid_Ptr_Verify(ptr)
#else
#define Verify_Valid_Ptr(ptr) 0
#endif

#undef PEEK_OFTEN
#undef Malloc_Log

#ifndef MOS_System // these are needed in System.h ..
//#undef _w32RECT_
// #undef w32RECT
// #undef wPOINT
//#undef _wPOINT_
#undef FILL_0
#undef int_2_ptr
#undef ptr_2_int
#undef C_string
#undef EXTRACT_Cstr
#undef MAKE_Cstr
#undef Literal_Cstr
// #undef WinWindow
#undef Cast_Proc
#undef Proc_Cast

#undef _rTop
#undef _rLeft
#undef _rBotm
#undef _rRite
#undef _wKind
#undef _wName
#undef _wFlags
#undef _wLink
#undef _wParent
#undef _wChild
#undef _wWindo
#undef _FoBgColo
#undef _theText
#undef _MoInfo
#undef _wOwner
#undef _wNxID
#undef _wFocus
#undef _wTextVH
#undef _wUserData
#undef _wMoreInfo
#undef WinFlagsOffs

// #undef Sem32
// #undef NewSem32
// #undef Signal32
// #undef Wait32

// #undef Windo_Event

#undef Do_Gooey
#undef Gooey_Do
#undef Panic_Log
#undef Event_Log
#undef See_Panic

#undef Drag_Trace
// #undef Menu_LineHeight
// #undef Menu_Comm_base
// #undef Max_Menus
#undef _Crash_and_Burn_
#undef DebugLogFile
#endif // MOS_System

#undef CR_LF
#undef CRLF_LEN
#undef FilePathDelim

#undef FrameWork_Body
#endif // MOS_FrameWork

////////////////////////////////////////////////////////////////////////

// Standard type conversions and other built-ins..
// array management routines..
// Opaque Point type, implemented as an int..
// Predefined Rectangle class
// 4-character-as-int (Char4) class, intrinsic to Turk/2..
// Global declarations used in WinMain/InitializeAll..
// early forward declarations..
// ref-counted String class, intrinsic to Turk/2..
// Opaque File type, implemented as a pointer to a _File_ class..
// Forward function declarations, mostly defined in System.h ..
// array bounds check..
// Process management stuff..
// Predefined Event class, implemented as a pointer to class _Event_
// DragonDrop data and functions..
// Graphics-related operations..
// Opaque Window type, implemented as a pointer to a WindInfo class..
// Utility Functions not elsewhere defined..
// [Part 2] D&D code adapted from <http://www.catch22.net/tuts/dragdrop.asp>
// Win32 Registry Access..
// MsgBox and AskText..
// Win32 event support..
// #include "FrameWork.h"

////////////////////////////////////////////////////////////////////////

