/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include "TBthread.h"

void TinyBasic::fileNew()
{
  Pasted = new QString("\nCLEAR\n");
  NewInt = (NewInt &-8192)+8192; // unlock wait loop
}

void TinyBasic::fileOpen()
{
  QString fn = QFileDialog::getOpenFileName(QString::null,
      "Text (*.txt)", this, "open file dialog", 
      "TinyBasic source file:");
  if (fn.isEmpty()) return;
  if (inFile != NULL) {   /* there is a file already open, close it */
    inFile->close();
    inFile = NULL;}
  inFile = new QFile(fn);
  if (inFile != NULL) {
    if (!(inFile->open(IO_ReadOnly))) inFile = NULL;
    else if (inFile->atEnd()) {
      inFile->close();
      inFile = NULL;}
    else NewInt = (NewInt &-8192)+(inFile->getch())+8192;} // 1st char
}

void TinyBasic::fileSaveAs()
{
  QString fn = QFileDialog::getSaveFileName("TBlog.txt",
      "Text (*.txt)", this, "save file dialog", 
      "TinyBasic log file:");
  if (fn.isEmpty()) return;
  if (oFile!= NULL) {   /* there is a file already open, close it */
    oFile->close();
    oFile = NULL;}
  oFile = new QFile(fn);
  if (oFile != NULL) 
    if (!(oFile->open(IO_WriteOnly|IO_Translate))) oFile = NULL;
}


void TinyBasic::filePrint()
{
  QMessageBox::warning(this,"TinyBasic Print",
    "Printing has been left as an exercize for the student",
    QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
}



void TinyBasic::editPaste()
{
  Pasted = new QString(QApplication::clipboard()->text());
  NewInt = (NewInt &-8192)+8192; // unlock wait loop
}


void TinyBasic::fileExit() {this->close();}

void TinyBasic::helpAbout()
{
  Pasted = new QString("\nREM -- TinyBasic by Itty Bitty Computers\n");
  NewInt = (NewInt &-8192)+8192; // unlock wait loop
}

bool TinyBasic::eventFilter(QObject* target, QEvent* event) {
  int pn;
  static bool cr = false;
  QEvent::Type evn = event->type();
  //QString msg("-Got:");
  if (evn == QEvent::KeyPress) {
    NewInt = ((int) ((QKeyEvent*)event)->key())+(NewInt &-8192)+8192;
    return true;}
  else if (evn>1024) {
    pn= ((int)evn)&127;
    if (pn== (int)'\n') {
      if (cr) ScreenText->append(QString(" "));
      cr = true;
      return true;}
    else if (pn==8) { // backspace
      cr = true;
      pn = ScreenText->paragraphs()-1;
      ScreenText->setSelection(pn,
          ScreenText->paragraphLength(pn)-1,pn,9999);
      ScreenText->del();
      return true;}
    else if (pn<32) return true;
    ScreenText->append(QString(QChar((char)pn)));
    pn = ScreenText->paragraphs();
    if (pn>777) {
      ScreenText->setSelection(0,0,99,0);
      ScreenText->removeSelectedText(0);}
    if (!cr) {
      pn = ScreenText->paragraphs();
      ScreenText->setSelection(pn-2,9999,pn-1,0);
      ScreenText->removeSelectedText(0);}
    else cr = false;
    return true;}
  else return QMainWindow::eventFilter(target, event);
}

void TinyBasic::init() {
  //ScreenText->setText("Got here");
  ScreenText->installEventFilter(this);
  myself = this;
  gooey.start();
}


