{ Grammar of the Turk/2 Programming Language -- 2009 September 24 }

 {~QualIdent} {~MethodHeader} {~VarDecln} {~MagiCall} {~AssignStmt}
 {~KeyWdStmt} {~Expressn} {~Primary} {~Assignable} {~Coerce}
 {~TempAlloc} {~PoorManConstor} {~Decorate} {~InsertStuff} {~NoFun}
 {~TempVar} {~UpdateLoc} {~GenTreeCode} {~PreCodeTree}

tag Turk2C:   {** all sections completed except as thus noted **}
{** TAGC generates incorrect C code for asserting (treeA#treeB) **}
{** set TAGC memory size to > 20M, this is very big **}        {review ??}
{review TempVar stuff: I think NextVarInf doesn't need to discard, but works}

  {tree node names -- see definitions at end}
  type node(no, ty, gl, fn, tk, nt, st, pl,  qu, tr, ac, at, mt, ot, cn, rt,
            xf, bt, er, al, ca, qm, dl, tf,  dr, vr, as, eq, ls, gr, ne, an,
            or, ad, su, mp, dv, md, ng, tv,  rn, nn, nc, co, sa, pk, ar, ax,
            bg, ch, cl, cm, cs, cv, df, do,  en, ex, fc, fl, fr, ge, hp, if,
            in, io, jm, ki, lc, le, lp, lx,  nl, nx, of, pm, pt, rc, rg, rp,
            rx, sh, sl, sr, sw, sz, un, up,  vt, wh, xo, yk, zz,
            ab, ag, bf, bs, by, cc, cp, ct,  dc, dn, dy, el, ez, fd, fk, fp,
            ft, go, hi, it, jp, jz, ld, lg,  lo, nm, np, nu, op, ov, pf, pr,
            rf, sg, sm, sy, tc, th, tp, va,  vd, wd, xc, ys, ze );

  funct   {predefined in virtual compiler machine}

  {debugging operators, output to trace file}
    tron !int;           {turn trace on to specified level}
    troff;               {turn trace off (level=0)}
    trlevel ^int;        {returns current trace level}
    trasci !int;         {inserts a single char in trace; 0=cr}
    trspel !str;         {inserts in trace the string symbol}
    trnmbr !int;         {inserts integer number in trace}
    trhexn !int !int;    {inserts hexdecimal value in trace, n digits}
    ttreedmp !tree;      {dumps entire tree in trace}
    ttabdmp !table;      {dumps symbol table in tabular form}
    ttoptree !tree !int; {top node only, with mark}
    tsetdmp !set;        {dumps set}
    treeflag !tree !int; {marks (and abbreviates) tree in trace}
    trunflag !tree ^int; {removes and returns treeflag, or -1 if none}
    tpremolevel !int;    {sets trace level for premortem}
    ttranslsts;          {show both trans lists}
    tcheckpoint;         {call it often during long processing loops}

  {generated code output operators}
    number !int;   {output decimal value}
    hexnum !int !int;    {output hexdecimal value, n digits}
    ascii !int;    {output a single character, 0=crlf}
      {WARNING: C gets confused by some chars in quoted strings; use ascii} 
    newimage !int;   {allocate memory image buffer spec'd size}
    putat !int !int; {at locn store datum}
    getat !int ^int; {from locn get datum}

  {string table operators}
    initbl;                   {prepare string table to accept a new string}
    addtbl !int;              {add this char to string table}
    charfrom !int !str ^int;  {i,s: char(i) from string (s), 0-based}
    charval ^int;             {ascii value of the character just read}
    stleng !str ^int;         {length of indexed string or ident}
    spell !str;               {output identif'r or string}
    spam !tree;               {equivalent to: treeint!t^i; spell!i}
    strindex !int !int ^str;  {equivclass,dataAttribute>0,index}
      {Adds current string to the string table and returns its index}
    StartScanner !bool;       {restart input (!true), after fake syms}
    uplino !int ^int;         {add to "line count" return new value}
    srctoklinch ^int;         {returns lino*4096+chno of last token}

  {symbol table operators}
    open !table ^table;            {open new table frame (not used by TAG)}
    into !int !table !tree ^table; {add int(name) to table with value tree}
    sinto !str !table !tree ^table; {add int(name) to table with value tree}
    lxinto !int !table !tree !int ^table; {like into, but explicit lex}
    slxinto !str !table !tree !int ^table; {like sinto, but explicit lex}
    from !int !table ^tree;        {get value tree for int(name) from table}
    froms !str !table ^tree;       {get value tree for str(name) from table}
    frmlex !int !table ^tree ^int; {like from, returns also lex level}
    nothere !str !table;           {fails if sinto would fail}
    ixfrom !int !table ^tree ^int ^str;
      {like frmlex, but takes 0-based index, returns also the name}

  {library management functions}
    exportree !str !tree;  {output this tree in re-readable format}
    importree !int ^tree;  {get previously exported tree from Libry file}

  {set operators}
    addset !int !set ^set;      {add integer element to set}
    difference !set !set ^set;  {first - second}
    inset !int !set;            {fails if not}
    intersect !set !set ^set;
    newelt !set ^int;           {returns a value not in the set}
    notinset !int !set;         {fails if int is in the set}
    union !set !set ^set;

  {type changing functions}
    strint !str ^int;
    intstr !int ^str;
    treestr !tree ^str;
    booltree !bool ^tree; 
    inttree !int ^tree;
    settree !set ^tree;
    tabtree !table ^tree;
    treebool !tree ^bool;
    treeint !tree ^int;
    treeset !tree ^set;
    treetab !tree ^table;
    bitand !int !int ^int;
    min !int !int ^int;
    max !int !int ^int;

                                    scanner

equivalent 1           {** Turk is not sposed to be case-sensitive.. **}
  "aA" "bB" "cC" "dD" "eE" "fF" "gG" "hH" "iI" "jJ" "kK" "lL" "mM"
  "nN" "oO" "pP" "qQ" "rR" "sS" "tT" "uU" "vV" "wW" "xX" "yY" "zZ" ;
ignore       {NOTE: scanner vars are global scope; choose names carefully}
  -> " " | ""
  -> "/" "/" (" ".."~")* ""
  -> "/" "*"
     (""..")"|"+".."~" | ("*")* (""..")"|"+".."."|"0".."~"))*
     "*" "/";
ID ^ident:str               {res words:} 1 "abcdefghijklmnopqrstuvwxyz_"
  -> [initbl] ("a".."z"|"A".."Z"|"_") [charval^this][addtbl!this]
     (("a".."z"|"A".."Z"|"_"|"0".."9") [charval^next][addtbl!next])*
     [strindex !1 !1 ^ident];
HEX ^hxval:int
  -> [hxval=0] "0" ("x"|"X") (("0".."9" [charval^this; hxdig=this\16]
        |("a".."f"|"A".."F") [charval^this; hxdig=this\16+9])
      [hxval@=hxval*16+hxdig])+;
NUM ^valu:int
  -> [valu=0] ("0".."9" [charval^this; valu@=valu*10+this-48])+;
CHR ^cval:int
  -> "'" ((" ".."&"|"(".."["|"]".."~") [charval^cval]
         |"\" ("b"  [cval=8]|"t" [cval=9]|"n"  [cval=10]|"r" [cval=13]
       |'"' [cval=34]|"'" [cval=39]|"\" [cval=92]|"0" [cval=0])) "'" ;
STR ^strg:str
  -> [initbl] '"' (("\" ("b" [theC=136]|"t" [theC=137]|"n" [theC=138]
                        |"r" [theC=141]|"z" [theC=127]
                        |'"' [theC=34]|"'" [theC=39]|"\" [theC=92])
       |(" ".."!"|"#".."["|"]".."~") [charval^theC]) [addtbl!theC])*
     '"' [strindex !0 !2 ^strg];
FLT ^fstr:str
  -> [initbl] ("0".."9" [charval^theD; addtbl!theD])+
        ("." [charval^theP; addtbl!theP]
          ("0".."9" [charval^theF; addtbl!theF])+
          (("e"|"E") [charval^theE; addtbl!theE]
           ("0".."9" [charval^theX; addtbl!theX])+ )?
        |("e"|"E") [charval^theG; addtbl!theG]
         ("0".."9" [charval^theN; addtbl!theN])+ )
     [strindex !0 !3 ^fstr];

                                     parser

Turk2C
  -> TreeNoZe   [trlevel ^ibdg; tron !0; cosym=vacant; howBig=0; Dbits=0]
     [theTr=<>; nimps=0; intstr !0 ^expname; passs=true; pkg=<>]
     [newimage !8; putat !0 !0]  {0: >0 if \n needed; 1: segment#}
       {2: _tmp_1K_ var#; 3: allocated _tmp_n_ var bits}
     ([importree !0 ^ipkg; ipkg:<pk lnk bod itrs >; treeflag !itrs !4]
      [treetab !itrs ^Isym; from !-7 !Isym ^mntr]
      [from !1 !Isym ^tr1; treeflag !tr1 !1]
      [from !2 !Isym ^tr2; treeflag !tr2 !2]
      [from !3 !Isym ^tr3; treeflag !tr3 !3]
      [from !7 !Isym ^tr7; treeflag !tr7 !0]
      mntr:GetStrDec ^main
     |BuiltinTypes !vacant ^Bsym ^main
      [into !-1 !Bsym !<> ^ysym; into !-5 !ysym !<fn <>>%4 ^wsym]
      [into !-11 !wsym !<no <>> ^uusym; into !-12 !uusym !<no <>> ^usym]
      [into !-9 !usym !<tp <> <>> ^xsym; into !-7 !xsym !<nm <>>%main ^Isym])
     [StartScanner !true; ename=main; danger=false]
     [tables=<tc <> <>>]  TrueFalSym !tables !Isym ^Zsym
     [tabtree !Zsym ^ZsymT; treeflag !ZsymT !10; troff]
         ("?" [tron !2; trasci !199; trnmbr !0; ttabdmp !Zsym]
              [trnmbr !0; trasci !200])? {0}
         {[tron !ibdg]}  ("!" [troff])?
     ("package" [//"Package name expected"//]
       Identifier ^ident
       [expname@=ident; //"Missing semicolon"//] ";")?
((NUM ^Dnum |HEX ^Dnum)  [Dbits@=Dnum])?
           TraxOff !Dbits ^Tr0
           TraceIff !0 !Tr0 !<> !Zsym
     ["/* C code generated by Turk compiler -- DO NOT MODIFY */"; ascii !00]
     (STR ^ProgName |[otherwise; intstr !0 ^ProgName])
     (Zstring !expname
      [into !-10 !Zsym !<nm <no>>%ProgName ^Msym]
      [into !-13 !Msym !<nm <>> ^udsym]
      [open !udsym ^symti; into !-2 !symti !<no> ^symtb]
     |[otherwise; symtb=Zsym])
           TraxOff !Dbits ^Tr1
           TraceIff !1 !Tr1 !<> !symtb
     [strint !ProgName ^nmsp]
     {----------------------------------------------------------}
     ( [passs=true; open !vacant ^osym; into !-1 !osym !<> ^vsym]
       [adrt=<lc <gl>>; into !-4 !vsym !adrt ^ssym; passs@=false]
       adrt:UpdateLoc !-33 ^xxloc              {start of globs: -128[A5]}
       (ImportDecln !Dbits !symtb !theTr ^theTr@ ^symtb@ )*
       CheckLn !false
       ["#include "; ascii !34; "TurkFrame.h"; ascii !34]
       EndLn !false !true
       [ascii !00; putat !1 !0]
       ([from !19 !symtb ^prox; danger@=true])?
       ([nmsp#0; "namespace _"; spell !ProgName; "_ { // _"]
        [spell !ProgName; "_::xxx"]  {; ascii !00; "#define _glob_var_ "]}
        {([danger=false; "(("; spell !ProgName; "*)(myframe->_my_prog_))->"]}
        [ascii !00; ascii !00; "int* _tmp_0_; int* _tmp_00_;"; ascii !00]
        ["int __aix__, __aiy__, __aiz__;"; ascii !00]
        { ["!class "; spell !ProgName]}
        { [": public _T2F_Process_ }{public: "; spell !ProgName]}
        { ["(Char4 id);"; ascii !00; "$  }{; // ~"; spell !ProgName]}
        {|[otherwise; putat !1 !-1])}
        EndLn !false !true )?
       [tabtree !symtb ^symtt; tabtree !ssym ^ssymt; intstr !0 ^zs]
       [treeflag !symtt !9; treeflag !ssymt !6; treeflag !theTr !4]
           TraxOff !Dbits ^Tr2
           TraceIff !2 !Tr2 !theTr !symtb
       (CopySyms !false !ssym !symtb ^glosym
        MemberDecl !<> !zs !glosym !ssym !theTr !0 ^nuTre ^ssyms ^ename@ ^iniz
        [ssym@=ssyms; theTr@=nuTre; treeflag !nuTre !4]
        [tabtree !ssyms ^tssym; treeflag !tssym !6]
           TraxOff !Dbits ^Tr3
           TraceIff !3 !Tr3 !theTr !ssyms )*
       [cosym@=ssym; troff]
           {normally [troff] thru OptimizeTre, unless Dbits=16}
           TraxOff !Dbits ^Tr4
           TraceIff !4 !Tr4 !<> !vacant
       (Zstring !expname
        [trasci !42; trspel !main; trasci !42; trasci !0] {*main*}
       |[otherwise; //"Can't finish package "; spell !expname//]
        [tabtree !ssym ^sympk; npkg=<pk <> sympk <>>%expname]
         [trasci !0; trasci !42; trspel !expname; trasci !42; trasci !0]
         [tron !2]
         [sinto !expname !Isym !npkg ^pksym; tabtree !pksym ^pksymt]
         npkg:InsertStuff !pksymt {npkg=<pk}
         [Isym@=pksym; pkg@=npkg; into !-6 !pksym !tables ^symtb@]
         ("package" [//"Another package name expected"//]
           Identifier ^ident
           [passs@=true; expname@=ident; theTr@=<nc theTr pkg >]
           [//"Semicolon??"//] ";")? ) [troff] )*
     {----------------------------------------------------------}
     [//"Missing period at end of file,";
         " or brace mismatch in "; spell !ename//]  "."
     EndLn !false !true
     TreeNoZe
           TraxOff !Dbits ^Tr6
           TraceIff !6 !Tr6 !theTr !symtb
     ([nmsp#0]
      ([danger=false & 1=0; spell !ProgName; "::"; spell !ProgName]
       ["(Char4 id) { // cons.."; ascii !00; "  T2F_Init(id,String("]
       [ascii !34; spell !ProgName; ascii !34; "));"; ascii !00]
       ["  _exec_stack_ = "]
       (Zstring !expname  ["new "; spell !ProgName; "_main"])?
       ["(NULL);"; ascii !00; "  _exec_stack_->_my_prog_ = this;}"])?
      ([from !-13 !symtb ^udlst; ascii !00]  udlst:UndefThese !false )?
      {[ascii !00; "#undef _glob_var_"; ascii !00; ascii !00]}
      [" } // (end namespace _"; spell !ProgName; "_)"; ascii !00; ascii !00]
      ([danger=false]
       ["/* --- DELETE THIS LINE IN MAIN PROCESS, move next line to front"]
       [ascii !00; "char* ProgramName = "; ascii !34; spell !ProgName]
       [ascii !34; ";"; ascii !00]

       ([from !-10 !symtb ^nmlst; ascii !00]
        ["DWORD StartNewProg(void* whom) {"; ascii !00]
        ["  Process thePro = (Process)whom;"; ascii !00]
        ["  String prName = GetProgName(thePro);"; ascii !00]
        StartupCaller !true !ProgName
        StartupCaller !false !ProgName
        {["Process NewProgram(String prName, File dir, Char4 pnm4) }{"]}
        {[ascii !00; "  pnm4 = Unique_ProcessID(pnm4);"; ascii !00]}
        {["  if (prName == "; ascii !34; spell !ProgName; ascii !34]}
        {[") return new _"; spell !ProgName; "_::"; spell !ProgName; "(pnm4)"]}
        {EndLn !true !true}
        nmlst:StartupNames !ProgName
        ["  return 0;}"; ascii !00])?
        {["  return NULL;}{"; ascii !00])?}

       ["// */"; ascii !00])?)?
           TraxOff !Dbits ^Tr12
           TraceIff !12 !Tr12 !<> !vacant   {4096 traces CallTree/export}
     (Zstring !expname [from !-5 !symtb ^fnot]
       [from !-6 !symtb ^tbls; from !7 !symtb ^void]
       TrueFalSym !tbls !symtb ^zzsym
       [//"There is no 'void main()'"//; froms !main !cosym ^mproc]
       [ascii !0]
     |[otherwise; from !-7 !symtb ^mnm]  mnm:InsertStuff !<>  {mnm=<nm}
      [exportree !expname !pkg]  TreeSee !pkg )
     [ascii !0]
     TreeNoZe ;  {~Turk2C}

{a compilation unit consists of any number of imports,
   followed by any number of type declarations (essentially classes).}

TraxOff !enables:int ^rebits:int {[troff] in prep for TraceIf}
  -> [enables+2=0; rebits=enables]
  -> [trlevel ^trlo; rebits=trlo*65536+enables; troff]
     ([enables>32768; rebits@=trlo*65536])? ;

TraceIff !tagID:int !enables:int !theTr:tree !theTab:table
    {to leave trace on starting at n, encode 2^n+16384 before import}
  -> [enables+2=0; tron !2]                {-2 leaves it on permanently}
  -> [enables\65536>0]  Exp2Bit !tagID ^abit
     [bitand !abit !enables ^test; test>0; tron !2]
       ([theTr#<>; trasci !199; trnmbr !tagID; ttreedmp !theTr]
        [trnmbr !tagID; trasci !200; trasci !0])?
       ([theTab#vacant; trasci !199; trnmbr !tagID; ttabdmp !theTab]
        [trnmbr !tagID; trasci !200; trasci !0])?          {n..n}
     [bitand !enables !32768-abit-abit ^lvo]
     ([lvo=16384 ` theTr=<>&theTab=vacant]
     |[tron !(enables/65536)\16])
  -> [tron !1; trasci !199; trnmbr !tagID; trasci !200] {n}
     [tron !(enables/65536)\16] ;

Modifier ^amod:int             {=0 if this mod'r has no effect}
  -> "public"       [amod=1]
  -> "protected"    [amod=2]
  -> "private"      [amod=4]
  -> "static"      [amod=16]
  -> "abstract"    [amod=32]
  -> "final"       [amod=64]
  -> "native"     [amod=128]
  -> "synchronized" [amod=8]
  -> "transient"    [amod=0]
  -> "volatile"     [amod=0]
  -> "strictfp"     [amod=0] ;

ImportDecln !Dbits:int !insym:table !intree:tree ^outree:tree ^outsym:table
  -> "import"  ("?" [tron !5])?  Identifier ^idn
      [//"Undefined package "; spell!idn//; froms !idn !insym ^vtree]
      [trlevel ^trlo; //"Package name expected for "; spell!idn//;
        vtree:<pk lnk symtt ..>; treetab !symtt ^symtb;
        {midtree=<pk intree symtt <>>; midsym=insym; mor=true; nxs=0;}
        midtree=intree; midsym=insym; mor=true; nxs=0;
        treeflag !midtree !11; bitand !Dbits !256 ^ntro]
      ("." ("*" |[mor@=false; //"Import what from "; spell!idn; "?"//]
        Identifier ^idx 
        [//"Can't import "; spell!idx; " from package "; spell!idn//]
        [froms !idx !symtb ^vtx; sinto !idx !midsym !vtx ^midsym@] ))?
      ([mor=true; ixfrom !nxs !symtb ^theTree ^lexn ^snam; nxs@=nxs+1]
           TraxOff !Dbits ^Tr8
           TraceIff !8 !Tr8 !<> !midsym
         ([strint !snam ^inam; inam>18; //"Can't import "; spell!snam;
            "from package "; spell!idn//]
          [slxinto !snam !midsym !theTree !-1 ^midsym@] )? )*
      [lxinto !0 !midsym !<> !0 ^outsym; outree=<nc midtree <>>]
           TraxOff !Dbits ^Tr9
           TraceIff !9 !Tr9 !outree !outsym
      ([from !19 !outsym ^dang; from !-7 !insym ^mnm]
        mnm:InsertStuff !dang     {mnm=<nm}
      | CheckLn !false
        ["#include "; ascii !34; spell !idn; ".h"; ascii !34]
        EndLn !false !true )
      [//"Semicolon expected"//]  ";" ;

{classes and new types... }

QualIdent !zOK:int !mOK:int !symtb:table !insym:table !axes:tree ^tname:str
       ^vname:str ^vtree:tree ^theTy:tree ^mods:int ^loval:int ^hival:int
   {lookup vars & .flds in insym, types & [] in symtb; nobody uses loval/hi}
   {parses (mods)name(.name|[..])*; axes is access tree, return vtree}
   {returns vtree+loval+hival if it's a left-expn or const, else vtree=<>}
   {mOK>=0 parses thru decln type, >0 allows those mods, +4K allows []}
   {mOK<0 parses full left-expn[] (no declns); mOK +8K does either}
   {vname is name of var, or =0; tname is name of type, or =0}
   {tname is used to name o'loaded funcs; loval,hival if const/expn}
  -> Modifier ^amod
     ([mOK=-1`mOK=16383; amod=2`amod=64; from !19 !symtb ^prox; nod=mOK]
     |[otherwise; bitand !mOK !amod ^xmod]
      [//"Inappropriate or duplicated modifier"//; xmod>0&mOK>0]
      [bitand !mOK-amod !8191 ^nod])
     QualIdent !zOK !nod !symtb !insym !axes ^tname ^vname ^vtree
       ^theTy ^modx ^loval ^hival            [mods=modx+amod]
  -> "void" [//"Type void inappropriate here"//; mOK>-1]
      [from !7 !symtb ^theTy; mods=0; loval=0; hival=-1; intstr !0 ^vname]
      [theTy:<ty ..>%pnam; treestr !pnam ^tname; vtree=<>]
  -> ("this"|"super")  [//"'this' is not defined yet"//]
        {** think about how these work later, when we add OOPS **}
      [from !-1 !insym ^theTy; mods=0; loval=0; hival=-1]
      [theTy:<ty ..>%pnam; treestr !pnam ^tname; intstr !0 ^vname]
      [from !14 !symtb ^par; froms !tname !insym ^vtree]
  -> Identifier ^idn  [mods=0; bitand !mOK !4096-16384 ^aOK] {=0 if no []}
      [bitand !mOK !-8192 ^eOK] {=0 if must be a type}
      ([froms !idn !insym ^whom]
      |[//"Undefined name "; spell !idn//; mOK>-1; froms !idn !symtb ^whom])
      ([whom:<vr lnk typ info adr ..>; intstr !0 ^tname; vname=idn]
        [//"Unexpected variable instead of type"//; eOK#0]
        ([axes=<>; access=whom]|[otherwise; access=<nm axes >%idn])
        whom:GetItsType ^clsym ^theTy ^loval ^hival
        IsPointer !theTy ^nwd ^isPt ^iniz ^stf
        ("." [//"This is not a class type"//; clsym#vacant]
          theTy:IsObject ^amod ^nod ^ety ^osym
          ([ety:<cl ..>; axess=access]
            ([isPt=true; axess@=<un <dr axess >%1 stf >])?
          |[otherwise; axess=<dr access >%1])
          QualIdent !zOK !-1 !symtb !clsym !axess
            ^tname@ ^vname@ ^access@ ^theTy@ ^modx ^loval@ ^hival@
        |[eOK#0] "[" [//"This is not an array type"//]
          theTy:ArrayBounds ^outyp ^rnty ^hix ^esiz
          [//"Compatible index expression expected here"//]
          Expressn !symtb ^expn ^ety ^lov ^hiv
          [//"Badly formed index expression (or missing ']')"//] "]"
          [//"Incompatible array index type"//]
          [theTy:<ty lnx siz <ar ixty  ..>>]
          Comparable !false !symtb !ixty !ety ^rty ^conv   [conv=0]
          ([hix<0; axess=<dr access >%nwd]|[axess=access])
          ([isPt=true; axess@=<un axess stf >])?
          IsIntger !zOK !symtb !outyp ^ixtx
          [access@=<ax axess expn rnty ixtx >%esiz]
          outyp:GetItsType ^clsym@ ^theTy@ ^loval@ ^hival@ )*
        [vtree=access]
      |[eOK#0; whom:<tc lnx <ty lnx siz <ar ixty elty ..>> elts >]
        whom:GetItsType ^clsym ^theTy ^loval ^hival
        [vtree=whom; outyp=theTy]
        (theTy:ArrayBounds ^ztyp ^rnty ^hix ^esiz  "["
         [outyp@=elty; //"Compatible table index expn expected"//]
         Expressn !symtb ^expn ^ety ^lov ^hiv
         [//"Badly formed table index (or missing ']')"//] "]"
         [intstr !0 ^tname; vname=idn]
         [//"Incompatible table array index type"//]
         Comparable !false !symtb !ixty !ety ^rty ^conv     [conv=0]
         ([from !19 !symtb ^dang]|[otherwise; dang=<>])
         ([dang=<>; lov=hiv; elts:<tc ..>]
          elts:GetTblCon !lov ^deco ^nwd ^tctr
          [//"Table index out of bounds"//; lov>-1 & hiv<hix+1]
          ([tctr=<>; tctr@=<cn>%nwd])?
          [loval@=nwd; hival@=nwd; theTy@=elty; vtree@=tctr]
         | IsIntger !zOK !symtb !elty ^ixtx
          [vtree@=<ax whom expn rnty ixtx >%esiz]
          outyp:GetItsType ^clsym@ ^theTy@ ^loval@ ^hival@ ))?
      |[whom:<cl ..>; intstr !0 ^vname; intstr !0 ^tname]
        QualCls !whom !symtb !idn !mOK !aOK ^tname ^vname ^vtree
           ^theTy ^loval ^hival
      |[whom:<ty ..>]
        QualCls !whom !symtb !idn !mOK !aOK ^tname ^vname ^vtree
           ^theTy ^loval ^hival
      |[//"Type name expected, possibly missing '}'"//; eOK#0;
                               vtree=whom; tname=idn; intstr !0 ^vname]
        whom:GetItsType ^clsym ^theTy ^loval ^hival ) ; {~QualIdent}

QualCls !whom:tree !symtb:table !idn:str !mOK:int !aOK:int
       ^tname:str ^vname:str ^vtree:tree ^theTy:tree ^loval:int ^hival:int
  -> [whom:<cl lnx typ sup elx psym ..>]
        ("." [treetab !psym ^clsym; bitand !mOK !-4096 ^esiz]
          ("&" [//"Dangerous '&' offset"//; from !19 !symtb ^dang]
            [//"Field name expected here"//]  Identifier ^vname
            [froms !vname !clsym ^expn; expn:<vr lnk rty info adr ..>]
            adr:GetDecor ^deco
            [vtree=<cn >%deco; intstr !0 ^tname]
            [loval=deco; hival=deco; from !1 !symtb ^theTy]
          |QualIdent !0 !esiz !vacant !clsym !elx
              ^tname ^vname ^vtree ^theTy ^modx ^loval ^hival )
        |[//"Class name inappropriate here"//; mOK>-1]
          [tname=idn; vtree=<>; intstr !0 ^vname]
          whom:GetItsType ^clsym ^theTy ^loval ^hival
          ([aOK>0] "["  Unbounded ^loval@ ^hival@
           ArrayType !symtb !tname !0 !<> !theTy ^tname@ ^theTy@ )* )
  -> [whom:<ty lnx siz <pt clss > ..>]
       QualCls !clss !symtb !idn !mOK !aOK ^tname ^vname ^vtree
          ^theTy ^loval ^hival
       (theTy:IsObject ^deco ^esiz ^rty ^clsym  [theTy@=whom])?
  -> [whom:<ty ..>; theTy=whom]
       [//"Type name inappropriate here"//; mOK>-1]
       [tname=idn; vtree=<>; intstr !0 ^vname]
        theTy:GetTypeRange ^rnty ^loval ^hival
        ([aOK>0] "["  Unbounded ^loval@ ^hival@                 {~QualCls}
           ArrayType !symtb !tname !0 !<> !theTy ^tname@ ^theTy@ )* ;

ArrayType !symtb:table !intnam:str !nelts:int !ixTy:tree !inTy:tree
       ^outnam:str ^ouTy:tree
  -> [nelts#0; arty=<ar ixTy inTy <>>]   inTy:TypeSize !false ^tsiz
     ([nelts<0; nwds=1]             NewIdent !intnam !1 ^outnam
     |[otherwise; nwds=nelts*tsiz]  NewIdent !intnam !-nelts ^outnam )
     [ouTy=<ty <> <sz>%nwds arty >]
     arty:InsertStuff !ouTy {arty=<ar}           {dyn array range type..}
  -> [nelts=0]  "]"  [from !1 !symtb ^ity; ity:<ty nxty ..>]
     ArrayType !symtb !intnam !-1 !nxty !inTy ^outnam ^ouTy
  -> [from !1 !symtb ^ity; //"Expected integer array size or ']' here"//]
     ConstExpn !false !symtb ^vtree ^ity ^nwds
     [//"Array size must be >0"//; nwds>0]
     [//"Missing ']' (or bad array size value)"//]  "]"
     [nxty=<ty <> <sz>%1 <rn <cn>%0 <cn>%nwds-1 ity >>]
     ArrayType !symtb !intnam !nwds !nxty !inTy ^outnam ^ouTy ;

MemberDecl !prnt:tree !tnam:str !symtb:table !insym:table !intree:tree
       !mods:int ^outree:tree ^outsym:table ^theName:str ^iniz:tree
   {look types up in symtb, build outsym on insym} {prnt=<> or <cl ..>}
  -> ";" [outsym=insym; outree=intree; theName=tnam; iniz=<>]
     ([mods=128; modz=-1]|[otherwise; modz=0])
     ([prnt=<>; from !19 !symtb ^prox; putat !1 !modz]  SeeNum !modz )?
  -> ("?" [tron !2] | "!" [troff])   {debugging trace on/off}
     [outsym=insym; outree=intree; theName=tnam; iniz=<>]
  -> [mods=0]  Modifier ^modz
     MemberDecl !prnt !tnam !symtb !insym !intree !modz
         ^outree ^outsym ^theName ^iniz
  -> ClassDecln !prnt !symtb !insym !intree !mods ^outree ^outsym
      [theName=tnam; iniz=<>]
  -> QualIdent !0 !8191-mods !symtb !insym !<>       {type required}
         ^idn ^vnm ^vtr ^cTy ^modz ^lox ^hix  {fails clean if not an ident}
     CheckLn !false
     ([cTy=prnt]   MethodRest !prnt !tnam !mods+modz   {--constructor--}
        !idn !cTy !symtb !insym !intree ^fntree ^outree ^outsym
      [theName=tnam; iniz=<>]
     |[//"Member (type/variable/function) name expected here"//]
      Identifier ^theName   {now, so MethodRes can fail clean if no "("}
      (MethodRest !prnt !tnam !mods+modz !theName !cTy !symtb !insym
          !intree ^fntree ^outree ^outsym   [iniz=<>]
      |[//"Global variables must precede methods"//]  intree:NoFun
       VarDecln !prnt !theName !mods+modz !cTy !symtb !insym !intree
           ^outree ^outsym ^iniz
       [//"Invalid declaration or missing semicolon ';'"//] ";" ))
  -> [mods=128; from !19 !symtb ^prox]  STR ^cdst
     [spell !cdst; ascii !00]
     [//"Semicolon ';' needed here"//] ";"
     [outsym=insym; outree=intree; theName=tnam; iniz=<>] ;

ClassDecln !prnt:tree !symtb:table !insym:table !intree:tree !mods:int
       ^outree:tree ^outsym:table
          {look types up in symtb, build outsym on insym}
  -> ("class" | "type")                {can be "native", for no code}
     Identifier ^cnam
     [//"Class or type must precede methods"//]  intree:NoFun
     ClassTypeRest !prnt !mods !cnam !symtb !insym !intree ^outree ^outsym ;

ClassTypeRest !prnt:tree !mods:int !tnam:str !symtb:table !insym:table
       !intree:tree ^outree:tree ^outsym:table
          {look types up in symtb, build outsym on insym}
  -> ";" [//"Opaque type "; spell !tnam; " is already defined here"//; 
       sinto !tnam !insym !<ty <> <sz>%1 <>>%tnam ^outsym; outree=intree]
     CheckLn !false
     ([mods<128; "#define "; spell !tnam; " int // opaque class type"]
      UndefineThis !symtb !tnam )?
     EndLn !false !true
  -> "=" NewType !symtb !insym !tnam !intree ^theTy ^outree ^tsym
     [//"Type name "; spell !tnam; " is already defined here"//; 
       sinto !tnam !tsym !theTy ^outsym]
     CheckLn !false
     ([mods<128; "typedef "] theTy:TypeSpell [" "; spell !tnam]
       EndLn !true !false )?
     [//"Missing semicolon ';' on type declaration"//] ";"
  -> CheckLn !false   EndLn !false !true    [natv=true]
     {([from !19 !symtb ^prox; natv=true]|[otherwise; natv=false])}
     ([mods<128]   ([natv=false; "+"; ascii !00; "+"])?
      ["struct _"; spell !tnam; "_; typedef _"; spell !tnam;
           "_* "; spell !tnam]    EndLn !true !true )?
     ("extends" TypeName !symtb ^theTy ^theName
      [locOK=true; //spell !theName; " is not an extendable class type"//]
      theTy:IsObject ^tname ^siz ^pty ^psymb
      [par=<up>%theTy; root=<ot>]  {** also gotta check for not final **}
      ([mods<128; "struct _"; spell !tnam; "_: _"; spell !theName; "_ {"]
        EndLn !false !true )?
     |([mods<128]   ([natv=false; "+"])?
       ["struct _"; spell !tnam; "_ {int _00_,_000_"] EndLn !true !false )?
      [locOK=true; par=<>; psymb=vacant; siz=0; root=<ot>])
     [ptr=<pt <>>; ctyp=<ty <> <sz>%1 ptr >%tnam; bitand !mods !128 ^modz]
     ([locOK=true; rtyp=<ty <> <sz> <>>%tnam]
     |[otherwise; rtyp=ctyp])
     [clss=<cl <> rtyp par <> <> <sz>>%tnam]
     ([locOK=true]  rtyp:InsertStuff !clss )?   {rtyp=<ty}
     ptr:InsertStuff !clss  {ptr=<pt}
     ([nothere !tnam !insym; sinto !tnam !insym !ctyp ^outsym]
     |[//"Class name "; spell !tnam; " is otherwise defined"//]
      [froms !tnam !insym ^xty; xty:<ty plk psz <>>; outsym=insym]
      xty:InsertStuff !ptr )  {xty:<ty}
     [open !psymb ^classy; into !-1 !classy !clss ^tsym; body=<>]
     [adrt=<lc root >%siz; into !-4 !tsym !adrt ^clasym; inip=<>]
     CopySyms !false !outsym !symtb ^glosym  {new class needs visible..}
     ([nothere !tnam !glosym; sinto !tnam !glosym !ctyp ^glosym@])?
     "{" (MemberDecl !clss !tnam !glosym !clasym !body !modz
              ^body@ ^clasym@ ^xname ^iniz   {propagate "native" inside}
           ([iniz=clss]|[otherwise; inip@=<nc inip iniz >]))*
     [//"Malformed class member or missing close brace '}'"//] "}"
     ("~" [//"This brace closes class "; spell !tnam//] ID^tnam )?
     [tabtree !clasym ^clasyt; treeflag !clasyt !5; outree=intree]
     adrt:UpdateLoc !0 ^nlocs
     ([locOK=true]  rtyp:Resize !nlocs )?
     ([mods<128]   CheckLn !false   ([natv=false; "+"])?
      ["  _"; spell !tnam; "_() { /* _00_ = "; number !nlocs; "; */ "]
      ["set_ary_size((void*)this,"; number !nlocs; ");"]
      ([inip=clss]  EndLn !false !false
      |inip:PreCodeTree !symtb   inip:GenTreeCode !1 !0 ["  "])
      ["}}"]  EndLn !true !true
      ([natv=false; "+"])?  EndLn !false !true )?
     clss:ClassParts !body !clasyt !nlocs ; {~ClassTypeRest}

NewType !symtb:table !insym:table !tnam:str !intree:tree ^theTy:tree
       ^outree:tree ^outsym:table
          {look types up in symtb, build outsym on insym}
  -> "{" [idx=0; lst=<>; theTy=<ty <> <sz>%1 <>>%tnam; outsym=insym]
     ([//"Comma-delimited list of names expected"//]
      Identifier ^idn [cval=<dc lst theTy <cn>%idx >%idn]
      [//"Constant name "; spell !idn; " is already defined"//; 
        sinto !idn !outsym !cval ^outsym@; lst@=cval; idx@=idx+1])$","
     [//"Right brace expected at end of enum constant list"//] "}"
     ("~" [//"This brace closes enum "; spell !tnam//] ID^tnam )?
     theTy:InsertStuff !lst  {theTy=<ty}  ([idx>255] theTy:Resize !2 )?
     [outree=intree; //"** enums not implemented **"//; 0=1]
  -> "[" [//"Subrange lower bound constant expected here"//]
     ConstExpn !false !symtb ^vtree ^exty ^intval
     [//"Subrange '..' expected here"//] ".."
     [//"Second constant value required for subrange"//]
     ConstExpn !false !symtb ^vtr2 ^ty2 ^val2
     [//"Subrange bounds must be same type"//; exty=ty2]
     [//"Subrange bounds out of order"//; intval<val2]
     [//"Missing ']' or badly formed subrange bound"//] "]"
     [theTy=<ty <> <sz>%1 <rn <cn>%intval <cn>%val2 exty >>%tnam]
     [outsym=insym; outree=intree; //"** range not implemented **"//; 0=1]
  -> aType !symtb ^theTy  [outsym=insym; outree=intree]; {~NewType}

NativeCodeQ ^natv:bool  -> [getat !1 ^doing; natv=true]; {(doing<0)}

NewBlockNum ^bkno:int
  -> [bkno=0]
  -> [getat !1 ^doing; doing<0; bkno=0]
  -> [getat !1 ^doing; bkno=doing+1; putat !1 !bkno]; {~NewBlockNum}

FunNameSpell !idn:str !symtb:table ^ismain:bool
  -> Zstring !idn
     [from !-3 !symtb ^progNm]  progNm:GetDecor ^fnam
     [intstr !fnam ^mane]       FunNameSpell !mane !symtb ^ismain
  -> [from !-7 !symtb ^mnNm; mnNm:<nm ..>%mnmt; treestr !mnmt ^mane]
     [mane=idn; from !-10 !symtb ^progNm; progNm:<nm ..>%pnmt; pnmt#<>]
     [treestr !pnmt ^pnms; spell !pnms; "_"; spell !idn; ismain=true]
  -> [spell !idn; ismain=false]; {~FunNameSpell}

GoToBlock !noret:bool !bkno:int !symtb:table
  -> [doing=0]
  -> [getat !1 ^doing; doing<0]
  -> CheckLn !true     ([noret=false; "{"])?
     [intstr !0 ^clfn; "myframe->_my_state_ = &_"]
     FunNameSpell !clfn !symtb ^ismain
     ["_0"; number !bkno; "_"]
     ([noret=false; "; return mystakframe;}"])?
     EndLn !noret !true ; {~GoToBlock}

StartBasicBlock !bkno:int !symtb:table
  -> [doing=0]
  -> [getat !1 ^doing; doing<0]
  -> [from !-3 !symtb ^fntree; intstr !0 ^clfn]    CheckLn !true
     ["return mystakframe;}"; ascii !00; "<class _"]
     FunNameSpell !clfn !symtb ^ismain   ["_"; number !bkno]
     ["_: public _T2F_Exec_ {public:"; ascii !00]
     ["<  _T2F_Stack_* _do_it_(_T2F_Stack_* mystakframe);} _"]
     FunNameSpell !clfn !symtb ^izmain
     ["_0"; number !bkno; "_;"; ascii !00; ascii !00; "_T2F_Stack_* _"]
     FunNameSpell !clfn !symtb ^mainix  ["_"; number !bkno]
     ["_::_do_it_(_T2F_Stack_* mystakframe) {"; ascii !00; "  "]
     FunNameSpell !clfn !symtb ^mainiz  ["* myframe = ("]
     FunNameSpell !clfn !symtb ^mainis  ["*)mystakframe"]
     EndLn !true !true ; {~StartBasicBlock}

MethodRest !prnt:tree !tnam:str !mods:int !idn:str !rtyp:tree !symtb:table
       !insym:table !intree:tree ^fntree:tree ^outree:tree ^outsym:table
          {look types up in symtb, build outsym on insym}
  -> "("  ([froms !idn !insym ^fnt]|[fnt=<>])               {fails if not}
     [putat !3 !0; putat !4 !0]
     ([mods<160]  CheckLn !false   EndLn !false !true )?
     ([mods>127`true; segd=false; putat !1 !-1]     {"native" = native code}
      {[//"Native code is Dangerous"//; from !19 !symtb ^prox]}
      ([mods<160]  rtyp:TypeSpell  [" "]  {"abstract native" omits gen code}
       FunNameSpell !idn !symtb ^ismain  ["("]
      |[otherwise; ismain=false])
     |[otherwise; putat !1 !0; putat !2 !0; ">class _"]
      FunNameSpell !idn !symtb ^ismain
      ["_0_: public _T2F_Exec_ {public:"; ascii !00; segd=true]
      ["<  _T2F_Stack_* _do_it_(_T2F_Stack_* mystakframe);} _"]
      FunNameSpell !idn !symtb ^izmain   [ "_00_;"]
      [ascii !00; ascii !00; "!class "]  FunNameSpell !idn !symtb ^mainiz
      [": public _T2F_Stack_ {public:"; ascii !00; "$  "]
      FunNameSpell !idn !symtb ^mainix
      ["(_T2F_Stack_* myframe"; ascii !00; "%      ) { // "]
      FunNameSpell !idn !symtb ^mainxx   [" constructor.."; ascii !00]
      ["%    _my_state_ = &_"]   FunNameSpell !idn !symtb ^mainxi
      ["_00_;"; ascii !00; "%    _up_link_ = myframe;"; ascii !00]
      ([ismain=true; "%    _my_prog_ = NULL"]
      |[otherwise; "%    _my_prog_ = myframe->_my_prog_"])
      EndLn !true !true )
        {"!" bgn; "-" frame var declns; "$" cons'tor head; "%" cons body}
        {"+" goes before bgn line}
        {"<" lines slide back to be immediately after most recent ">"}
     MethodHeader !prnt !fnt !tnam !mods !idn !rtyp !symtb !insym !intree
         !segd !ismain ^fntree ^outree ^prmsym ^outsym
     ([mods<160]  {"abstract native" omits gen code}
      ([segd=false; ")"]
      |[otherwise; "  } }; //~"]  FunNameSpell !idn !symtb ^mainzi
       [ascii !00; ascii !00; "_T2F_Stack_* _"]
       FunNameSpell !idn !symtb ^mainsi
       ["_0_::_do_it_(_T2F_Stack_* mystakframe) {"; ascii !00; "  "]
       FunNameSpell !idn !symtb ^mainis   ["* myframe = ("]
       FunNameSpell !idn !symtb ^mainii   ["*)mystakframe"])
      EndLn !segd !true )?
     (";" [//"We don't do fwd functs yet"//; segd=false] 
       ([mods<160] EndLn !true !true )?
     |[adrt=<lc <>>%-1; into !-4 !prmsym !adrt ^hedsym; strint !idn ^nidn]
      ([ismain=true; usym=hedsym]  TreeSee !adrt {getting bogus ismain=true?}
      |[otherwise; into !-11 !hedsym !<no <>> ^usym])
      [into !-3 !usym !fntree ^bodsym; tabtree !bodsym ^bodst]
      [treeflag !bodst !7; //"Method body (or ';') expected here"//]
      Blocks !fntree !bodsym !true !<> !nidn ^bodtree ^comesout ^bsym
        {if nidn=main, Block also calls GlobArrayInit}
      rtyp:TypeSize !false ^tsz
      [//"Return required for function value"//; tsz=0`comesout=false]
      [fntree:<fn lnk sgn fnbod ..>; sgn:<xf rtyp pms nloct ..>]
      [//"Function "; spell !idn; " is already defined"//; fnbod:<fn <> ..>]
      ([segd=true]
       GoToBlock !true !99999 !bsym
       StartBasicBlock !99999 !bsym
       ([ismain=true; from !-12 !bsym ^stzp]  stzp:StringArrayZaps )? )?
      sgn:InsertSyms !bsym
      fnbod:InsertStuff !bodtree  {fnbod=<fn <> <>>}
      adrt:UpdateLoc !0 ^nlocs  {the entry number = # locvars, +1 extra}
      nloct:Decorate !nlocs      {nloct:<nn>}
      {([ismain=true&comesout=true&segd=false;"  Quit();";ascii!00])?}
      ([segd=true; "  mystakframe = myframe->_up_link_;"; ascii !00]
       ["  delete myframe; return mystakframe;} //~"]
       FunNameSpell !idn !symtb ^iimain )?
      ([mods<160]  EndLn !false !true )? );  {~MethodRest}

MethodHeader !prnt:tree !fnt:tree !tnam:str !mods:int !idn:str !rtyp:tree
   !symtb:table !insym:table !intree:tree !segd:bool !ismain:bool ^fntree:tree
        ^outree:tree ^bodysym:table ^outsym:table   {** ignore modifiers **}
          {inherit symtb into bodysym, build outsym on insym}
  -> ([fnt=<>; sgn=<xf rtyp <> <nn> <no <>> <> <>>]
         { <xf rtnty pmlst <nn>%nlocvs ptrlst namstr bodysym >%npms }
      ([intree:<fn ..>; dclns=intree]|[otherwise; dclns=<df intree >])
      ([segd=true; uptr=<up>%prnt]|[otherwise; uptr=<fp>%prnt])
      [fnbod=<fn <> <>>; fntree=<fn dclns sgn fnbod uptr >%idn]
      fnbod:InsertStuff !fntree  {fnbod=<fn <> <>>}
      [outree=fntree; //"Function "; spell !idn; " is already defined"//]
      [sinto !idn !insym !fntree ^midsym; sinto !idn !symtb !fntree ^opsy]
     |[midsym=insym; fnt:<fn lnk sgn ..>; outree=intree; fntree=fnt]
      [opsy=symtb])
     [open !opsy ^bodsy; into !-1 !bodsy !fntree ^symty]
     [into !-9 !symty !<tp <> <>> ^xsym]  {start new temp vars counter}
     [into !-2 !xsym !<no> ^pramsym] {start new breakabl/loop list}
     [//"There is something wrong with this function's param list"//]
     FormParam !segd !(mods>159) !prnt !0 !pramsym !<> !tnam
        ^menam ^pmlst ^bodsym ^nlocs
     ([fnt=<>]
      sgn:Decorate !nlocs  {sgn=<xf; the exit number}
      sgn:InsertStuff !pmlst )?  {sgn=<xf}
     ("throws" ThrowList !midsym)? {** ignore 'throws' for now **}
     ([prnt=<>; outsym=midsym; bodysym=bodsym] {non-OO, name already in}
     | [strint !menam ^minam]  NewIdent !idn !minam ^pname 
       [sinto !pname !midsym !fntree ^outsym] {=procname'signature, OOPS}
       CopySyms !true !outsym !bodsym ^bodysym ) ; {~MethodHeader}

ThrowList !symtb:table    {used only by: MethodHead throws}
  -> (TypeName !symtb ^theTy ^theName
      ThrowableType !symtb !theTy  )$"," ;

CopySyms !ottr:bool !symtb:table !insym:table ^outsym:table
        {if symtb has our defaults, use it; otherwise..}
        {..copy everything from symtb over onto insym}
  -> [ottr=false; from !1 !symtb ^atree; outsym=symtb]
  -> [midsym=insym; nxp=0]
     ([ixfrom !nxp !symtb ^atree ^nxl ^nxn; nxp@=nxp+1]
       ([strint !nxn ^nxnn; nxnn>20&nxl>0]
        ([ottr=true; atree@=<ot atree >])?
        [slxinto !nxn !midsym !atree !-1 ^midsym@])? )*
     [lxinto !0 !midsym !<> !1 ^outsym] ;  {same as open}

FormParam !segd:bool !abx:bool !prnt:tree !comm:int !insym:table !intree:tree
       !tnam:str ^menam:str ^outree:tree ^outsym:table ^outloc:int
  -> ")" [outloc=0; outsym=insym; outree=intree; menam=tnam]
     [//"Another parameter expected after comma"//; comm=0]
  -> [info=<>; noRf=true; ztyp=0]
     ("final" [info@=<cn>])?  ("native" [info@=<pm>])?
     [//"Parameter type expected here"//]   aType !insym ^theTy
     ("&" [//"Import 'Dangerous' for this"//; from !19 !insym ^prox; ztyp@=1]
      ([from !1 !insym ^theTy; info@=<pt>;
         from !8 !insym ^ntr:<dc lnk nulty ..>; theTy@=nulty]
      |IsPointer !theTy ^tsix ^rxPt ^inix ^stx
        ([stx:<sm>]|[//"Inappropriate pointer type"//;
                        rxPt=true; stx=<>; noRf@=false])))?
     ([noRf=false; isPt=false; tsiz=1; stf=<>]
     |IsPointer !theTy ^tsiz ^isPt ^iniz ^stf
      [//"Parameter type must not be void"//; tsiz>0])
     [//"Parameter name expected here"//]   Identifier ^idn
     theTy:NameOfType ^tyname   [strint !tyname ^tynim]
     NewIdent !tnam !tynim ^pnam     ([segd=true; "$    , "])?
     ([abx=false]
      ([ztyp=0] theTy:TypeSpell |[otherwise; "void*"])
      ([segd=true; " _p_"; spell !idn; ascii !00; "-  "]
       ([ztyp=0] theTy:TypeSpell |[otherwise; "int*"])
       [" "; spell !idn; ";"; ascii !00; "%    "; spell !idn; " = "]
       ([ztyp#0; "(int*)"])?  ["_p_"; spell !idn]
      |[otherwise; " "; spell !idn])   EndLn !segd !true )?
     (","   ([segd=false & abx=false; ", "])?
       FormParam !segd !abx !prnt !1 !insym !intree !pnam
          ^menam ^ptree ^psym ^ploc
     |[ploc=0; psym=insym; ptree=intree; menam=pnam]
      [//"Malformed parameter or missing close paren"//] ")"
      ([prnt#<>; thty=<ty ptree <sz>%1 <pt prnt >>] {method needs 'this'}
       [thtr=<vr thty thty <> <of <>>%8 <>>%14; ploc@=1]
       [into !14 !psym !thtr ^psym@; ptree@=thtr])? )
     [outloc=tsiz+ploc]
     [outree=<vr ptree theTy info <of <>>%outloc*4+4 stf >%idn]
     PointList !isPt !insym !outree
     [sinto !idn !psym !outree ^outsym] ; {~FormParam}

InClassQ !prnt:tree ^inclss:bool
  -> ([prnt:<cl ..>]|[prnt:<yk ..>]|[prnt:<as ..>]) [inclss=true]
  -> [inclss=false];

VarDecln !prnt:tree !idn:str !mods:int !vtyp:tree !symtb:table !insym:table
       !intree:tree ^outree:tree ^outsym:table ^iniz:tree
  {look things up in symtb/insym, build outsym on insym} {** ignore mods **}
      {prnt: <> glob, <cl..>|<yk..> class, <fn..> local}
  -> "[" [//"Put array brackets with type (before var name)"//] Zstring !idn
     vtyp:TypeSize !false ^loval   [from !1 !symtb ^ity]
     ("]"  [hival=0; offs=1]
     |ConstExpn !false !symtb ^vtree ^exty ^hival   [offs=hival*loval]
       [//"Array size must be integer"//; exty=ity]
       [//"Closing bracket ']' expected"//]  "]" )
     [ityp=<ty <> <sz>%1 <rn <cn> <cn>%hival-1 ity >>]
     [atree=<ar ityp vtyp >; atyp=<ty <> <sz>%offs atree >]
     atree:InsertStuff !atyp  [intstr !0 ^zs]  {atree=<ar}
     VarDecln !prnt !zs !mods !atyp !symtb !insym !intree
         ^outree ^outsym ^iniz
  -> Zstring !idn [//"Name of variable expected here"//] Identifier ^vidn
     VarDecln !prnt !vidn !mods !vtyp !symtb !insym !intree
         ^outree ^outsym ^iniz
  -> [mods\128>63; vtyp:<ty lnk siz <pt rty:<cl atree atyp chrt elts ..>..>>]
     [from !1 !symtb ^ityp]      NativeCodeQ ^natv         {static record}
     InClassQ !prnt ^inclss
     prnt:PaRoot !mods-64 ^locOK ^root
     ([mods=2; from !-10 !symtb ^root@])? {"protected" gens 'progname::..'}
     [//"Variables of this class cannot be final"//; locOK=true]
     atyp:IsObject ^vxn ^nby ^ntyp ^osym  [rty=ntyp]
     NextVarInfo !2 !atyp !insym ^par ^offs  {the record itself}
     [rfx=<of root >%offs-2; xntree=<vr intree ityp <up> rfx <>>]
     [nfx=<of root >%offs-1; nxtree=<vr xntree ityp <up> nfx <>>]
     [extree=<as nxtree nfx <cn>%nby <>>%ityp]
     [vfx=<of root >%offs; outree=<vr extree atyp <up>%par vfx <>>%idn]
     [sinto !idn !insym !outree ^outsym; intstr !0 ^zs]
     CheckLn !false
     ([mods<128]  ([natv=false&inclss=true; "+"]|[natv=false; "-"])?
      ["  _"] vtyp:TypeSpell ["_ _"; spell !idn; "_,*"; spell !idn]
      ([natv=false&prnt=<>; from !-12 !symtb ^arzp]
         arzp:ListStuff !<> !<rc>%idn
      |[otherwise] ([natv=false; ";"; ascii !00; "%  "; spell !idn])?
       [" = &_"; spell !idn; "_"])
      ([natv=true&prnt=<>; from !-12 !symtb ^arzp]
         arzp:ListStuff !outree !<ar>%nby
           {we need to do the same for class vars too (in const'r) ??}
      |[natv=true; "; set_ary_size((void*)"; spell !idn; ",-";
         number !nby; ")"])?
      EndLn !true !false )?
     ("="  CopySyms !false !outsym !symtb ^glosym   {needs to be + ??}
       rty:GetStrDec ^vidn  {rty:<cl}
      [//"Constructor expected here"//]  Identifier ^vidn
      "(" chrt:PoorManConstor !true !glosym !vfx !outree ^booz ^mtree
         elts:PoorManConstor !booz !glosym !vfx !mtree ^boox ^outree@
      [//"Final ')' expected, possibly constructor error"//]  ")" )?
     [iniz=prnt]
     (","  CopySyms !false !outsym !symtb ^glosym
        CheckLn !false
        VarDecln !iniz !zs !mods !vtyp !glosym !outsym !outree
             ^outree@ ^outsym@ ^iniz@ )*
  -> [mods\128>63; vtyp:<ty lnk siz <ar rfx atyp ..>>]   {const array}
     [//"Tables not allowed here"//]  ([prnt:<fn ..>]|[prnt=<>])
     atyp:TypeSize !false ^nby      NativeCodeQ ^natv
     rfx:GetTypeRange ^rnty ^loval ^hival
     (atyp:IsString ^xsfg [strn=true]|[otherwise; strn=false])
     [from !1 !symtb ^ityp; //"Final array needs values"//]  "="
     [from !3 !symtb ^chrt; from !-6 !symtb ^root; elts=<sz>; nix=0]
     "{"  [//"Only chars and numbers can be in table"//; nby=1]
     ([//"Table item must be constant"//]
       ConstExpn !true !symtb ^vtree ^exty ^vxn
       [//"Table item type mismatch"//]  Assignable !symtb !atyp !exty
       ([vtree:<tc ..>; axtree=<ls elts vtree >]  vtree:StringTouch !root
       |[otherwise; axtree=<in elts >%vxn])
       [elts@=axtree; nix@=nix+1])$"," 
     [//"Missing '}' at end of table or bad value"//] "}"
     ("~" [//"This brace closes table "; spell !idn//] ID^idn )?
     [lino=nix; stf=<>; root:<tc nxtk >; nutk=<tc nxtk elts >]
     ([from !2 !symtb ^atyp; xtyp=2]|[from !3 !symtb ^atyp; xtyp=3]
     |[from !4 !symtb ^atyp; xtyp=4]|[otherwise; xtyp=1])
     [//"Table must not be empty"//; lino>0]
     CheckLn !false
     ([mods<128]
      ([natv=false; "+"]  atyp:TypeSpell   [" _"]
        prnt:TypeSpell  ["_"; spell !idn; "[] = {"]
       elts:TablElts !false !strn !nix !nix !xtyp
       ["};"; ascii !00; "-  "]  atyp:TypeSpell
       ["* "; spell !idn]
       ([prnt=<>; from !-12 !symtb ^arzp]
         arzp:ListStuff !<> !<nm>%idn
       |[otherwise; ";"; ascii !00; "%    "; spell !idn]
        [" = _"]  prnt:TypeSpell  ["_"; spell !idn])
      |([prnt#<>; "  "])?
       atyp:TypeSpell [" "; spell !idn; "[] = {"]
       elts:TablElts !natv !strn !nix !nix !xtyp  ["}"])
      EndLn !true !true )?
     root:InsertStuff !nutk  {root:<tc}
     [rty=<ty <> <sz>%1 <rn <cn> <cn>%lino-1 ityp >>]
     [sizn=lino*nby; artr=<ar rty atyp <>>]
     [ntyp=<ty <> <sz>%sizn artr stf >; atree=<tc <> ntyp nutk prnt >%idn]
     artr:InsertStuff !ntyp    {artr=<ar}
     [//"Array size does not match data"//; hival<0`hival=lino; iniz=prnt]
     [outree=<nc intree <> atree >; sinto !idn !insym !atree ^outsym]
  -> [mods\128>63; sizn=0; //"Constant declaration expected"//]
     vtyp:TypeSize !false ^nby  "="  {"&" allows constant value for Point..}
     ("&" [//"& is Dangerous"//; from !19 !symtb ^prox; sizn@=1])?
     ConstExpn !true !symtb ^vtree ^exty ^vxn
     [//"This value is not the declared type"//]
     ([sizn>0] exty:IsScalar |[otherwise] Assignable !symtb !vtyp !exty )
     ([from !6 !symtb ^vtyp; //"Use string literals"//; vtyp=exty])?
     ([from !4 !symtb ^vtyp; vtree:<tc ..>; nix=4]  {S->C4}
       String4 !true !vtree ^axtree ^vrsiz
     |[vtree:<tc ..>; axtree=vtree; nix=0]
     |[from !3 !symtb ^vtyp; axtree=<ch>%vxn; nix=1]
     |[otherwise; axtree=<cn>%vxn; nix=1])
     [outree=<dc intree vtyp axtree >%idn]
     [sinto !idn !insym !outree ^outsym; intstr !0 ^zs; iniz=prnt]
     (","  CopySyms !false !outsym !symtb ^glosym
        CheckLn !false
        VarDecln !iniz !zs !mods !vtyp !glosym !outsym !outree
           ^outree@ ^outsym@ ^iniz@ )*
  -> [from !1 !symtb ^ityp; //"Variable declaration expected here"//]
     IsPointer !vtyp ^vrsiz ^isPt ^inip ^stf        NativeCodeQ ^natv
     InClassQ !prnt ^inclss
     prnt:PaRoot !mods ^locOK ^root
     ([mods=2; from !-10 !symtb ^root@])? {"protected" gens 'progname::..'}
     (vtyp:ArrayBounds ^ztyp ^rnty ^hix ^eltsz [hix>-1; ohed=1] {static ary..}
     |[otherwise; hix=-1; ohed=0; ztyp=vtyp])
     NextVarInfo !ohed !vtyp !insym ^par ^offs  {the array/var itself}
     CheckLn !false      [iniz=prnt]
     ([mods<128]  ([natv=false&inclss=true; "+"]|[natv=false; "-"])?
      ["  "]  ztyp:TypeSpell  [" "; spell !idn])?
     ([vrsiz>hix+2; zas=hix+2; zint=vrsiz+vrsiz/zas-2] {true if eltsz>1}
     |([from !2 !symtb ^ztyp]|[from !3 !symtb ^ztyp])
      [bitand !vrsiz+11 !-4 ^zas; zint=zas/4-2]
     |[otherwise; zint=vrsiz; zas=vrsiz+2])
     ([trlevel ^tlvl; tlvl>0; trasci !64; trnmbr !zint; trasci !32])?
     ([hix>-1; rfx=<of root >%offs-8; nfx=<of root >%offs-4]
      ([mods<128; "["; number !zas; "]"])?
      {(([prnt=<>]|[prnt:<fn ..>])["; "; spell !idn; "[0] = "; number !vrsiz])?}
      [xntree=<vr intree ityp <up> rfx <>>]
      [nxtree=<vr xntree ityp <up> nfx <>>]
      [extree=<as nxtree nfx <cn>%vrsiz <>>%ityp]
     |[otherwise; extree=intree]) {** loc obj array **}
     [vfx=<of root >%offs; vrtree=<vr extree vtyp <up>%par vfx stf >%idn]
     ([hix>-1]   IsPointer !ztyp ^zsiz ^zPt ^zini ^zstx
      [zini=true; from !-11 !symtb ^stzp]  stzp:ListStuff !vrtree !<> )?
        {stzp is used by StringArrayZap}
     ([inclss=true; hix>-1; iniz@=<yk iniz vrtree >%vrsiz])?
        {init static ary inside class}
     [outree=vrtree; from !-12 !symtb ^arzp]
     PointList !isPt !insym !outree   NativeCodeQ ^natv
     [sinto !idn !insym !outree ^outsym; srctoklinch ^lnz; lino=lnz/4096+1]
     ("=" [//"Cannot initialize instance variables"//]
        ([prnt=<>]|[prnt:<fn ..>])
      Expressn !symtb ^vtree ^exty ^loval ^hival
      [//"Type mismatch"//]  Assignable !symtb !vtyp !exty
        {this may fail trying to assign unequal but compat types from insym}
      IsPointer !exty ^xsz ^zPt ^inix ^stx
      Coerce !symtb !vtyp !exty !vtree ^exptr   {maybe call ValRefer here?}
      (exptr:PreCountAry  [zPt@=false] )? ([stx:<st>; zPt@=false])?
      [//"Oops (VarDecln) ="//]
      ([mods<128]
        ([natv=false&prnt=<>]
         ([vtree:<ys>]    arzp:ListStuff !vrtree !vtree
         |[vtree:<tc vlnk sttr:<st> ..>] arzp:ListStuff !vrtree !sttr
         |[//"Only init global vars to constant"//; loval=hival]
          ([from !3 !symtb ^vtyp] arzp:ListStuff !vrtree !<ch>%loval
          |[otherwise]         arzp:ListStuff !vrtree !<ze>%loval ))
        |([natv=false&prnt#<>]  EndLn !true !true   exptr:PreCodeTree !symtb
          ["  myframe->"; spell !idn])?
         [" = "]           {in 1st frame block (after constructor) if seg'd}
         ([loval=hival; from !3 !symtb ^vtyp] GenChar !loval
         |[loval=hival; from !3 !symtb ^exty] exptr:GenTreeCode !1 !0
         |[otherwise] ([zPt=true; "("]  vtyp:TypeSpell  [")up__ptr("])?
          exptr:GenTreeCode !loval !hival   ([zPt=true; ")"])? ))? )?
      (([exptr:<cn>]|[exptr:<ch>]) [tmtree=<as outree vfx exptr <>>%exty ]
      |[stf:<st>]
       (([exptr:<fc ..>]|[exptr:<ca ..>]|[exptr:<tc ..>]
         |[exptr:<mt ..>]|[exptr:<ys>])
        [tmtree=<as <nn outree >%lino vfx exptr <>>%exty ]
       |[otherwise; tmtree=<as <nn <as outree vfx <cn> <>>%vtyp >%lino
             vfx exptr stf >%exty ])
      |exty:IsScalar
       [loval=hival & stf=<>; tmtree=<as outree vfx <cn>%loval <>>%exty ]
      |[isPt=true & stf=<> & (loval#0`hival#0)]               {var = new...;}
        ([hix>-1; exptr:<al <as ..> ..>; exptr@=<zz exptr <nn>%hix+1 >%offs])?
        (([exptr:<fc ..>]|[exptr:<al ..>]|[exptr:<ar <> ..>])
         [tmtree=<as <nn outree >%lino vfx exptr <>>%exty ]
        |[otherwise; tmtree=<as <nn <as outree vfx <cn> <>>%vtyp >%lino 
            vfx exptr <pt>>%exty ])
      |[otherwise]  {I think <zz..> tree clears for a poorman const'or..}
          {anyway, poorman ignores <zz..>}
        ([hix>-1; exptr:<al <as ..> ..>; exptr@=<zz exptr <nn>%hix+1 >%offs])?
        [tmtree=<as <nn outree >%lino vfx exptr stf >%exty ])
      [outree@=tmtree]   {-------- end of explicit initialize --------}
     |[hix>-1; outree@=<zz <nn outree >%lino <nn>%vrsiz >%offs] {preclear ary}
      ([inclss=true]   {[iniz@=<zz iniz vrtree <nn>%vrsiz >]}
      |[prnt=<>]  arzp:ListStuff !vrtree !<ar>%zint
      |EndLn !true !true   ([natv=false; "%  "])?
        ([mods<128; "  set_ary_size((void*)"; spell !idn; ",-";
            number !zint; ")"])? )
     |[inip=true; outree@=<as outree vfx <cn> <>>%vtyp]
        (vtyp:IsString ^sfg
        |[inclss=true]  {[iniz@=<as iniz vrtree <cn> <>>]}
        |[prnt=<> & mods<128]
          ([natv=true; " = 00"]
          | arzp:ListStuff !vrtree !<ze> )
        |[mods<128]
          ([natv=false]  EndLn !true !true  ["%  "; spell !idn])?
          [" = 00"])?)?
     ([mods<128]  EndLn !true !false )?
     (","  CopySyms !false !outsym !symtb ^glosym  [intstr !0 ^zs]
        CheckLn !false
        VarDecln !iniz !zs !mods !vtyp !glosym !outsym !outree
             ^outree@ ^outsym@ ^iniz@ )* ; {~VarDecln}

aType !symtb:table ^theTy:tree          {can be dimensioned}
  -> QualIdent !0 !4096 !symtb !vacant !<>
        ^tnam ^vnm ^vtr ^theTy ^mods ^lox ^hix 
     [//"Type expected here"//]   theTy:TypeSize !false ^tsiz ;

Blocks !frntPar:tree !symtb:table !gazin:bool !intree:tree !whom:int
    ^outree:tree ^gzout:bool ^locsym:table  {frntPar=<fn ..>|frntPar=<>}
  -> "{"  CheckLn !false     NativeCodeQ ^natv    {fails clean if no brace}
       [ismain=false; srctoklinch ^linz; intstr !whom ^whos]
       FuncInfo !symtb ^fun ^fty ^par ^npms
       ([natv=true; " {"]   ([frntPar#<>; " int* _tmp_00_;"]
         ([fty#<>; " "] fty:TypeSpell [" _tmp__;"])? )?  [ascii !00])?
       [locsym=symtb; gzout=gazin; front=(frntPar#<>)]
       [stms=<nn intree >%linz/4096+1; getat !1 ^zini]
       ([whom>0; from !-7 !symtb ^mnNm]  mnNm:GetDecor ^whom
        ([from !19 !symtb ^prox; putat !1 !-1])?
        [from !-12 !locsym ^stzp]  stzp:GlobArrayInits
        [ismain@=true; putat !1 !zini])?
(("?" [tron !2] | "!" [troff]   {debugging trace on/off}
      |QualIdent !-1 !16383 !locsym !vacant !<> ^tname ^vnm ^vtree ^vty
          ^mods ^lov ^hiv  {type+declns, or stat.members, or qual'd.vars}
        TempFrame !symtb !0 ^tvsv
        ([vtree=<>; tvok=false; intstr !0 ^zs]   {it's a type or class..}
         [//"Missing '}' or late variable declaration"//; front=true]
         VarDecln !frntPar !zs !mods !vty !locsym !locsym !stms
             ^stmx ^lox ^iniz
         [//"Invalid declaration or missing semicolon ';'"//] ";"
         [cmo=gzout; fro=front; tabtree !lox ^loxt; treeflag !loxt !8]
        |[//"Modifiers inappropriate here"//; mods=0`mods=2`mods=66;
            fro=false; tvok=true]                     {protected OK}
         [lox=locsym; //"Malformed statement or variable declaration"//]
         ProStmt !vtree !vty !locsym !gzout !stms !mods ^stmx ^cmo ^lino
          ([lino>0; stmx@=<nn stmx >%lino])? )
        [front@=fro; gzout@=cmo; locsym@=lox]
        DoTvDeallo !symtb !tvok !stmx ^stms@
        TempFrame !symtb !tvsv ^tvsx
      |Statment !locsym !gzout !stms !0 ^stms@ ^gzout@
       [front@=false]))*  {QualIden fails clean to exit}
     [srctoklinch ^liny; outree=<nn stms >%liny/4096+1]
     ([whom>0; from !-11 !locsym ^stzp] stzp:StringArrayZaps )?
     ([ismain=true&natv=true] CheckLn !true  ["Quit()"] EndLn !true !false )?
     [//"Malformed statement or missing close brace '}'"//] "}"
     ([frntPar#<>; gzout=true]  DownRefPtrs !locsym !<> )?
     ([natv=true; "}"]  EndLn !false !false )?
     ("~" 
      ([whom>0; //"This brace closes function "; spell !whos//] ID ^whos
        ([natv=true; " // ~"; spell !whos]  EndLn !false !true )?
      |[whom+1=0; //"This brace closes an if statement"//]   "if"
      |[whom+2=0; //"This brace closes an else statement"//] "else"
      |[whom+3=0; //"This brace closes a while loop"//]      "while"
      |[whom+4=0; //"This brace closes a do loop"//]         "do"
      |[whom+5=0; //"This brace closes a for loop"//]        "for"
      |[whom+8=0; //"This brace closes a synchronized block"//]
         "synchronized" 
      |[whom+9=0; //"This brace closes a try block"//]       "try"
      |[whom+10=0; //"This brace closes a catch block"//]    "catch"
      |[whom+11=0; //"This brace closes a finally block"//]  "finally"
      |[otherwise; //"This brace should be unlabeled"//; 0=1]))? ; {~Blocks}

Statment !symtb:table !gazin:bool !intree:tree !whom:int
       ^outree:tree ^gzout:bool    {intree is prev stmts}
  -> TempFrame !symtb !0 ^tvsv
     ( Blocks !<> !symtb !gazin !intree !whom ^outree ^gzout ^bsym
     | ProStmt !<> !<> !symtb !gazin !intree !0 ^midtree ^gzout ^lino
       DoTvDeallo !symtb !true !midtree ^outree
       TempFrame !symtb !tvsv ^tvsx 
       ([lino>0; outree@=<nn outree >%lino])? ) ; {~Statment}

ProStmt !theV:tree !vtyp:tree !symtb:table !gazin:bool !intree:tree !mods:int
       ^outree:tree ^gzout:bool ^lino:int    {intree is prev stmts}
  -> [theV=<>]  (KeyWdStmt !symtb !gazin !intree ^outree ^gzout  [lino=0]
        | QualIdent !-1 !-1 !symtb !symtb !<> ^idn ^vnm ^vtree ^exty ^modz
            ^lov ^hiv  {fails clean, causing LeftOrCal to error off}
          [//"Declarations should preceed statements"//; vtree#<>]
          [modz=0`modz=2`modz=66]   CheckLn !false
          ProStmt !vtree !exty !symtb !gazin !intree !modz
              ^outree ^gzout ^lino )
  -> LeftOrCall !theV !symtb !vtyp !intree !mods ^otree ^exty ^isFn ^lov ^hiv
     ([isFn>0]  AssignStmt !false !otree !exty !symtb !intree !true
         ^outree ^loval ^hival ^semi                          {genco}
     |[otherwise]  exty:TypeSize !false ^siz
      [//"Assignment to a variable expected"//; siz=0; isFn=0]
      CheckLn !true
      otree:PreCodeTree !symtb
      otree:GenTreeCode !1 !0
      [loval=lov; hival=hiv; outree=otree; semi=true])
     [gzout=gazin; srctoklinch ^linz; lino=linz/4096+1]
     [//"Malformed statement or missing semicolon ';'"//] ";" 
     EndLn !semi !false ;

MagiCall !theV:tree !symtb:table !intree:tree ^outree:tree
       ^exty:tree ^loval:int ^hival:int
  -> [theV:<fn link <fn>%pnot exty >; //"Function param(s) expected"//]
     "(" [from !1 !symtb ^ity; treeint !pnot ^fno] 
     ([fno=1; //"Scalar value expected for ORD"//]
       Expressn !symtb ^vtree ^exta ^lov ^hiv
       (String4 !false !vtree ^vtr ^loval
        [hival=loval; outree=<op vtr <>>]
       |[lov=hiv & lov+hiv#0; outree=<op vtree exta >; loval=lov; hival=hiv]
       |exta:IsScalar  [outree=<op vtree exta >; loval=lov; hival=hiv])
     |[fno=2; //"Array or String parameter expected for LENGTH"//]
      (QualIdent !0 !12288 !symtb !symtb !<>
           ^tnm ^vnm ^qtr ^qty ^mox ^loz ^hiz
       ([qtr=<>]   qty:TypeSize !true ^nby
        [outree=<cn>%nby; loval=nby; hival=nby]
       |LeftOrCall !qtr !symtb !qty !<> !0 ^vtree ^exta ^isFx ^lov ^hiv
        IsPointer !exta ^hix ^isPt ^iniz ^stf
        ([stf:<st>]
         ([vtree:<tc par <st>%vtr ..>; treestr !vtr ^stn]
          [stleng !stn ^loval; hival=loval; outree=<cn>%loval]
         |[vtree:<cn>; outree=vtree; loval=0; hival=loval]
         |[vtree:<ch>; outree=vtree; loval=0; hival=loval]
         |[otherwise; loval=0]
          ([isFx#0; vtree@=<pr <dr vtree >%1 stf >])?
          [outree=<sg vtree >]
          Unbounded ^lox ^hival )
        |exta:ArrayBounds ^ztyp ^rnty ^nby ^esz
         ([nby<0; loval=0]   Unbounded ^lox ^hival
          [outree=<lg vtree >]
          ([esz#1; outree@=<dv outree <cn>%esz >])?
         |[otherwise; loval=nby+1; hival=loval; outree=<cn>%loval])
        |exta:IsObject ^nby ^loval ^rnty ^osym  {** NG if subclassed **}
         [hival=loval; outree=<cn>%loval]))
      |STR ^stn  [stleng !stn ^nby; loval=nby; hival=nby; outree=<cn>%nby])
     |[fno=3; //"Integer value expected for CHR"//]
       Expressn !symtb ^vtree ^exta ^loval ^hival
       ([loval<0`hival>255; vtree@=<an vtree <cn >%255 >]
        [loval@=0; hival@=255])?
       [outree=<cp vtree >]
       Assignable !symtb !ity !exta
     |[fno=4; //"Integer address value expected for PEEK"//]
       Expressn !symtb ^vtree ^exta ^lox ^hix
       Assignable !symtb !ity !exta
       Unbounded ^loval ^hival           {pBR;neg;add; for raw numbers}
       {[outree=<dr <ez <ez <ez vtree >%63 >%15 >%17 >%1]}
       [outree=<pm vtree >%1]
     |[fno=5; //"Integer address value expected for POKE"//]
       CheckLn !true
       Expressn !symtb ^vtree ^exta ^lov ^hiv
       Assignable !symtb !ity !exta
       [//"Simple value to be poked expected"//]  ","
       Expressn !symtb ^vtr ^par ^lox ^hix
       Unbounded ^loval ^hival
       vtree:PreCodeTree !symtb
       vtr:PreCodeTree !symtb
       par:TypeSize !false ^nby   [nby=1]
       ["_POKE_((int)"]  vtree:GenTreeCode !1 !0  [",(int)"]
         vtr:GenTreeCode !lox !hix  [")"]
       {[outree=<as intree <ez <ez <ez vtree >%63 >%15 >%17 vtr <>>]}
       [outree=<ki <as intree vtree vtr <>>>]
     |[fno=6; from !3 !symtb ^exta; vtree=<>; nby=4]
       ([//"Character values expected for PackText"//]
         Expressn !symtb ^vtr ^exta ^lov ^hiv
         [vtree@=<at vtree vtr >; nby@=nby-1])$","
       [//"Four params expected"//; nby=0; outree=<ac intree vtree <at>>]
       Unbounded ^loval ^hival
     |[fno=7; //"Two integer values expected for TextChar"//]
       Expressn !symtb ^vtree ^exta ^lov ^hiv
       Assignable !symtb !ity !exta
       ","   Expressn !symtb ^vtr ^par ^lox ^hix
       Assignable !symtb !ity !par
      {([hix>-64`lox<-67; vtr@=<ad <an vtr <cn>%3 > <cn>%-96 >])?}
       [loval=0; hival=255; outree=<ac intree vtree <ch> vtr >]
     |[fno=8; //"Array reference expected for FORKER"//]
       LeftOrCall !<> !symtb !<> !<> !0 ^vtree ^exta ^isFx ^lov ^hiv
       [isFx>0]  IsPointer !exta ^lox ^isPtr ^iniz ^stf
       ([isPtr=true & stf=<>; vtr=<dr vtree >%1]
       |[otherwise; vtr=vtree]  exta:ArrayBounds ^ztyp ^rnty ^esz ^nby )
       Unbounded ^loval ^hival
       [outree=<ac intree <un vtr stf > <no>>]
     |[fno=9; //"Integer address value expected for COCALL"//]
       Expressn !symtb ^vtree ^exta ^lov ^hiv
       Assignable !symtb !ity !exta
       Unbounded ^loval ^hival
       [outree=<ac intree vtree <>>]
     |[fno/2=5; //"Semaphore reference expected for Signal or Wait"//]
       [from !20 !symtb ^exta]
       LeftOrCall !<> !symtb !<> !<> !0 ^vtree ^exta ^isFx ^lov ^hiv
       Unbounded ^loval ^hival
       [outree=<sm intree vtree >%fno-6]
     |[fno/2=6; //"Values for MIN/MAX must be scalar"//]
       Expressn !symtb ^outree ^exta ^lov ^hiv
       exta:IsScalar
       exta:GetTypeRange ^rnty ^loval ^hival
       (","   Expressn !symtb ^vtree ^par ^lox ^hix
         Comparable !false !symtb !exta !par ^exty@ ^conv
         [//"MIN/MAX values must be same type"//; conv=0]
         ([lov=hiv&lox=hix]
           ([fno=12 & lov<lox ` fno=13 & lov>lox; stnn=lov]
           |[otherwise; stnn=lox]) [lov@=stnn; hiv@=stnn; outree@=<cn>%stnn]
         |[outree@=<ac <> outree <if> vtree >%fno-12; lov@=hiv-1]))*
       ([lov=hiv; loval@=lov; hival@=lov])?
     |[fno=14; //"Integer value expected for ABS"//]
       Expressn !symtb ^vtree ^exta ^lov ^hiv
       Assignable !symtb !ity !exta
       [max !hiv !-lov ^hival; max !lov !-hiv ^lox; max !lox !0 ^loval]
       ([lov=hiv; outree=<cn>%loval]|[outree=<ac intree vtree <pl>>])
     |[fno=15; //"Integer param expected for CHR4"//]
       Expressn !symtb ^vtree ^exta ^loval ^hival
       Assignable !symtb !ity !exta
       [outree=<ac intree vtree <nn>>]
     |[fno=99]  Unbounded ^loval ^hival            {'HUGE_NOP' or 'RAW_CODE'}
       (STR ^stn   CheckLn !true   [outree=<>; spell !stn]
       |[//"Constant integer size expected here"//] NUM ^lov
        [outree=<ac intree <> <cn>%lov >])
     |[fno<0; outree=<>; //"There's a problem with this C0DE"//]
       Unbounded ^loval ^hival
       (":" [//"Result type name expected here"//]
         TypeName !symtb ^exty@ ^stn
       |"#" [//"Constant integer opcode expected here"//]
         ConstExpn !false !symtb ^vtree ^exta ^lov
         Assignable !symtb !ity !exta
         [outree@=<ez outree >%lov]
       |STR ^stn   [spell !stn; loval@=2147483648; hival@=2147483648]
       |[//"Operand value expected here"//]
         Expressn !symtb ^vtree ^exta ^lov ^hiv
         [outree@=<nc outree vtree >])$","
       ([intree#<>; outree@=<nc intree outree >])?
     |[fno=0; outree=<bg intree >]) {DEBUG}
     [//"Bad parameter or missing parenthesis"//]  ")" ; {~MagiCall}

LeftOrCall !theV:tree !symtb:table !intyp:tree !intree:tree !mds:int
       ^outree:tree ^exty:tree ^isFn:int ^loval:int ^hival:int
          {must fail clean for Stmt to exit properly}
  -> [theV=<>]     {isFn=0 is a value/fn; >0 writeable, <0 non-wr adr}
     QualIdent !1 !-1 !symtb !symtb !<> ^tname ^vnm ^vtree ^xty ^nby ^lov ^hiv
     ([vtree:<fn ..>; intyp:<ft>; sty=intyp]|[otherwise; sty=xty])
     [//"Variable or method name expected here"//]
     LeftOrCall !vtree !symtb !sty !intree !nby
         ^outree ^exty ^isFn ^loval ^hival
  -> [theV:<ys>; outree=theV; exty=intyp; isFn=0]
     Unbounded ^loval0 ^hival
  -> [theV:<cn>%vtr; outree=theV; exty=intyp]
     [treeint !vtr ^loval; hival=loval; isFn=0]
  -> [theV:<ch>%vtr; outree=theV; exty=intyp]
     [treeint !vtr ^loval; hival=loval; isFn=0]
  -> [theV:<vr lnk exty vtr ..>; outree=theV; isFn=1]
     exty:GetTypeRange ^rnty ^loval ^hival
  -> [theV:<fn lnk <fn> ..>; isFn=0]
     MagiCall !theV !symtb !intree ^outree ^exty ^loval ^hival
  -> [theV:<fn lnk exty:<ty ..> prms fcod >]         {inlined function}
     exty:GetTypeRange ^rnty ^loval ^hival  [intstr !0 ^zs]
     "(" Argments !symtb !prms !<> !zs ^xname ^args
     [//"Missing ')' or badly formed argument"//] ")"
     [outree=<nc intree <nc args fcod >>; isFn=0; from !6 !symtb ^sty]
     ([exty=sty]  TempSave !true !symtb !outree ^outree@ )?
  -> [intyp:<ft>; theV:<fn ..>; exty=intyp; isFn=-1]
     Unbounded ^lov ^hival
     [outree=<ft intree theV >; loval=-hival]
  -> [theV:<fn lnk <xf exty prms nloct ..> pnot uptr >; fcod=<>]
     {exty:NameOfType ^tname -- we don't have an object to get type of}
     NativeCodeQ ^natv
     ([uptr:<fp ..>; from !19 !symtb ^prox]
       ([mds=2; from !-10 !symtb ^fcod@])? {"protected" gens 'progname::..'}
       ([mds=66; fcod@=<sy>])? {"protected final" makes it 'FrameWork::..'}
     |[otherwise; //"Native code must call native functions"//; natv=natv])
     [isFn=0; intstr !0 ^zs; //"Argument list expected"//]
     "(" Argments !symtb !prms !<> !zs ^xname ^args
     [//"Badly formed argument or missing ')'"//] ")"
     IsPointer !exty ^nby ^isPt ^iniz ^stf
     Unbounded ^lov ^hiv
     ([isPt=true; loval=-hiv; hival=hiv]
     | exty:GetTypeRange ^rnty ^loval ^hival )
     [outree=<fc intree args theV <nn>%nby fcod >; from !6 !symtb ^sty]
     ([exty=sty]  TempSave !true !symtb !outree ^outree@ )?
  -> [theV:<dc lnk exty outree >] ([outree:<cn>]|[outree:<ch>])
     outree: GetDecor ^loval  [hival=loval; isFn=0]
  -> [theV:<dc lnk exty outree:<tc args <st>>>; isFn=0]
     Unbounded ^loval ^hival
  -> [theV:<dc lnk exty <vr>%vtr >; isFn=-1]
     exty:GetTypeRange ^rnty ^loval ^hival
     LeftOrCall !vtr !symtb !exty !intree !mds ^outree ^xty ^nby ^lov ^hiv
  -> [theV#<>; exty=intyp]
     exty:GetTypeRange ^rnty ^loval ^hival
     exty:NameOfType ^tname
     ("(" Argments !symtb !<nt> !<> !tname ^xname ^args
       [//"Badly formed constructor parameter or missing ')'"//] ")"
       [outree=<fc intree args <nt>%tname <> <>>; isFn=0]
     |[isFn=1; outree=theV]) ; {~LeftOrCall}

AssignStmt !eqo:bool !vrtree:tree !vrty:tree !symtb:table !intree:tree
       !genco:bool ^outree:tree ^loval:int ^hival:int ^semi:bool
  -> [vrtree=<>]   {stat.members, or qual'd.vars}
     LeftOrCall !<> !symtb !<> !intree !0 ^vtr ^exty ^isFn ^lov ^hiv
     [//"Variable name expected here"//; isFn>0]
     AssignStmt !eqo !vtr !exty !symtb !intree !genco
         ^outree ^loval ^hival ^semi
  -> [//"Variable name expected here"//; vrtree#<>]
     IsPointer !vrty ^nby ^isPt ^iniz ^stf  ([stf:<st>; isPt@=false])?
     [from !1 !symtb ^ity; semi=true] 
     ([eqo=false] ("++" [upn=1]|"--" [upn=-1])  {fails safe into "="}
       [//"Increment ++/-- can only be used on scalars"//; isPt=false]
       vrty:IsScalar
       vrty:GetTypeRange ^rnty ^loval ^hival
       [outree=<rg intree vrtree <cn >%upn >%vrty]
       ([genco=true]  CheckLn !true
         vrtree:PreCodeTree !symtb
         vrtree:GenTreeCode !1 !0
         ([upn>0; "++"]|[otherwise; "--"]))
     |[brc=false; //"Assignment operator '=' expected here"//]  "="
      ([isPt=true&genco=true] ([vrtree:<vr ..>]|[vrtree:<nm ..>])
       CheckLn !true    ["{_tmp_00_ = (int*)"]
       vrtree:PreCodeTree !symtb
       vrtree:GenTreeCode !1 !0    [";"; brc@=true])?
      [//"Expression value expected for assignment"//]
      Expressn !symtb ^xtree ^exty ^loval ^hival
      [//"Expression value must be compatible type with variable"//]
      Assignable !symtb !vrty !exty
      Coerce !symtb !vrty !exty !xtree ^vtree
      ([genco=true]  CheckLn !true
        vtree:PreCodeTree !symtb
        vrtree:PreCodeTree !symtb
        vrtree:GenTreeCode !1 !0
        [" = "] IsPointer !exty ^xby ^izPt ^inx ^stg
        (vtree:PreCountAry  [izPt@=false])? ([stg:<st>; izPt@=false])?
        ([vtree=xtree&loval=hival] vtree:GenTreeCode !loval !hival
        |[izPt=true; "("]  vrty:TypeSpell  [")up__ptr("]
         vtree:GenTreeCode !1 !0   [")"]
        |[otherwise]   vtree:GenTreeCode !1 !0 )
        ([brc=true; "; down__ptr(_tmp_00_);}"; semi@=false])? )?
      ([nby>2; //"HUH? Value is too big"//; vtree:<dr upt >]
       [outree=<co intree vrtree upt >%nby ]
      |vtree:ValRefer !vrty ^xvtr ^upx ^upt
       [outree=<as intree vrtree xvtr upt >%vrty])) ; {~AssignStmt}

KeyWdStmt !symtb:table !gazin:bool !intree:tree ^outree:tree ^comesout:bool
  -> "if"   NewBlockNum ^bktop   NewBlockNum ^bkext    NativeCodeQ ^natv
      [srctoklinch ^linz; //"Boolean if expression in parentheses expected"//]
      ParExpn !symtb ^btree ^bxty ^blov ^bhiv
      [//"Boolean if expression expected"//]  IsBool !symtb !bxty
      btree:PreCodeTree !symtb
      CheckLn !true  ["if ("]  ([natv=false; "!("])?
      btree:GenTreeCode !blov !bhiv  [")"]  ([natv=false; ")"])?
      GoToBlock !false !bktop !symtb
      DoTvDeallo !symtb !true !<> ^tvsd
      [srctoklinch ^linx; //"Statement expected after if"//]
      Statment !symtb !gazin !<nn tvsd >%linx/4096+1 !-1 ^thtree ^thout
      ("else"  [srctoklinch ^liny; //"Statement expected after else"//]
        ([natv=true]  CheckLn !true  ["else"])?
        GoToBlock !true !bkext !symtb
        StartBasicBlock !bktop !symtb
        Statment !symtb !gazin !<nn tvsd >%liny/4096+1 !-2 ^eltree ^elout
        GoToBlock !true !bkext !symtb
        [bktst=bkext]
      |[eltree=tvsd; elout=true; bktst=bktop]
        GoToBlock !true !bktop !symtb )
      StartBasicBlock !bktst !symtb
      [outree=<if <nn intree >%linz/4096+1 btree thtree eltree >;
         comesout=elout`thout]
  -> "for" [srctoklinch ^linz; dbrace=false]  NativeCodeQ ^natv
      NewBlockNum ^bktop   NewBlockNum ^bkext   NewBlockNum ^bktst
      [nnst=<nn intree >%linz/4096+1]                   {I took out C-for}
      [//"Local scalar control variable expected here"//]
      QualIdent !0 !-1 !symtb !symtb !<>
          ^tname ^idn ^dcln ^qty ^modq ^loq ^hiq
      LeftOrCall !dcln !symtb !qty !nnst !0 ^axes ^vrty ^isFn ^xlov ^xhiv
      [isFn>0; dcln:<vr ..>%vnam; treestr !vnam ^vstr]
         {[isFn>0; dcln:<vr .. <of <>> ..>]}
      vrty:IsScalar
      [//"Initial index value assignment expected here"//]
      AssignStmt !true !axes !vrty !symtb !<> !false ^initr ^ilov ^ihiv ^semi
      [//"Malformed initial value or missing comma ','"//] "," 
      [tvn=-1; svn=-1; //"Final index value expected here"//]
      Expressn !symtb ^fvtree ^fxty ^flov ^fhiv
      [//"Final value must be compatible type with control variable"//]
      Assignable !symtb !vrty !fxty
      ([flov#fhiv]
        ([natv=true; dbrace@=true]  CheckLn !true  ["{"])?
        TempAlloc !symtb !fvtree !nnst ^fvtree@ ^nnst@ ^tvn@ )?
      [from !1 !symtb ^ity; blov=0; bhiv=1]
      (","  [//"Integer step index value expected here"//]
       Expressn !symtb ^stree ^sxty ^slov ^shiv
       IsNumeric !symtb !sxty ^isint  [isint=1]
      |[slov=1; shiv=1; stree=<cn>%1])
      [//"Ill-defined step size (must be either >0 or <0)"//]
      ([slov#shiv] TempAlloc !symtb !stree !nnst ^stree@ ^nnst@ ^svn@ )?
      ([slov>0; llo=ilov; hhi=fhiv; btree=<gr <dr axes >%1 fvtree >%vrty]
      |[shiv<0; llo=flov; hhi=ihiv; btree=<ls <dr axes >%1 fvtree >%vrty])
      ([slov=1&shiv=1; svtree=<xc axes <ad>>]
      |[slov+1=0&shiv+1=0; svtree=<xc axes <su>>]
      |[shiv<0 & slov=shiv;
         svtree=<as <> axes <su <dr axes >%1 <cn>%0-shiv >%vrty >%vrty]
      |[svtree=<as <> axes <ad <dr axes >%1 stree >%vrty >%vrty])
      DoTvDeallo !symtb !true !<nc nnst initr > ^tvsd   {dn-refs tv's ?}
      [//"Malformed for-loop expression or missing 'do'"//] "do"
      CheckLn !false  [open !symtb ^nsym]  vrty:TypeSize !false ^siz
      ([natv=false; "//for "; spell !vstr;
          " ------------------------"; ascii !00])?
      [xrty=<ty <> <sz>%siz <rn <cn>%llo <cn>%hhi vrty >>]
      [sinto !idn !nsym !<dc <> xrty <vr>%dcln > ^locsym]
      ([natv=true; "  for ("])?
      btree:PreCodeTree !symtb
      initr:PreCodeTree !symtb
      initr:GenTreeCode !1 !0
      ([natv=false; "  if ("]|[otherwise; " !"])
      btree:GenTreeCode !blov !bhiv    ([natv=false; ") "])?
      GoToBlock !true !bkext !symtb  {btree evals true to exit}
      ([natv=false; "  else "])?  GoToBlock !true !bktop !symtb
      StartBasicBlock !bktop !symtb
      [outree=<fr tvsd <> svtree btree >; putat !0 !0]
      ([natv=true; ";"]  svtree:GenTreeCode !0 !-7  [ ") "])?
      [from !-2 !symtb ^brkt]        {[putat !0 !0; / EndLn !false !true }
      brkt:Breakable !outree !0 !(bktst*65536+bkext) ^brox
      [srctoklinch ^liny; //"Repeatable statement expected after for"//]
      Statment !locsym !gazin !<nn <>>%liny/4096+1 !-5 ^botree ^thout
      outree:InsertStuff !botree  {outree=<fr|<wh}
      ([natv=false]   btree:PreCodeTree !symtb    svtree:PreCodeTree !symtb
        svtree:GenTreeCode !0 !-7   EndLn !true !true
        CheckLn !true  ["if ("]  btree:GenTreeCode !blov !bhiv  [ ") "]
        GoToBlock !true !bkext !symtb
        ["  else "]  GoToBlock !true !bktop !symtb
        StartBasicBlock !bktst !symtb
        btree:PreCodeTree !symtb    svtree:PreCodeTree !symtb
        svtree:GenTreeCode !0 !-7   EndLn !true !true
        CheckLn !true  ["if ("]  btree:GenTreeCode !blov !bhiv  [ ") "]
        GoToBlock !true !bkext !symtb
        ["  else "]  GoToBlock !true !bktop !symtb
      |[dbrace=true; "}"]  EndLn !false !false )?
      brkt:Breakable !<> !0 !0 ^broke [comesout=(blov=0)`(broke>0)]
      StartBasicBlock !bkext !symtb
      ([natv=false; "//rof "; spell !vstr;
          " ------------------------"; ascii !00])?
  -> "while" CheckLn !false  [srctoklinch ^linz]  NativeCodeQ ^natv
      NewBlockNum ^bktop   NewBlockNum ^bkext
      [//"Boolean while condition in parentheses expected"//]
      ParExpn !symtb ^btree ^bxty ^blov ^bhiv
      [//"Boolean while expression expected"//]  IsBool !symtb !bxty
      ([natv=true; "  while ("; bktst=bktop]
        btree:GenTreeCode !blov !bhiv  [")"]
      |[blov+bhiv=2; bktst=bktop]  GoToBlock !true !bktop !symtb
      | NewBlockNum ^bktst
        btree:PreCodeTree !symtb
        ["  if ("]  btree:GenTreeCode !blov !bhiv  [")"]
        GoToBlock !true !bktop !symtb
        ["  else "]  GoToBlock !true !bkext !symtb
        StartBasicBlock !bktst !symtb  {in case there is a continue..}
        btree:PreCodeTree !symtb
        ["  if ("]  btree:GenTreeCode !blov !bhiv  [")"]
        GoToBlock !true !bktop !symtb
        ["  else "]  GoToBlock !true !bkext !symtb )
      StartBasicBlock !bktop !symtb
      ([natv=false; "//while "; " ------------------------"; ascii !00])?
      [outree=<wh <nn intree >%linz/4096+1 <>>; from !-2 !symtb ^brkt]
      brkt:Breakable !outree !0 !(bktst*65536+bkext) ^brox
      DoTvDeallo !symtb !true !<> ^tvsd
      [shiv=bktop; //"Repeatable statement expected after while"//]
      Statment !symtb !gazin !tvsd !-3 ^botree ^thout
      ([thout=true; botree@=<nc botree <nx>%outree >])?
      outree:InsertStuff !<if <> btree botree <ex>%outree > {outree=<wh}
      ([tvsd#<>; outree@=<nc outree tvsd >])?
      brkt:Breakable !<> !0 !0 ^broke [comesout=(blov=0)`(broke>0)]
      ([natv=false&blov+bhiv<2; shiv@=bkext; "  if ("]
        btree:PreCodeTree !symtb
        btree:GenTreeCode !blov !bhiv  [")"]
        GoToBlock !true !bktop !symtb  ["  else "])?
      GoToBlock !true !shiv !symtb
      StartBasicBlock !bkext !symtb
      ([natv=false; "//eliwh "; " ------------------------"; ascii !00])?
  -> "do" [srctoklinch ^linz; outree=<lp <nn intree >%linz/4096+1 <> <>>]
      CheckLn !false  [from !-2 !symtb ^brkt]  NativeCodeQ ^natv
      NewBlockNum ^bktop   NewBlockNum ^bkext   NewBlockNum ^bktst
      brkt:Breakable !outree !0 !(bktst*65536+bkext) ^brox
      GoToBlock !true !bktop !symtb
      StartBasicBlock !bktop !symtb
      ([natv=false; "//do "; " ------------------------"; ascii !00])?
      ([natv=true; "  do "])?
      [//"Repeatable statement expected after do"//]
      Statment !symtb !gazin !<> !-4 ^botree ^thout
      "while" [//"Boolean loop condition in parentheses expected"//]
      CheckLn !false   ParExpn !symtb ^btree ^bxty ^blov ^bhiv
      [//"Boolean do expression expected"//]  IsBool !symtb !bxty
      GoToBlock !true !bktst !symtb
      StartBasicBlock !bktst !symtb
      btree:PreCodeTree !symtb
      ([natv=true; "  while ("]|["  if ("])
      btree:GenTreeCode !blov !bhiv  [")"]
      GoToBlock !true !bktop !symtb
      ([natv=false; "  else "])?  GoToBlock !true !bkext !symtb
      DoTvDeallo !symtb !true !<> ^tvsd
      [//"Avoid String expressions in do-while condition"//; tvsd=<>]
      {EndLn !true !false}
      [//"Do needs a following semicolon"//] ";"              {outree=<lp}
      outree:InsertStuff !<if botree btree <nx>%outree <ex>%outree >
      brkt:Breakable !<> !0 !0 ^broke  [comesout=(blov=0)&thout`(broke>0)]
      StartBasicBlock !bkext !symtb
      ([natv=false; "//od "; " ------------------------"; ascii !00])?
  -> "try"  CheckLn !true  ["try"]
      [//"Try needs a statement block {in braces}"//]
      Blocks !<> !symtb !false !intree !0-9 ^outree ^out1 ^bsym  [ccnt=0]
      (CatchClause !symtb !outree ^outree@  [ccnt@=ccnt+1])* 
      ("finally" [//"Finally needs a statement block {in braces}"//]
        Blocks !<> !symtb !false !outree !0-11 ^outree@ ^out2 ^nsym
        [ccnt@=ccnt+1])?
      [//"Try must be followed by either 'catch' or 'finally'"//; ccnt>0]
      [comesout=gazin]
  -> "switch" CheckLn !false  [srctoklinch ^linz]  NativeCodeQ ^natv
      NewBlockNum ^bktop   NewBlockNum ^bkext
      [//"Switch expression in parentheses expected"//]
      ParExpn !symtb ^btree ^bxty ^blov ^bhiv
      [cases=<>; //"Scalar switch expression expected"//]   bxty:IsScalar
      [outree=<sw <nn intree >%linz/4096+1 btree <> <>>%bxty;
          from !-2 !symtb ^brkt]
      brkt:Breakable !outree !0 !bkext ^brox
      DoTvDeallo !symtb !true !<> ^tvsd
      [//"Avoid String expressions in switch expression"//; tvsd=<>]
      [//"Switch block must start '{'"//]  "{"
      ([natv=false; "//switch "; " ------------------------"; ascii !00])?
      ([natv=true; "  switch ("]
        btree:GenTreeCode !blov !bhiv  [") {"]  EndLn !false !true )?
      GoToBlock !true !bktop !symtb
      (SwitchBlockGroup !symtb !bxty !cases ^cases@ )*
      [//"Switch block must end '}'"//]  "}" 
      ("~" [//"This brace closes a switch block"//] "switch" )?
      outree:InsertStuff !cases {outree=<sw} {** no range calcs for now **}
      brkt:Breakable !<> !0 !0 ^broke  [comesout=gazin]
      StartBasicBlock !bktop !symtb
      btree:PreCodeTree !symtb
      ([natv=false; "  switch ("]
        btree:GenTreeCode !blov !bhiv [") {"] EndLn !false !true
        cases:SwitchCases !symtb )?
      ["  } //~switch"]  EndLn !false !true   CheckLn !true
      GoToBlock !true !bkext !symtb
      StartBasicBlock !bkext !symtb
  -> "break" { (Identifier ^idn)? }
      [from !-2 !symtb ^brkt; comesout=false]  NativeCodeQ ^natv
      [//"There is nothing to break out of here"//]
      brkt:Breakable !<> !1 !0 ^brox
      [brkt:<yk ..>%btree; outree=<ex intree >%btree]
      CheckLn !false  [//"Semicolon ';' required after break"//] ";"
      ([natv=true; "  break"]  EndLn !true !false )?
      GoToBlock !false !brox\32768 !symtb
      ([natv=false; "//break "; " ------------------------"; ascii !00])?
  -> "continue" { (Identifier ^idn)? }
      [from !-2 !symtb ^brkt; comesout=false]  NativeCodeQ ^natv
      [//"There is no loop to continue here"//]
      brkt:IsLoop ^btree
      brkt:Breakable !<> !-1 !0 ^brox
      CheckLn !false  [outree=<nx intree >%btree]
      [//"Semicolon ';' required after continue"//] ";"
      ([natv=true; "  continue"]  EndLn !true !false )?
      GoToBlock !false !brox !symtb
      ([natv=false; "//continue "; " ------------------------"; ascii !00])?
  -> "return"         NativeCodeQ ^natv
      CheckLn !natv   ([natv=true; "{"])?
      [srctoklinch ^linz; comesout=false; from !-11 !symtb ^stzp]
      ([stzp:<no <>>; dbrace=true]
      |[otherwise; dbrace=false]  stzp:StringArrayZaps )
      FuncInfo !symtb ^fun ^bxty ^par ^npms   {CheckLn !true}
      [nnst=<nn intree >%linz/4096+1]
      (";" [//"Return value expression expected here"//]
        [bxty=<>; vtree=<>; btree=nnst; upt=<>]
        DownRefPtrs !symtb !<>
        ([natv=true; " return"])?
      |[bxty=<>; vtree=<>; btree=nnst; upt=<>]
        [//"Semicolon expected after void return"//; 0=1]
      |[//"Return value expression or semicolon expected here"//]
        Expressn !symtb ^vtree ^exty ^loval ^hival
        [//"Return expression must match function result type"//]
        Assignable !symtb !bxty !exty
        IsPointer !bxty ^nby ^isPt ^iniz ^stf  ([stf:<st>; isPt@=false])?
        Coerce !symtb !bxty !exty !vtree ^xtree
        (xtree:PreCountAry  [isPt@=false])?
        [axes=<of <>>%npms*4+8; //"Semicolon expected after return"//]
        ";" ([nby>2; //"Huh? Return value too big"//; xtree:<dr upt >]
             [btree=<co nnst axes upt >%nby ]
        |([nby=2; upt=<fp>]
         |[otherwise]  xtree:ValRefer !bxty ^fxty ^upt ^qty )
         [tvsd=<as nnst axes xtree upt >%bxty]
         DoTvDeallo !symtb !true !tvsd ^btree )
        ([natv=false; upd=0]| DownRefAble !symtb !xtree ^upd )
        ([bitand !upd !1 ^upz; upz=1; isPt@=false])?
        xtree:PreCodeTree !symtb
        ([upd>1; " _tmp__ = "]|[natv=true; " return "]
        |ShoRetName !true !bxty )
        ([vtree=xtree&loval=hival]  xtree:GenTreeCode !loval !hival
        |[isPt=true; "("]  bxty:TypeSpell  [")up__ptr("]
         xtree:GenTreeCode !1 !0   [")"]
        |[otherwise]  xtree:GenTreeCode !loval !hival )
        ([upd>1]  EndLn !true !false )?   DownRefPtrs !symtb !xtree
        ([upd>1; " return _tmp__"])? )
      ([natv=true; ";}"])?   EndLn !(natv=false) !true
      ([gazin=true; outree=<rt btree >%fun]
        par:InsertStuff !outree  {par:<up>|<fp>}
      |[otherwise; outree=btree])
      GoToBlock !false !99999 !symtb
      ([natv=false; "//return "; " ------------------------"; ascii !00])?
  -> "synchronized"   [//"Boolean sync expression expected"//]
      ParExpn !symtb ^btree ^bxty ^blov ^bhiv
      IsBool !symtb !bxty
      [//"Sync needs a statement block {in braces}"//]
      Blocks !<> !symtb !false !intree !0-8 ^outree ^comesout ^bsym
                                                  {** not functional **}
  -> "throw" Expressn !symtb ^vtree ^exty ^loval ^hival
      [//"Semicolon ';' required after throw"//] ";"
      [comesout=false; outree=<th intree vtree >]
  -> ";"   EndLn !true !false
     [outree=intree; comesout=gazin]; {~KeyWdStmt}

CatchClause !symtb:table !intree:tree ^outree:tree  {** not functional **}
  -> "catch" "("   CheckLn !true  ["catch"; intstr !0 ^zs]
     (".."  ["(...)"; bodysym=symtb; pmlst=intree; //"Close paren??"//] ")"
     | FormParam !false !false !<> !0 !symtb !intree !zs
          ^menam ^pmlst ^bodysym ^nlocs )
     [//"Catch needs a statement block {in braces}"//]
     Blocks !<> !bodysym !true !pmlst !0-10 ^outree ^comesout ^bsym ;

SwitchBlockGroup !symtb:table !vty:tree !incase:tree ^outcase:tree
  -> SwitchLabel !symtb !vty ^lbls ^bkno     {fails clean when done}
     [srctoklinch ^linz; body=<nn <>>%linz/4096+1; comesout=true]
     (Statment !symtb !comesout !body !0 ^body@ ^comesout@ )*
     [//"Missing break at end of case"//; comesout=false]
     [outcase=<cs incase lbls body >%bkno] ; {~SwitchBlockGroup}

SwitchLabel !symtb:table !vty:tree ^lbls:tree ^bkno:int
  -> "default" [lbls=<>; //"Colon expected here"//] ":"  NativeCodeQ ^natv
     NewBlockNum ^bkno
     StartBasicBlock !bkno !symtb
      CheckLn !false  ([natv=false; "//"])?  ["default:"]  EndLn !false !true
  -> [lbls=<>; bkno=0]  NativeCodeQ ^natv  {fail terminates caller's loop..}
     ("case" ([bkno=0]  NewBlockNum ^bknx   [bkno@=bknx]
              StartBasicBlock !bknx !symtb )?
       CheckLn !false  ([natv=false; "//"])?  ["case "]
       [//"Case label must be same type constant as switch exprn"//]
       ConstExpn !false !symtb ^vtree ^exty ^intval    exty:IsScalar
       Comparable !false !symtb !vty !exty ^zty ^conv  [conv=0]
       ([intval=0`intval+intval#0; number !intval])?
       [lbls@=<cn lbls >%intval; //"Colon expected after case label"//]
       ":"  [":"]  EndLn !false !true )+ ; {~SwitchLabel}

ParExpn !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> "(" Expressn !symtb ^vtree ^exty ^loval ^hival
     [//"Unmatched left parenthesis, or bad expression"//] ")" ;

ConstExpn !stok:bool !symtb:table ^vtree:tree ^exty:tree ^intval:int
  -> Expressn !symtb ^vtree ^exty ^loval ^hival  {fails if not expn}
     [//"Constant value expected here"//] {if got expn, but not constant}
     ([stok=true; intval=-2147483648] ([vtree:<tc lnk <st>>]|[vtree:<ys>])
     |[loval=hival; intval=hival]  ([intval=0]| exty:IsScalar ));

Expressn !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BoolExpn !symtb ^xtree ^exty ^loval ^hival
     ([xtree:<cn>; vtree=xtree]
     |[xtree:<ch>; vtree=xtree]
     |exty:IsScalar  [loval=hival; vtree=<cn>%loval]
     |[otherwise; vtree=xtree]) ; {~Expressn}

BoolExpn !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BoolTerm !symtb ^vtree ^exty ^loval ^hival
     ("||" [//"OR operator requires boolean type"//] IsBool !symtb !exty
        [//"Boolean expression expected after ||"//]
        BoolTerm !symtb ^vtx ^xty ^lvx ^hvx
        [//"OR operator requires boolean type"//] IsBool !symtb !xty
        ([loval=1&hival=1`lvx=0&hvx=0]
        |[loval=0&hival=0`lvx=1&hvx=1; vtree@=vtx; loval@=lvx; hival@=hvx]
        |[vtree@=<or vtree vtx >%exty; loval@=0; hival@=1]) )* ;

BoolTerm !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BoolPrim !symtb ^vtree ^exty ^loval ^hival
     ("&&" [//"AND operator requires boolean type"//] IsBool !symtb !exty
        [//"Boolean expression expected after &&"//]
        BoolPrim !symtb ^vtx ^xty ^lvx ^hvx
        [//"AND operator requires boolean type"//] IsBool !symtb !xty
        ([loval=0&hival=0`lvx=1&hvx=1]
        |[loval=1&hival=1`lvx=0&hvx=0; vtree@=vtx; loval@=lvx; hival@=hvx]
        |[vtree@=<an vtree vtx >%exty; loval@=0; hival@=1]) )* ;

BoolPrim !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> CatExpn !symtb ^vtree ^exty ^loval ^hival
     ("instanceof"  [//"Left operand of instanceof must be an object"//]
       exty:IsObject ^tname ^osiz ^ptyp ^osym
       [//"Object type name expected to the right of 'instanceof'"//]
       TypeName !symtb ^xty ^theName  xty:IsObject ^tnamx ^xsiz ^xtyp ^osym
       [//"Object type must be same or subtype of this type"//]
       SubClass !exty !xty
       [from !2 !symtb ^exty@; vtree@=<tk vtree >%xty; loval@=0; hival@=1]
     |RelOp ^cop  (exty:IsObject ^tname ^osiz ^ptyp ^osym
        [//"Left operand of order compare must not be an object"//; cop<2])?
       IsPointer !exty ^psiz ^isPt ^iniz ^stf  ([stf:<st>; isPt@=false])?
       ([isPt=true; //"Must not order-compare array reference"//; cop<2]
        vtree:AutoDownRef !exty )?
       [//"Expression expected after compare operator"//]
       CatExpn !symtb ^vtx ^xty ^lvx ^hvx
       ([isPt=true]  vtx:AutoDownRef !exty )?
       [//"The expressions being compared must be compatible"//]
       Comparable !(cop<2) !symtb !exty !xty ^rty ^conv
       ([conv>0`conv+2=0] Coerce !symtb !rty !exty !vtree ^vtree@
        Unbounded ^loval@ ^hival@ )?
       ([conv<0] Coerce !symtb !rty !xty !vtx ^vtx@
        Unbounded ^lvx@ ^hvx@ )?
       (exty:IsScalar  xty:IsScalar  [loval=hival&lvx=hvx]
         ([cop=0&loval=lvx`cop=1&loval#lvx; lov=1]
         |[cop=0&loval#lvx`cop=1&loval=lvx; lov=0]
         |[cop=2&loval<lvx`cop=3&lvx-loval<1; lov=1]
         |[cop=3&loval<lvx`cop=2&lvx-loval<1; lov=0]
         |[cop=4&loval>lvx`cop=5&loval-lvx<1; lov=1]
         |[cop=5&loval>lvx`cop=4&loval-lvx<1; lov=0])
         [vtree@=<cn>%lov; hiv=lov]
       |[from !6 !symtb ^rty]
         ([loval=hival&lvx=hvx&loval=lvx; lov=1; hiv=1]
         |[loval=hival&lvx=hvx; lov=0; hiv=0]
         |[loval=hival&loval=0 ` lvx=hvx&lvx=0]
          [from !1 !symtb ^rty@; lov=0; hiv=1]
         |[otherwise; lov=0; hiv=1]
           vtree:ValRefer !rty ^vtrv ^uprv ^xrv
           ([uprv#<>; vtrv@=<pr vtrv uprv >])?
           vtx:ValRefer !rty ^vtrx ^uprx ^xrx
           ([uprx#<>; vtrx@=<pr vtrx uprx >])?
           {[vtree@=<sy <> vtrv vtrx <nn>%-8 >%2]}
           ([cop=0; vtree@=<eq vtrv vtrx >%rty]
           |[cop=1; vtree@=<ne vtrv vtrx >%rty]
           |[cop=2; vtree@=<ls vtrv vtrx >%rty]
           |[cop=4; vtree@=<gr vtrv vtrx >%rty]
           |[cop=3; vtree@=<ge vtrv vtrx >%rty]
           |[cop=5; vtree@=<le vtrv vtrx >%rty]))
       |[otherwise; lov=0; hiv=1]
         ([cop=0; vtree@=<eq vtree vtx >%rty]
         |[cop=1; vtree@=<ne vtree vtx >%rty]
         |[cop=2; vtree@=<ls vtree vtx >%rty]
         |[cop=4; vtree@=<gr vtree vtx >%rty]
         |[cop=3; vtree@=<ge vtree vtx >%rty]
         |[cop=5; vtree@=<le vtree vtx >%rty]))
       [from !2 !symtb ^bty; exty@=bty; loval@=lov; hival@=hiv] )? ;

RelOp ^cop:int
  -> "==" [cop=0]| "!=" [cop=1]
  -> "<" [cop=2]| ">=" [cop=3]| ">" [cop=4]| "<=" [cop=5] ;

CatExpn !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BitExpn !symtb ^vtree ^exty ^loval ^hival
     ("#" [//"String operands required for # operator"//]
       Stringable !symtb !exty
       [from !6 !symtb ^sty; //"String expression expected after #"//]
       BitExpn !symtb ^vtx ^xty ^lvx ^hvx
       [//"Catenate operator requires String operands"//]
       Stringable !symtb !xty       {** check for constant strings?? **}
       Coerce !symtb !sty !exty !vtree ^rtz
       rtz:ValRefer !sty ^argz ^uprz ^xrz
       ([uprz#<>; argz@=<pr argz uprz >])?
       Coerce !symtb !sty !xty !vtx ^rtx
       rtx:ValRefer !sty ^argx ^uprx ^xrx
       ([uprx#<>; argx@=<pr argx uprx >])?
       [exty@=sty; loval@=-1; hival@=-2]
       ([argx:<ys>; vxtree=argz]|[argz:<ys>; vxtree=argx]
       | TempSave !true !symtb !<ca argz argx > ^vxtree )
       [vtree@=vxtree])* ;

BitExpn !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BitTerm !symtb ^vtree ^exty ^loval ^hival
     ("|" [//"Bit operator requires int operands"//; from !1 !symtb ^inty]
       Assignable !symtb !inty !exty
       [m1=<cn>%-1; //"Integer expression expected after bit OR"//]
       BitTerm !symtb ^vtx ^xety ^lvx ^hvx
       Assignable !symtb !inty !xety
       RangeBits !loval !hival ^lo1 ^hi1
       RangeBits !lvx !hvx ^lo2 ^hi2
       [bitand !-1-lo1 !-1-lo2 ^lo3; bitand !-1-hi1 !-1-hi2 ^hi3]
       [loval@=-1-lo3; hival@=-1-hi3; vtree@=<or vtree vtx >%exty])* ;

BitTerm !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BitFact !symtb ^vtree ^exty ^loval ^hival
     ("^" [//"Bit operator requires int operands"//; from !1 !symtb ^inty]
       Assignable !symtb !inty !exty
       [//"Integer expression expected after bit XOR"//]
       BitFact !symtb ^vtx ^xety ^lvx ^hvx
       Assignable !symtb !inty !xety
       ([loval=hival & lvx=hvx; bitand !loval !-1-lvx ^lo1]
        [bitand !-1-loval !lvx ^lo2; lo0=lo1+lo2; hi0=lo0]
       | RangeBits !loval !hival ^lo1 ^hi1
         RangeBits !lvx !hvx ^lo2 ^hi2
         [bitand !lo1 !lo2 ^lo0]              {use & for lo, | for hi}
         [bitand !-1-hi1 !-1-hi2 ^hi3; hi0=-1-hi3])
       [loval@=lo0; hival@=hi0; vtree@=<xo vtree vtx >%exty])* ;

BitFact !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> BitPrim !symtb ^vtree ^exty ^loval ^hival
     ("&" [//"Bit operator requires int operands"//; from !1 !symtb ^inty]
       Assignable !symtb !inty !exty
       [//"Integer expression expected after bit AND"//]
       BitPrim !symtb ^vtx ^xety ^lvx ^hvx
       Assignable !symtb !inty !xety
       RangeBits !loval !hival ^lo1 ^hi1
       RangeBits !lvx !hvx ^lo2 ^hi2
       [bitand !lo1 !lo2 ^loval@; bitand !hi1 !hi2 ^hival@]
       [vtree@=<an vtree vtx >%exty])* ;

BitPrim !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> MathExpn !symtb ^vtree ^exty ^loval ^hival 
     (ShiftOp ^cop
       [//"Shift operator requires integer operands"//;
         from !1 !symtb ^inty]
       Assignable !symtb !inty !exty
       [//"Integer expression expected after shift operator"//]
       MathExpn !symtb ^vtx ^xety ^lvx ^hvx
       Assignable !symtb !inty !xety
       ([cop<0; vtree@=<sl vtree vtx >%exty]
       |[otherwise; vtree@=<sr vtree vtx >%exty]) {all sr is signed}
       HighBitOf !loval ^tlo   HighBitOf !hival ^thi
       RangeBits !lvx !hvx ^lo2 ^hi2
       [bitand !lo2 !31 ^slo; bitand !hi2 !31 ^shi]
       ShiftBits !tlo !shi ^hilo       ShiftBits !thi !shi ^lohi
       Unbounded ^ilo ^ihi
       ([shi=0]             {no shift possible, keep hival}
       |[cop<0&hival>-1&lohi>hival] ShiftBits !hival !shi ^hival@
       |[cop<0&hival<0&lohi<hival]  ShiftBits !hival !slo ^hival@
       |[cop=0&loval<0; max !slo-1 !0 ^slx]
         ShiftBits !ihi !-slx ^hival@
       |[cop>-1&hival>-1]           ShiftBits !hival !-slo ^hival@
       |[cop>0&hival<0]             ShiftBits !hival !-shi ^hival@
       |[otherwise; hival@=ihi])
       ([shi=0]             {no shift possible, keep loval}
       |[cop<0&loval<0&hilo<loval]  ShiftBits !loval !shi ^loval@
       |[cop<0&loval>-1&hilo>loval] ShiftBits !loval !slo ^loval@
       |[cop=0&hival<0; bitand !(loval+1)/2-1 !ihi ^zsh]
         ShiftBits !zsh !1-shi ^loval@
       |[cop=0&loval<0&hival>-1; loval@=0]
       |[cop>-1&loval>-1]           ShiftBits !loval !-shi ^loval@
       |[cop>0&loval<0]             ShiftBits !loval !-slo ^loval@
       |[otherwise; loval@=ilo]) )* ;

ShiftOp ^cop:int
  -> "<<" [cop=-1]| ">>>" [cop=0]| ">>" [cop=1] ;

MathExpn !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> MathTerm !symtb ^vtree ^exty ^loval ^hival  
     (AddOp ^cop
       [//"Add/subtract operator requires numeric operands"//]
       IsNumeric !symtb !exty ^isint
       [//"Numeric expression expected after add/subtract operator"//]
       MathTerm !symtb ^vtx ^xty ^lvx ^hvx
       IsNumeric !symtb !xty ^xint
       Comparable !false !symtb !exty !xty ^rty ^conv
       Coerce !symtb !rty !exty !vtree ^ltr
       Coerce !symtb !rty !xty !vtx ^rtr
       rty:GetTypeRange ^rnty ^ilo ^ihi
       ([cop>0; vtrt=<ad ltr rtr >%rty]
         AddnOflo !isint>0&xint>0 !loval !lvx !ilo ^lov
         AddnOflo !isint>0&xint>0 !hival !hvx !ihi ^hiv
       |[cop=0; vtrt=<su ltr rtr >%rty]
         ([lvx=hvx&loval=hival; lov=loval-lvx; hiv=lov]
         |[lvx<0&lvx+lvx=0; lov=ilo; hiv=ihi]|[otherwise]
          AddnOflo !isint>0&xint>0 !loval !-hvx !ilo ^lov
          AddnOflo !isint>0&xint>0 !hival !-lvx !ihi ^hiv ))
       [vtree@=vtrt; exty@=rty; loval@=lov; hival@=hiv])* ;

AddOp ^cop:int
  -> "+" [cop=1]| "-" [cop=0] ;

MathTerm !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> Primary !symtb ^vtree ^exty ^loval ^hival
     (MulOp ^cop
       [//"Multiply/div operator requires numeric operands"//]
       IsNumeric !symtb !exty ^isint
       [//"Numeric expression expected after multiply/div operator"//]
       Primary !symtb ^vtx ^xty ^lvx ^hvx
       IsNumeric !symtb !xty ^xint
       Comparable !false !symtb !exty !xty ^rty ^conv
       Coerce !symtb !rty !exty !vtree ^ltr
       Coerce !symtb !rty !xty !vtx ^rtr
       rty:GetTypeRange ^rnty ^ilo ^ihi
       ([cop=0; vtree@=<mp ltr rtr >%rty]
         Unbounded ^noval ^zival
         ([loval=noval`lvx=noval`hival=zival`hvx=zival; tbb=zival; xbb=tbb]
         |[otherwise]  HighBitOf !loval ^tlo   HighBitOf !hival ^thi
            HighBitOf !lvx ^xlo     HighBitOf !hvx ^xhi
          [max !thi !tlo ^tbb; max !xhi !xlo ^xbb])
         ([isint<1`xint<1; loval@=ilo; hival@=ihi] {one or both float, can't}
         |[loval=0&hival=0; vtree@=ltr]
         |[lvx=0&hvx=0; loval@=0; hival@=0; vtree@=rtr]
         |[loval=1&hival=1; loval@=lvx; hival@=hvx; vtree@=rtr]
         |[lvx=1&hvx=1; vtree@=ltr]
         |[loval=hival&lvx=hvx; loval@=loval*lvx; hival@=hival*hvx] {cn*cn}
         |[loval=-1&hival=-1; loval@=-hvx; hival@=-lvx;
            vtree@=<ng rtr >%rty]
         |[lvx=-1&hvx=-1; loval@=-hival; hival@=-loval;
            vtree@=<ng ltr >%rty]
         |[tbb>32767&xbb>32767; loval@=ilo; hival@=ihi] {could overflow}
         |[tbb*xbb=0; loval@=ilo; hival@=ihi]    {could overflow}
         |[otherwise;
            max !loval*lvx !hival*hvx ^shx;
            max !loval*hvx !hival*lvx ^ohx;
            min !loval*lvx !hival*hvx ^slx;
            min !loval*hvx !hival*lvx ^olx;
            max !shx !ohx ^hival@;  min !slx !olx ^loval@])
       |[cop<0; vtree@=<md ltr rtr >%rty]
         ([isint<1`xint<1; loval@=ilo; hival@=ihi]
         |[lvx=0&hvx=0; //"Divide by zero"//; lvx>hvx]
         |[lvx=1&hvx=1; loval@=0; hival@=0]    {divide/1, rem=0}
         |[lvx=hvx&loval=hival; loval@=loval\lvx; hival@=hival\hvx]
         |([hival>0; max !-1-lvx !hvx-1 ^hival@]|[otherwise; hival@=0])
          ([loval<0; min !lvx+1 !1-hvx ^loval@]
          |[otherwise; loval@=0]))
       |[cop>0; vtree@=<dv ltr rtr >%rty]
         ([isint<1`xint<1; loval@=ilo; hival@=ihi]
         |[lvx=0&hvx=0; //"Divide by zero"//; lvx>hvx]
         |[lvx=1&hvx=1; vtree@=ltr]      {divide/1, keep old values}
         |[lvx=-1&hvx=-1; loval@=-hival; hival@=-loval;
            vtree@=<ng ltr >%rty]
         |[lvx<0&hvx>0; shx=hival; slx=loval; max !shx !-slx ^hival@;
            min !slx !-shx ^loval@]   {/0 is trapped, greatest is /1}
         |[lvx=hvx&loval>-1]  Power2 !lvx ^olx
          [vtree@=<sr ltr <cn>%olx >; loval@=loval/lvx; hival@=hival/hvx]
         |[otherwise;
            max !loval/lvx !hival/hvx ^shx;
            max !loval/hvx !hival/lvx ^ohx;
            min !loval/lvx !hival/hvx ^slx;
            min !loval/hvx !hival/lvx ^olx;
            max !shx !ohx ^hival@;  min !slx !olx ^loval@]) ) )* ;

MulOp ^cop:int
  -> "%" [cop=-1]| "*" [cop=0]| "/" [cop=1] ;

Primary !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> "&" [//"Import 'Dangerous' to use this"//; from !19 !symtb ^prox]
       [//"Can't get address of that"//]
       LeftOrCall !<> !symtb !<ft> !<> !0 ^vrtree ^typ ^isFn ^loval ^hival
       [isFn#0; vtree=<by vrtree >; from !1 !symtb ^exty]
  -> "!" Primary !symtb ^xtree ^exty ^xlo ^xhi
       [//"NOT operator requires boolean type"//] IsBool !symtb !exty
       [loval=1-xhi; hival=1-xlo; vtree=<nt xtree >%exty]
  -> "~" Primary !symtb ^xtree ^exty ^xlo ^xhi
       [//"Bit operator requires integer operand"//; from !1 !symtb ^exty]
       [loval=-1-xhi; hival=-1-xlo; vtree=<lx xtree >%exty]
  -> "+" Primary !symtb ^vtree ^exty ^loval ^hival 
       [//"Positive sign operator requires numeric operand"//]
       IsNumeric !symtb !exty ^isint
  -> "-" Primary !symtb ^xtree ^exty ^xlo ^xhi
       [//"Sign operator requires numeric operand"//]
       IsNumeric !symtb !exty ^isint
       [vtree=<ng xtree >%exty; loval=-xhi; hival=-xlo]
  -> "{" [from !1 !symtb ^ity; nelts=0; elty=<>; vrtree=<>; root=<dr <>>%1]
       (Expressn !symtb ^etree ^typ ^xlo ^xhi
         ([elty=<>; elty@=typ]
         |[//"Array elements must be same type"//; elty=typ])
         [vrtree@=<as vrtree <of root >%nelts etree <> >%typ]
         [nelts@=nelts+1])$","
       [//"Faulty array constructor, expected '}' here"//]  "}" 
       elty:TypeSize !false ^siz
       [rnty=<ty <> <sz>%1 <rn <cn>%0 <cn>%nelts-1 ity >>; loval=0]
       [asz=nelts*siz; exty=<ty <> <sz>%asz <ar rnty typ <>>>]
       [vtree=<al vrtree exty >%asz; hival=nelts-1]
  -> ParExpn !symtb ^vtree ^exty ^loval ^hival
  -> Creator !symtb ^vtree ^exty
       exty:GetTypeRange ^rnty ^loval ^hival
  -> Literal !symtb ^vtree ^exty ^loval ^hival
  -> [//"Invalid expression value"//]
     LeftOrCall !<> !symtb !<> !<> !0 ^vrtree ^exty ^isFn ^loval ^hival
     exty:TypeSize !false ^siz
     ([isFn=0; vtree=vrtree]
     |[otherwise; vtree=<dr vrtree >%siz])
     vtree:OptDeref ; {~Primary}

Literal !symtb:table ^vtree:tree ^exty:tree ^loval:int ^hival:int
  -> NUM ^intn                                    { IntegerLit }
      [from !1 !symtb ^exty; vtree=<cn>%intn; loval=intn; hival=intn]
  -> HEX ^intn
      [from !1 !symtb ^exty; vtree=<cn>%intn; loval=intn; hival=intn]
  -> CHR ^intn                                   { CharacterLit }
      [from !3 !symtb ^exty; vtree=<ch>%intn; loval=intn; hival=intn]
  -> STR ^strs                                     { StringLit }
      [from !6 !symtb ^exty; strint !strs ^strn]
      ([stleng !strs ^intn; intn=0; vtree=<ys>]
      |StringConstant !strs !symtb ^nutk
       [//"Oops, literal string failed"//; nutk#<>; vtree=nutk])
      [loval=strn; hival=-strn]
  -> FLT ^strs                           { FloatingPointLit = double }
      [from !5 !symtb ^exty; vtree=<dc <> exty <cn>%strs >]
      [intval=0]
  -> ("true" [intn=1]| "false" [intn=0])           { BooleanLit }
      [from !2 !symtb ^exty:<ty lnk siz <en elk <dc fls bty tru:<cn>> >>]
      ([intn=1; vtree=tru]|[intn=0; fls:<dc blk fty vtree >])
      [loval=intn; hival=intn]
  -> "null" [from !8 !symtb ^<dc lnk exty vtree >; loval=0; hival=0];

Creator !symtb:table ^vtree:tree ^exty:tree
  -> "new" [//"Class name (constructor) or array expected here"//]
     TypeName !symtb ^theTy ^tname
     ("[" [from !1 !symtb ^ixty]
        theTy:TypeSize !true ^siz
        [//"Integer array size >0 expected here"//]
        Expressn !symtb ^etree ^ixty ^lov ^hiv   [hiv>0]
        ([lov<1; etree@=<jm etree <cn>%1 >])?
        ([lov=hiv; rty=<ty <> <sz>%1 <rn <cn> <cn>%hiv-1 ixty >>]
         [asz=siz*lov; nntr=<cn>%asz]
        |[siz>1; rty=ixty; nntr=<dy <mp etree <cn>%siz >>]
        |[otherwise; rty=ixty; nntr=<dy etree >])
        [irty=<ty <> <sz>%1 <rn <cn> <cn>%-1 rty >>]
        [atyp=<ar irty theTy >; arty=<ty <> <sz> atyp >]
        atyp:InsertStuff !arty  {atyp=<ar}
        [exty=<ty <> <sz>%1 atyp >; vtree=<ar <> exty nntr >]
        [//"There is a problem with array size (missing ']')"//]  "]"
     | theTy:IsObject ^xname ^lov ^ixty ^osym
       ("("  (")"  [etree=<>]
         |[ixty:<cl atyp rty nntr elts ..>; arty=<dr <>>%1]
           nntr:PoorManConstor !true !symtb !arty !<> ^booz ^irty
           elts:PoorManConstor !booz !symtb !arty !irty ^boox ^etree
          [//"Close ')' expected, possibly expn error"//]  ")")
       |[otherwise; etree=<>])
       [vtree=<al etree theTy >%lov; exty=theTy]) ;

ConstrValue !symtb:table !axes:tree !prms:tree !intree:tree
         !fust:bool ^outree:tree            {called only by PoorManConstor}
  -> ([fust=false; //"Too few values (or syntax error)"//] ",")?
     [prms:<vr link theTy adr loc:<of root >%offx smx >; treeint !offx ^ofs]
     [//"Value expected in constructor for each field"//]
     Expressn !symtb ^etree ^exty ^loval ^hival
     [//"Value type must be compatible with field"//]
     Assignable !symtb !theTy !exty
     IsPointer !theTy ^asiz ^xPt ^iniz ^stx
     IsPointer !exty ^xsiz ^isPt ^inix ^stf
     Coerce !symtb !theTy !exty !etree ^atree  {adds <rf..> to mk ptr}
     ([atree:<cn>; uprf=<>; vtree=atree]      {actual param is const}
     |[atree:<ch>; uprf=<>; vtree=atree]      {actual param is const}
     |[atree:<tc ..>; uprf=<>; vtree=atree]   {actual param is str const}
     |[atree:<ys>; uprf=<>; vtree=atree]      {actual param is str const}
     |[isPt=true & stf=<> & (loval#0`hival#0); uprf=<pt>] {val is ptr..}
       ([xPt=true; vtree=atree]|[otherwise; vtree=<dr atree >%1])
     |[asiz=2; uprf=<fp>; vtree=atree]
     |[//"Can't construct value that big"//; asiz<3; uprf=stf; vtree=atree])
     ([vtree:<cn>%zrt; treeint !zrt ^zrn; zrn=0; outree=intree]
     |[vtree:<ys>; outree=intree]
     |[otherwise; outree=<as intree <of axes >%ofs vtree uprf >%theTy ]);

Argments !symtb:table !prms:tree !sofar:tree !tname:str
       ^mname:str ^vtree:tree
  -> [prms=<>; mname=tname; vtree=sofar]
  -> [prms:<vr link theTy adr loc smx >]
     ([smx:<sm>; uprf=smx; //"Semaphore reference expected"//]
       QualIdent !1 !-1 !symtb !symtb !<> ^xnm ^vnm ^argv ^theTy
           ^mox ^loval ^hival
     |[//"Argument expression expected here"//]
      Expressn !symtb ^xtree ^exty ^loval ^hival
      [//"Argument type must be compatible with formal parameter"//]
      Assignable !symtb !theTy !exty
      Coerce !symtb !theTy !exty !xtree ^etree  {adds <rf..> to mk ptr}
      ([adr:<pm>; from !-10 !symtb ^prx; prx:<nm plst >]
        etree:StringFrom ^pnst
        prx:InsertStuff !<nm plst >%pnst )?      {prx:<nm}
      etree:ValRefer !theTy ^argv ^uprf ^xrf
      ([uprf#<>; argv@=<pr argv uprf >; uprf@=<>])?  {uprf:<st>/<pt>/<fp>}
      IsPointer !exty ^nby ^isPt ^iniz ^stf
      ([from !8 !symtb ^<dc lnk nulty ..>; theTy=nulty; xtype=<>]
      |[xtype=theTy])
      (etree:PreCountAry  [isPt@=false])?  ([stf:<st>; isPt@=false])?
      ([isPt=true&loval#hival; argv@=<pr argv <up>%xtype >])? )
     [args=<at sofar argv adr uprf >%theTy ]
     ([link=<>; mname=tname; vtree=args]
     |[otherwise; //"More arguments expected"//]
       "," Argments !symtb !link !args !tname ^mname ^vtree ) ;

Identifier ^ident:str -> ID ^ident;

TypeName !symtb:table ^theTy:tree ^theNm:str   {QualIden can forbid []}
  -> "long"  [//"We don't do long int"//; 0=1; theTy=<>; intstr !0 ^theNm]
  -> QualIdent !0 !0 !symtb !vacant !<>
         ^theNm ^vnm ^vtr ^theTy ^mods ^lox ^hix 
     [//"Expected type name here"//]  theTy:TypeSize !false ^tsiz ;

{utility nonterminals..}

AddnOflo !isint:bool !a:int !b:int !defalt:int ^sum:int
  -> [isint=false; sum=defalt]
  -> [a<0&b>0`a>0&b<0`a=0`b=0; sum=a+b]
  -> [sum=a+b; a>0&sum>0]
  -> [sum=a+b; a<0&sum<0]
  -> [sum=defalt] ;

Assignable !symtb:table !xtype:tree !ytype:tree {true if x := y OK}
  -> [xtype:<ty xlk xsz <sm>>; //"Semaphore cannot be assigned"//; 0=1]
  -> [xtype=ytype]
  -> IsNumeric !symtb !xtype ^xint   IsNumeric !symtb !ytype ^yint
     [xint<yint+1] {unmatched numeric types can assign to larger}
  -> [ytype:<ty ylk ysz <pt <nl>>>]  {nil assigns to any ptr or opaque}
     ([xtype:<ty xlk xsz <pt xty >>]
     |[xtype:<ty xlk xsz <>>]
     | xtype:ArrayBounds ^ztyp ^rnty ^hival ^xint  [hival<0])
  -> [xtype:<ty xlk xsz <pt <nl>>>] {any ptr/struct assigns to generic ptr}
     ([ytype:<ty ylk ysz <pt ..>>]|[ytype:<ty ylk ysz <cl ..>>]
     | ytype:ArrayBounds ^ztyp ^rxty ^xint ^hiv )
  -> [xtype:<ty xlk xsz <pt xty >>]  {same class or ptr to it..}
     ([ytype:<ty ylk ysz <pt xty >>]|[ytype:<ty ylk ysz xty >]
     | SubClass !ytype !xtype ) {fails if y is not = or sub of x}
  -> [xtype:<ty xlk xsz xty:<cl ..>>; ytype:<ty ylk ysz <pt xty >>]
  -> [xtype:<ty xlk xsz <ar rxty xty ..>>]  {same elt type}
     [ytype:<ty ylk ysz <ar ryty xty ..>>]  {and also same size array,}
     rxty:GetTypeRange ^rnty ^lov ^hiv   ([lov>hiv]  {or dyn recvr}
       | ryty:GetTypeRange ^rzty ^yint ^xint  [xint-yint=hiv-lov])
  -> [xtype:<ty xlk xsz <st>>]  (IsNumeric !symtb !ytype ^yint  {I->S}
       |[from !3 !symtb ^ytype]|[from !2 !symtb ^ytype]  {C->S|B->S}
       |[from !4 !symtb ^ytype])                         {C4->S}
  -> [from !4 !symtb ^xtype; from !6 !symtb ^ytype]      {S->C4}
  -> [from !5 !symtb ^xtype; from !1 !symtb ^ytype];  {I->F} {~Assignable}

BuiltinTypes !insym:table ^outsym:table ^main:str
  -> [initbl; addtbl !109; addtbl !97; addtbl !105; addtbl !110;
       strindex !0 !1 ^main]                      {'main' is used by caller}
     [initbl; addtbl !110; addtbl !117; addtbl !108; addtbl !108;
       strindex !0 !1 ^nnam]                                       {'null'}
     [initbl; addtbl !79; addtbl !98; addtbl !106; addtbl !101;
       addtbl !99; addtbl !116; strindex !0 !1 ^onam]            {'Object'}
     [initbl; addtbl !83; addtbl !116; addtbl !114; addtbl !105;
       addtbl !110; addtbl !103; strindex !0 !1 ^snam]           {'String'}
     [initbl; addtbl !84; addtbl !104; addtbl !114; addtbl !111;
       addtbl !119; addtbl !97; addtbl !98; addtbl !108; 
       addtbl !101; strindex !0 !1 ^tnam]                     {'Throwable'}
     [initbl; addtbl !105; addtbl !110; addtbl !116;
       strindex !0 !1 ^inam]                                        {'int'}
     [initbl; addtbl !98; addtbl !111; addtbl !111; addtbl !108;
       addtbl !101; addtbl !97; addtbl !110; 
       strindex !0 !1 ^bnam]                                    {'boolean'}
     [initbl; addtbl !116; addtbl !114; addtbl !117; addtbl !101;
       strindex !0 !1 ^trunm]                                      {'true'}
     [initbl; addtbl !102; addtbl !97; addtbl !108; addtbl !115;
       addtbl !101; strindex !0 !1 ^flsnm]                        {'false'}
     [initbl; addtbl !99; addtbl !104; addtbl !97; addtbl !114;
       strindex !0 !1 ^cnam]                                       {'char'}
     [initbl; addtbl !102; addtbl !108; addtbl !111; addtbl !97;
       addtbl !116; strindex !0 !1 ^fnam]                         {'float'}
     [initbl; addtbl !100; addtbl !111; addtbl !117; addtbl !98;
       addtbl !108; addtbl !101; strindex !0 !1 ^dnam]           {'double'}
     [initbl; addtbl !118; addtbl !111; addtbl !105; addtbl !100;
       strindex !0 !1 ^vnam]                                       {'void'}
     [initbl; addtbl !116; addtbl !104; addtbl !105; addtbl !115;
       strindex !0 !1 ^mnam]                                       {'this'}
     [initbl; addtbl !67; addtbl !104; addtbl !97; addtbl !114;
       addtbl !52; strindex !0 !1 ^Char4]                         {'Char4'}
     [initbl; addtbl !67; addtbl !72; addtbl !82; addtbl !52;
       strindex !0 !1 ^CHR4]                                       {'CHR4'}
     [initbl; addtbl !80; addtbl !97; addtbl !99; addtbl !107;
       addtbl !84; addtbl !101; addtbl !120; addtbl !116;
       strindex !0 !1 ^PkTxt]                                  {'PackText'}
     [initbl; addtbl !84; addtbl !101; addtbl !120; addtbl !116;
       addtbl !67; addtbl !104; addtbl !97; addtbl !114;
       strindex !0 !1 ^TxtCh]                                  {'TextChar'}
     [initbl; addtbl !79; addtbl !82; addtbl !68; strindex !0 !1 ^zORD]
     [initbl; addtbl !67; addtbl !72; addtbl !82; strindex !0 !1 ^zCHR]
     [initbl; addtbl !77; addtbl !73; addtbl !78; strindex !0 !1 ^zMIN]
     [initbl; addtbl !77; addtbl !65; addtbl !88; strindex !0 !1 ^zMAX]
     [initbl; addtbl !65; addtbl !66; addtbl !83; strindex !0 !1 ^zABS]
     [initbl; addtbl !76; addtbl !69; addtbl !78; addtbl !71;
       addtbl !84; addtbl !72; strindex !0 !1                 ^zLENGTH]
     [initbl; addtbl !82; addtbl !65; addtbl !87; addtbl !95;
       addtbl !67; addtbl !79; addtbl !68; addtbl !69;
       strindex !0 !1 ^RawCo]                                {'RAW_CODE'}
     [initbl; addtbl !72; addtbl !85; addtbl !71; addtbl !69;
       addtbl !95; addtbl !78; addtbl !79; addtbl !80;
       strindex !0 !1 ^HugeN]                                {'HUGE_NOP'}
     [initbl; addtbl !83; addtbl !101; addtbl !109; addtbl !97;
       addtbl !112; addtbl !104; addtbl !111; addtbl !114;
       addtbl !101; strindex !0 !1 ^Semaphor]                {'Semaphore'}
     [initbl; addtbl !83; addtbl !101; addtbl !109; addtbl !97;
       addtbl !112; addtbl !104; addtbl !111; addtbl !114;
       addtbl !101; addtbl !115; strindex !0 !1 ^Semphors]  {'Semaphores'}
     [initbl; addtbl !83; addtbl !105; addtbl !103; addtbl !110;
       addtbl !97; addtbl !108; strindex !0 !1 ^zSignal]
     [initbl; addtbl !87; addtbl !97; addtbl !105; addtbl !116;
       strindex !0 !1 ^zWait]
     [initbl; addtbl !80; addtbl !69; addtbl !69; addtbl !75;
       strindex !0 !1 ^PEEK]
     [initbl; addtbl !80; addtbl !79; addtbl !75; addtbl !69;
       strindex !0 !1 ^POKE]
     [initbl; addtbl !70; addtbl !79; addtbl !82; addtbl !75;
       addtbl !69; addtbl !82; strindex !0 !1 ^FORKER]          {'FORKER'}
     [initbl; addtbl !67; addtbl !79; addtbl !67; addtbl !65;
       addtbl !76; addtbl !76; strindex !0 !1 ^COCALL]
     [initbl; addtbl !67; addtbl !48; addtbl !68; addtbl !69;
       strindex !0 !1 ^c0de]                                      {'C0DE'}
     [initbl; addtbl !68; addtbl !69; addtbl !66; addtbl !85;
       addtbl !71; strindex !0 !1 ^DEBUG]                        {'DEBUG'}
     [initbl; addtbl !68; addtbl !97; addtbl !110; addtbl !103;
       addtbl !101; addtbl !114; addtbl !111; addtbl !117;
       addtbl !115; strindex !0 !1 ^Dangerous]                 {Dangerous}

   {1:int; 12:short; 13:byte}
     [aty=<ty <> <sz>%1 <>>; ity=<ty aty <sz>%1 <>>%inam; bigno=1]
     ([bigno>0; bigno@=bigno*2])*
     aty:InsertStuff !<rn <cn>%0 <cn>%0-1 ity >           {aty=<ty}
     ity:InsertStuff !<rn <cn>%bigno+1 <cn>%bigno-1 ity > {ity=<ty}
     [treeflag !ity !1]
     [into !1 !insym !ity ^sym1i; sinto !inam !sym1i !ity ^sym1]
   {2:bool; 10:false; 11:true}
     [bty=<ty ity <sz>%1 <>>%bnam; fls=<dc <> bty <cn>%0 >%flsnm]
     [tru=<dc fls bty <cn>%1 >%trunm]
     bty:InsertStuff !<en bty tru > {bty=<ty}
     [treeflag !bty !2]
     [into !10 !sym1 !fls ^sym10b; sinto !flsnm !sym10b !fls ^sym10] {false}
     [into !11 !sym10 !tru ^sym11b; sinto !trunm !sym11b !tru ^sym11] {true}
     [into !2 !sym11 !bty ^sym2b; sinto !bnam !sym2b !bty ^sym2]   {bool}
   {3:char; 4:ch4; 5:flt; 6:str}
     [cht=<ty bty <sz>%1 <ch>>%cnam; treeflag !cht !3]
     [into !3 !sym2 !cht ^sym3; sinto !cnam !sym3 !cht ^sym3a]
     [ty4=<ty cht <sz>%1 <tf>>%Char4]
     [into !4 !sym3a !ty4 ^sym4; sinto !Char4 !sym4 !ty4 ^sym4a]
     [flt=<ty ty4 <sz>%2 <fl>>%fnam; into !5 !sym4a !flt ^sym5]
     [sinto !dnam !sym5 !flt ^sym5f; sinto !fnam !sym5f !flt ^sym6]
   {7:void; 8:null; 14:this}
     [tvd=<ty flt <sz> <vd>>%vnam; sinto !vnam !sym6 !tvd ^sym6v]
     [treeflag !tvd !0; into !7 !sym6v !tvd ^sym7]
     [npt=<dc tvd <ty <> <sz>%1 <pt <nl>>>%nnam <cn>%0 >%nnam]
     [sinto !nnam !sym7 !npt ^sym8; into !8 !sym8 !npt ^sym9]
     [ths=<tv npt >%mnam; into !14 !sym9 !ths ^sym14]
   {15:Obj; 16:Str; 17:Thr; 9:pkg}
     [oty=<ty <> <sz>%1 <>>%onam; cls=<cl <> oty <> <> <> <sz>>%onam]
     oty:InsertStuff !cls  {oty=<ty}         {** fill in elts later **}
     [sty=<ty <> <sz>%1 <st> <>>%snam]
     [tty=<ty <> <sz>%1 <>>%tnam]
     sty:InsertStuff !<cl <up>%oty <> <> <>>%snam  {sty=<ty}
     tty:InsertStuff !<cl <up>%oty <> <> <>>%tnam  {tty=<ty}
     [into !16 !sym14 !sty ^sym16; into !6 !sym16 !sty ^sym17]   {String}
     [into !17 !sym17 !tty ^sym18]                            {Throwable}
     [into !15 !sym18 !oty ^sym18s; tabtree !sym18s ^sym18t]     {Object}
     { cls:ClassParts !<> !sym18t !0 }     {** fill in elts later **}
     [sinto !snam !sym18s !sty ^sym19]
     [fch4=<fn <> <fn>%15 ty4 >%CHR4; sinto !CHR4 !sym19 !fch4 ^sym20]
     [fabs=<fn <> <fn>%14 ity >%zABS; sinto !zABS !sym20 !fabs ^absym]
     [fmax=<fn <> <fn>%13 ity >%zMAX; sinto !zMAX !absym !fmax ^mxsym]
     [fmin=<fn <> <fn>%12 ity >%zMIN; sinto !zMIN !mxsym !fmin ^mnsym]
     [fpktx=<fn <> <fn>%6 ity >%PkTxt;  sinto !PkTxt !mnsym !fpktx ^pxsym]
     [ftxch=<fn <> <fn>%7 cht >%TxtCh;  sinto !TxtCh !pxsym !ftxch ^tcsym]
     [fchr=<fn <> <fn>%3 cht >%zCHR; sinto !zCHR !tcsym !fchr ^chsym]
     [ford=<fn <> <fn>%1 ity >%zORD; sinto !zORD !chsym !ford ^orsym]
     [flen=<fn <> <fn>%2 ity >%zLENGTH; sinto !zLENGTH !orsym !flen ^lnsym]

     [fraw=<fn <> <fn>%99 tvd >%RawCo;  sinto !RawCo !vacant !fraw ^rcsym]
     [fhuge=<fn <> <fn>%99 tvd >%HugeN; sinto !HugeN !rcsym !fhuge ^hgsym]
     [fpeek=<fn <> <fn>%4 ity >%PEEK;   sinto !PEEK !hgsym !fpeek ^pksym]
     [fpoke=<fn <> <fn>%5 tvd >%POKE;   sinto !POKE !pksym !fpoke ^posym]
     [ffork=<fn <> <fn>%8 ity >%FORKER; sinto !FORKER !posym !ffork ^fksym]
     [fcocl=<fn <> <fn>%9 tvd >%COCALL; sinto !COCALL !fksym !fcocl ^ccsym]
     [fdbg=<fn <> <fn>%0 tvd >%DEBUG;   sinto !DEBUG !ccsym !fdbg ^dbsym]
     [fc0d=<fn <> <fn>%-1 tvd >%c0de;   sinto !c0de !dbsym !fc0d ^cdsym]
     [into !19 !cdsym !<no> ^pfsym; tabtree !pfsym ^sympf] {import proof}
     [DgPkg=<pk <> sympf <>>%Dangerous]
     [wty=<ty <> <sz>%1 <sm>>%Semaphor]
     [into !20 !vacant !wty ^wsym1; sinto !Semaphor !wsym1 !wty ^wsym2]
     [fsig=<fn <> <fn>%10 tvd >%zSignal; sinto !zSignal !wsym2 !fsig ^wsym4]
     [fwat=<fn <> <fn>%11 tvd >%zWait; sinto !zWait !wsym4 !fwat ^wsym5]
     [tabtree !wsym5 ^symsw; swPkg=<pk <> symsw <>>%Semphors]
     [sinto !Semphors !lnsym !swPkg ^smsym]
     [sinto !Dangerous !smsym !DgPkg ^outsym] ; {~BuiltinTypes}

Coerce !symtb:table !resType:tree !intype:tree !intree:tree ^outree:tree
  -> [resType=intype; outree=intree]
  -> [resType:<ty xlk xsz xty:<cl ..>>; intype:<ty ylk ysz <pt xty >>]
     intype:TypeSize !false ^isz
     [outree=<dr intree>%isz]
  -> [resType:<ty xlk xsz <pt <nl>>>]  {generic ptr pram}
     ([intype:<ty ylk ysz <pt ..>>; outree=intree]
     |[intype:<ty ylk ysz <cl ..>>; outree=<rf intree>]
     |intype:ArrayBounds ^ztyp ^irty ^inhi ^isz
      ([inhi<0; outree=intree]|[otherwise; outree=<rf intree>]))
  -> [resType:<ty xlk xsz <pt xty >>; intype:<ty ylk ysz xty >]
     [outree=<rf intree>]
  -> resType:ArrayBounds ^ztyp ^rnty ^reshi ^esz
     intype:ArrayBounds ^mtree ^irty ^inhi ^isz
     ([inhi=reshi; outree=intree]
     |[reshi<0; outree=<rf intree>]   {assume Assignable}
     |[otherwise; //"Huh (Coerce)?"//; 0=1])
  -> SubClass !intype !resType {fails if in is not = or sub of res}
     ([resType:<ty xlk xsz <pt ..>>; intype:<ty ylk ysz <cl ..>>;
         outree=<rf intree>]|[otherwise; outree=intree])
  -> [from !6 !symtb ^resType]
     Stringify !symtb !resType !intype !intree ^outree
  -> [from !4 !symtb ^resType; from !6 !symtb ^intype]  {S->C4}
     (String4 !true !intree ^outree ^isz
     |intree:ValRefer !intype ^mtree ^uprf ^xrf
      ([uprf#<>; mtree@=<pr mtree uprf >])?
      [outree=<sy <> mtree <> <nn>%-9 >%1])
  -> [from !5 !symtb ^resType; from !1 !symtb ^intype]  {I->F}
     [outree=<mt intree <sy>%-2 >]
  -> intype:TypeSize !false ^isz   resType:TypeSize !false ^esz   {?->I}
     [isz=1&esz=1; outree=intree]  {assume bit transfer for now}  
  -> [tron !2; outree=<mt intree <ty >%intype >%resType]; {~Coerce}
       {assume Comparable; trace runs away if not handled previously}

Comparable !opok:bool !symtb:table !xtype:tree !ytype:tree
        ^resType:tree ^conv:int
  -> [xtype:<ty xlk xsz <sm>>; //"Semaphore cannot be compared"//; 0=1]
  -> [ytype:<ty ylk ysz <sm>>; //"Semaphores can't be compared"//; 0=1]
  -> [opok=true; xtype=ytype; resType=xtype; conv=0]
  -> [xtype:<ty xlk xsz <>>; //"Opaque types cannot be compared"//]
     [from !8 !symtb ^yty; yty:<dc zty ytype ..>; resType=xtype; conv=0]
  -> [ytype:<ty ylk ysz <>>; //"Opaque types can't be compared"//]
     [from !8 !symtb ^yty; yty:<dc zty xtype ..>; resType=ytype; conv=0]
  -> [xtype=ytype; resType=xtype; conv=0]
  -> IsNumeric !symtb !xtype ^xint   IsNumeric !symtb !ytype ^yint
     ([xint=yint; resType=xtype; conv=0] {neq num types resolve float}
     |[from !5 !symtb ^resType; conv=xint-yint])
  -> [xtype:<ty xlk xsz <pt <nl>>>]  {nil (or generic ptr pram)}
     ([ytype:<ty ylk ysz <pt xty >>]
     | ytype:ArrayBounds ^ztyp ^rnty ^hival ^yint  [hival<0])
     [resType=ytype; conv=0]
  -> [ytype:<ty ylk ysz <pt <nl>>>]
     ([xtype:<ty xlk xsz <pt xty >>]
     | xtype:ArrayBounds ^ztyp ^rnty ^hival ^xint  [hival<0])
     [resType=xtype; conv=0]
  -> [xtype:<ty xlk xsz <pt xty >>; ytype:<ty ylk ysz <pt yty >>; conv=0]
     Comparable !opok !symtb !xty !yty ^zty ^xint
     ([xty=zty; resType=xtype]|[yty=zty; resType=ytype]
     |zty:NameOfType ^tname    NewIdent !tname !2 ^pname
      [resType=<ty <> <sz>%1 <pt zty>>%pname])
  -> [from !4 !symtb ^resType]
     ([resType=xtype; conv=-1] Assignable !symtb !resType !ytype
      (IsNumeric !symtb !ytype ^yint 
       [//"Use explicit conversion to compare Char4:number"//; 0=1])?
     |[resType=ytype; conv=1]  Assignable !symtb !resType !xtype 
      (IsNumeric !symtb !xtype ^xint 
       [//"Use explicit conversion to compare number:Char4"//; 0=1])? )
  -> [from !6 !symtb ^resType]
     ([resType=xtype; conv=-1] Stringable !symtb !ytype
      (IsNumeric !symtb !ytype ^yint 
       [//"Use explicit conversion to compare String:number"//; 0=1])?
     |[resType=ytype; conv=1]  Stringable !symtb !xtype 
      (IsNumeric !symtb !xtype ^xint 
       [//"Use explicit conversion to compare number:String"//; 0=1])? )
  -> SubClass !xtype !ytype  [resType=ytype; conv=0]
  -> SubClass !ytype !xtype  [resType=xtype; conv=0]; {~Comparable}

DoTvDeallo !symtb:table !tvok:bool !intree:tree ^outree:tree
       {I think this is to down-ref any ptrs or strs saved in temps}
  -> [from !-9 !symtb ^tvars]
     tvars:TvDealloc !tvok !intree ^outree ;

DownRefAble !symtb:table !xvar:tree ^didit:int
  -> [didit=0; nxp=0; done=1]  ([xvar:<dr varx:<vr ..>>; xvar@=varx])?
     ([ixfrom !nxp !symtb ^vtree ^lxn ^nxn; lxn>done]
      [nxp@=nxp+1; strint !nxn ^nxnn]  ([nxnn=-3; done@=lxn-1])?
       ([vtree:<vr lnk exty vtr ..>; nxnn>20]
        IsPointer !exty ^xsz ^isPt ^inx ^stx
        [isPt=true; didit@=didit+2] ([vtree=xvar; didit@=didit-1])? )? )* ;

DownRefPtrs !symtb:table !xvar:tree
  -> [nxp=0; done=1]  ([xvar:<dr varx:<vr ..>>; xvar@=varx])?
     ([ixfrom !nxp !symtb ^vtree ^lxn ^nxn; lxn>done]
      [nxp@=nxp+1; strint !nxn ^nxnn]  ([nxnn=-3; done@=lxn-1])?
       ([vtree:<vr lnk exty vtr ..>; nxnn>20]
        IsPointer !exty ^xsz ^isPt ^inx ^stx
        ([vtree=xvar; isPt@=false])?  ([stx:<st>; isPt@=false])?
        [isPt=true]  CheckLn !true
        ["down__ptr((int*)"; spell !nxn; ")"]
        EndLn !true !false )? )* ;

Exp2Bit !theNum:int ^theBit:int
  -> [theBit=1; cnt=theNum]
     ([cnt>0; cnt@=cnt-1; theBit@=theBit+theBit])* ;

FuncInfo !symtb:table ^fun:tree ^fty:tree ^par:tree ^npms:int
  -> [from !-3 !symtb ^fun; fun:<fn lnk <xf fty ..>%npmt loc par >]
     [treeint !npmt ^npms; from !7 !symtb ^vty] ([vty=fty; fty@=<>])?
  -> [fun=<>; fty=<>; par=<>; npms=0];

HighBitOf !theNum:int ^hiBit:int
  -> Unbounded ^loval ^hival
     [theNum=loval`theNum=hival; hiBit=hival]
  -> [theNum<0] HighBitOf !-1-theNum ^hiBit
  -> [hiBit=1]  ([hiBit>0&theNum>hiBit-1; hiBit@=hiBit*2])*
     ([hiBit<0; hiBit@=hiBit-1])? ;

IsBool !symtb:table !exty:tree
  -> [from !2 !symtb ^exty];    {fails if not; caller posts error msg}

IsIntger !zOK:int !symtb:table !exty:tree ^ixtx:tree
  -> [from !19 !symtb ^dang; ixtx=<>]
  -> [from !1 !symtb ^exty] ([zOK>0; ixtx=exty]|[zOK<0; ixtx=<in>])
  -> [ixtx=<>];

IsNumeric !symtb:table !exty:tree ^isint:int
  {fails if not; caller posts error msg}
  -> [from !1 !symtb ^exty; isint=1]
  -> [from !5 !symtb ^exty; isint=0]
  -> [exty:<ty lnk siz <rn clo chi xty >>]
     [from !1 !symtb ^xty; isint=1];

IsPointer !theTy:tree ^vrsiz:int ^isPt:bool ^iniz:bool ^stf:tree
  -> theTy:ArrayBounds ^ztyp ^rnty ^hival ^eltsz  {fails if not dynamic array}
     [hival<0; isPt=true; iniz=true; vrsiz=1; stf=<>]
  -> [theTy:<ty lnk sizt xty ..>]
      ([xty=<>; isPt=false; stf=<>]|[xty:<sm>; isPt=false; stf=xty]
      |[xty:<pt ..>; isPt=true; stf=<>]|[xty:<st>; isPt=true; stf=xty])
     [vrsiz=1; iniz=true]                    {iniz: needs init =0 in decln}
  -> [isPt=false; iniz=false; stf=<>]  theTy:TypeSize !false ^vrsiz ;

NewIdent !name1:str !nn2:int ^catname:str {** not safe during parse **}
  -> [initbl; strint !name1 ^nn1; intstr !nn2 ^name2] 
     ([nn1>0; stleng !name1 ^len1; ix1=0]
      ([ix1<len1; charfrom !ix1 !name1 ^ch1; addtbl !ch1; ix1@=ix1+1])*)?
     ([nn2<0; addtbl !91]  NumIdent !-nn2  {"[n]" fixed-len array}
      [addtbl !93]
     |[nn2=1; addtbl !91; addtbl !93]        {"[]" dyn array types}
     |[nn2=2; addtbl !94]                    {"^" for ptr types}
     |[stleng !name2 ^len2; ix2=0; addtbl !39] {"'" between names}
       ([ix2<len2; charfrom !ix2 !name2 ^ch2; addtbl !ch2; ix2@=ix2+1])*)
     [strindex !0 !1 ^catname];

NextVarInfo !ohed:int !addtyp:tree !symtb:table ^parnt:tree ^offs:int
   {called only from VarDecl; restart temp vars, if already used..}
  -> [from !-1 !symtb ^parnt; from !-4 !symtb ^adrt]
     ([from !-9 !symtb ^tmpv]  tmpv:InsertStuff !<> )?  {tmpv:<tp}
     addtyp:TypeSize !false ^tsiz
     [//"Variables cannot be type 'void'"//; tsiz>0]
     adrt:UpdateLoc !0 ^dirn
     ([dirn<0; adsz=-tsiz]  {count same dir'n}
     |[otherwise; adsz=tsiz] ([ohed>0] adrt:UpdateLoc !ohed ^xxo )? )
     adrt:UpdateLoc !adsz ^base          {always returns low end..}
     ([dirn<0] adrt:UpdateLoc !-ohed ^here  [base@=here+1])? {remove extra}
     [offs=base]; {~NextVarInfo}

NumIdent !theNum:int
  -> [theNum<10; addtbl !theNum+48]
  -> NumIdent !theNum/10   NumIdent !theNum\10 ;

PointList !isPt:bool !symtb:table !vtree:tree
  -> [isPt=true; from !-1 !symtb ^fun]
     ([fun:<fn lnk <xf rtyp pms nloct ptlst ..> ..> ]
      ptlst:InsertStuff !vtree )?  {ptlst:<no ..>}
        {right now nobody looks at ptlst; RSN gotta down-ref them on exit}
        {fun=<> for globals; no cleanup needed} {** TBD: fun:<cl..> **}
  -> [isPt=false] ; {do nothing}

Power2 !theNum:int ^exp:int        {fails unless theNum=2^exp}
  -> [theNum>0; bitand !theNum !-theNum ^theNum; exp=0; bit=1]
     ([theNum>bit; bit@=bit*2; exp@=exp+1])* ;

RangeBits !loval:int !hival:int ^newlo:int ^newhi:int
  {if loval<0<=hival, newlo has all low bits =0, newhi all low bits =1}
    {low bits are all bits below highest bit unequal to sign bit}
  -> [loval<0&hival>-1]
     HighBitOf !-1-loval ^tlo  [newlo=-tlo]
     HighBitOf !hival ^thi     [newhi=thi-1]
  {if loval,hival on same side of 0, then low bits are below highest diff}
  -> [bitand !hival !-1-loval ^thi]   HighBitOf !thi ^tlo
     [bitand !loval !-tlo ^newlo]
     [bitand !-1-hival !-tlo ^res; newhi=-1-res];

SeeNum !theNum:int  -> ;

ShiftBits !theNum:int !shby:int ^res:int  {shby>0 shifts left}
  -> [res=theNum; ix=shby]
     ([ix>0; res@=res*2; ix@=ix-1])*
     ([ix<0&res>0; res@=res/2; ix@=ix+1]
     |[ix<0&res<0; res@=(res+1)/2-1; ix@=ix+1])* ;

ShoRetName !sto:bool !fntyp:tree
  -> fntyp:WhatType ^tyx
     ([sto=false&tyx=0; "("]  fntyp:TypeSpell  [")"])?
     ["myframe->_my_prog_->_tmp_"]
     ([tyx=1; "int_"]|[tyx=6; "str_"]|[tyx=2; "bool_"]
     |[tyx=4; "ch4_"]|[tyx=3; "char_"]|[otherwise; "ptr_"])
     ([sto=true; " = "]  ([tyx=0; "(int*)"])? )? ;

StrCatCon !sxm:str !sxn:str ^nst:str
  -> [stleng !sxm ^lem; stleng !sxn ^len; initbl; ix=0; xi=0]
     ([ix<lem; charfrom !ix !sxm ^acm; addtbl !acm; ix@=ix+1])*
     ([xi<len; charfrom !xi !sxn ^acn; addtbl !acn; xi@=xi+1])*
     [strindex !0 !2 ^nst];

String4 !lefty:bool !vtree:tree ^outree:tree ^ival:int {4-ch const, or fail}
  -> [vtree:<tc par <st>%vtr ..>; treestr !vtr ^stn]
     [stleng !stn ^lox; lox<5; ival=0; nby=0]
     ([lox>0; lox@=lox-1; charfrom !nby !stn ^hix;
        ival@=ival*256+hix; nby@=nby+1])*
     ([lefty=true & nby<4; ival@=ival*256+32; nby@=nby+1])*
     [outree=<ac <> <cn>%ival <nn>>] ;

Stringable !symtb:table !exty:tree
  -> [from !6 !symtb ^exty]
  -> exty:IsObject ^tname ^osiz ^ptyp ^osym
  -> exty:IsScalar
  -> IsNumeric !symtb !exty ^isint ;

StringConstant !theStr:str !symtb:table ^theDef:tree
  -> ([from !-6 !symtb ^root]  root:aFindString !theStr ^theDef
       ([theDef=<>; root:<tc nxtk >;
           nutk=<tc nxtk <st>%theStr <no>>; theDef@=nutk]
        root:InsertStuff !nutk )?  {root:<tc}
     |[otherwise; theDef=<>]) ;

Stringify !symtb:table !resType:tree !intype:tree !intree:tree ^outree:tree
  -> [from !1 !symtb ^intype]  {I->S}                {fails if can't}
     TempSave !true !symtb !<mt intree <sy>%-4 > ^outree  {TempSav disabled}
  -> [from !3 !symtb ^intype]  {C->S}
     TempSave !true !symtb !<mt intree <sy>%-3 > ^outree
  -> [from !5 !symtb ^intype]  {F->S}
     TempSave !true !symtb !<mt intree <sy>%-5 > ^outree
  -> [from !2 !symtb ^intype]  {B->S}
     TempSave !true !symtb !<mt intree <sy>%-2 > ^outree
     {[from !-8 !symtb ^rnty; outree=<ad intree rnty >]}
  -> [from !4 !symtb ^intype]  {C4->S}
     TempSave !true !symtb !<mt intree <sy>%-6 > ^outree
  -> [from !1 !symtb ^xtype]  Assignable !symtb !xtype !intype
     TempSave !true !symtb !<mt intree <sy>%-4 > ^outree ; {~Stringify}

SubClass !xtype:tree !ptype:tree      {fails if x is not = or sub of p}
  -> [xtype=ptype]
  -> [xtype:<cl lnk typ <up>%sup elts sym >; ptype:<cl .. >]
     ([xtype=ptype]|[ptype=sup]|SubClass !sup !ptype )
  -> [xtype:<ty lnk siz cls >]  SubClass !cls !ptype
  -> [ptype:<ty lnk siz cls >]  SubClass !xtype !cls
  -> [xtype:<pt cls >]  SubClass !cls !ptype
  -> [ptype:<pt cls >]  SubClass !xtype !cls ;

TempAlloc !symtb:table !valu:tree !itree:tree ^tmpv:tree ^otree:tree ^vno:int
   {allocate temp var in stack of temps; TempFram releases when done}
  -> [from !-9 !symtb ^root]   root:GetDecor ^cur  [vno=cur+1]
     root:TempVar !symtb !vno ^theV     NativeCodeQ ^natv
     [tmpv=<dr <va <>>%vno >%1; otree=<as itree theV valu <>>]
     valu:PreCodeTree !symtb
     CheckLn !false   Exp2Bit !vno ^abit
     [getat !3 ^bitz; bitand !bitz !abit ^whom; putat !3 !bitz-whom+abit]
     ([whom=0]  ([natv=false; "-"])?
      ["  int "]
      ([natv=false; "_tmp_"; number !vno; "_"]  EndLn !true !true
       ["  myframe->"])?
     |["  "] ([natv=false; "myframe->"])? )
     ["_tmp_"; number !vno; "_ = "]
     valu:GenTreeCode !1 !0   EndLn !true !false
     root:Decorate !vno ;  {root:<tp} {~TempAlloc}

TempFrame !symtb:table !init:int ^sav:int  {init=0 opens, else restore}
  -> [from !-9 !symtb ^root; root:<tp ..>]     {mark/init'ize}
     ([init=0] root:GetDecor ^sav   {sav>0 is actual # tvs in use}
     |[init>0; sav=init] {root:Decorate !sav} ); {root:<tp} {restore to init}

TempSave !istr:bool !symtb:table !intree:tree ^outree:tree
       {this gets called when tos is a string/ptr that may need dn-ref}
  -> [outree=intree]  {disabled for now; we think it's unneeded}
  -> [from !-9 !symtb ^root]   root:GetDecor ^cur
     root:TempVar !symtb !cur+1 ^theV
     ([istr=true; tagt=<st>]|[otherwise; tagt=<pt>])
     theV:InsertStuff !tagt   {theV:<of}
     [outree=<vt intree theV tagt >]
     root:Decorate !cur+1 ;  {root:<tp}

ThrowableType !symtb:table !exty:tree
  -> [from !17 !symtb ^tty; //"Throwable type expected"//]
     SubClass !exty !tty ;

TreeNoZe                             {validate node names in trace}
  -> TreeSee !<no>   {increase NodeNameOffs +3 if this is ty}
     TreeSee !<ze> ;   {reduce it -3 if this is ys}

TreeSee !whom:tree -> ;

TrueFalSym !tables:tree !insym:table ^outsym:table
  -> [from !11 !insym ^tru; tru:<dc <dc ..>%flt ..>%trt]
     [treestr !trt ^trnm; treestr !flt ^flnm]
     [into !-6 !insym !tables ^midsym]
     StringConstant !flnm !midsym ^fld
     StringConstant !trnm !midsym ^trd
     fld:StringTouch !tables
     trd:StringTouch !tables
     [into !-8 !midsym !fld ^outsym] ;

Unbounded ^loval:int ^hival:int                 {return minInt,maxInt}
  -> [hival=2147483647; loval=-hival];

UndefineThis !symtb:table !theName:str
  -> [from !-13 !symtb ^theList; theList:<nm link >]
     theList:InsertStuff !<nm link >%theName ;

ValType !theTy:tree ^uprf:tree ^isPt:bool     {called only by ValRefer}
  -> theTy:IsString ^uprf  [isPt=true]   {uprf=<st>}
  -> IsPointer !theTy ^asiz ^isPt ^iniz ^stx
      [isPt=true&iniz=true; uprf=<pt>]
  -> [uprf=<>; isPt=false];

Zstring !theStr:str                {fails if not null}
  -> [strint !theStr ^num; num=0];

CheckLn !spcs:bool
  -> ([getat !0 ^doit; doit#0; ascii !00; putat !0 !0])?
     ([spcs=true; "  "])? ;

EndLn !semi:bool !now:bool
  -> [semi=true; ";"]  EndLn !false !now
  -> [now=false; putat !0 !1]
  -> [ascii !00; putat !0 !0];

GenChar !theC:int
  -> [theC=39; "'"; ascii !92; "''"]
  -> [theC=10; "'"; ascii !92; "n'"]
  -> [theC=92; "'"; ascii !92; ascii !92; "'"]
  -> [theC=9; "'"; ascii !92; "t'"]
  -> [theC>31&theC<127; "'"; ascii !theC; "'"]
  -> ["CHR("; number !theC; ")"];

HexOrDec !theNum:int
  -> [theNum+200>0&theNum<1000; number !theNum]
  -> [theNum<0&theNum+16777217>0; "-"]  HexOrDec !-theNum
  -> [theNum>0&theNum\4096#0&theNum\1000=0; number !theNum]
  -> [abit=67108864; ndgs=8]  {0x4000000}
     ([ndgs>2 & theNum>0 & theNum<abit*4; abit@=abit/16; ndgs@=ndgs-1])*
     ["0x"; hexnum !theNum !ndgs];

StartupCaller !zip:bool !pname:str
  -> ["  "]  ([zip=false; "else "])?
     ["if (prName == "; ascii !34]  ([zip=false; spell !pname])?
     [ascii !34; ") _"; spell !pname; "_::"; spell !pname; "_main()"]
     EndLn !true !true ; {~StartupCaller}


                                     transformer

{tree transformation utilities... }

aFindString !theStr:str ^theDef:tree
  -> here:<tc link <st>%nstr >
      ([treestr !nstr ^theStr; theDef=here]
      |[otherwise] link:aFindString !theStr ^theDef )
  -> <tc link elts >
      link:aFindString !theStr ^theDef
  -> <>  [theDef=<>] ;

ArrayBounds ^etyp:tree ^rnty:tree ^hival:int ^eltsz:int  {fails if not array}
  -> <ty lnk siz arty >
       arty:ArrayBounds ^etyp ^rnty ^hival ^eltsz
  -> <ar arty etyp >
       etyp:TypeSize !false ^eltsz
       arty:GetTypeRange ^rnty ^loval ^hival ;

AutoDownRef !exty:tree
  -> <al lnk pms body >
  => <dn exty <al lnk pms body >>
  -> <ar lnk pms body >
  => <dn exty <ar lnk pms body >>
  -> <fc lnk args typ pms body >
  => <dn exty <fc lnk args typ pms body >>
  -> xtree ;

Breakable !body:tree !upcnt:int !blox:int ^broke:int
  -> <yk lnk <cn>%cntr <nn>%lps >
      [body=<>&upcnt=0; treeint !cntr ^broke]
  => lnk
  -> <yk lnk cntr blx >%lps  [body=<>&upcnt<0] {continue only}
      blx:GetDecor ^cnt   [broke=cnt/65536]
  -> <yk lnk <cn>%cntr blx >%lps  [body=<>&upcnt>0] {break only}
      [treeint !cntr ^cnt; ncnt=cnt+upcnt] blx:GetDecor ^broke
  => <yk lnk <cn>%ncnt blx >%lps
  -> <yk lnk <cn>%cntr blx >%lps  [body#<>; broke=0]
  => <yk <yk lnk <cn>%cntr blx >%lps <cn>%0 <nn>%blox >%body
  -> <no>            [body#<>; broke=0]
  => <yk <no> <cn>%0 <nn>%blox >%body ; {~Breakable}

ClassParts !body:tree !clasym:tree !rsize:int
  -> clss:<cl lnk typ sup elts sym siz >%dec
      {typ:InsertStuf !clss   [typ:<ty tlk siz clss >]}
      ([rsize>0]  siz:Decorate !rsize )?       {siz:<sz>}
  => <cl lnk typ sup body clasym siz >%dec ;

DecoString !deco:str
  -> <vr lnk pms body loc stf >
  => <vr lnk pms body loc stf >%deco
  -> body  [tron !2; trunflag !body ^inx]  TreeSee !body
      [//"Oops (DecoString)"//; 0=1] ; {~DecoString}

Decorate !deco:int
  -> <nn body >
  => <nn body >%deco
  -> <xf body pms loc lnk >
  => <xf body pms loc lnk >%deco
  -> <no body >
  => <no body >%deco
  -> <cs lnk pms body >
  => <cs lnk pms body >%deco
  -> <lp lnk body pms >
  => <lp lnk body pms >%deco
  -> <fr lnk body loc pms >
  => <fr lnk body loc pms >%deco
  -> <sw lnk pms body loc >
  => <sw lnk pms body loc >%deco
  -> <sz body >
  => <sz body >%deco
  -> <fn body pms lnk >
  => <fn body pms lnk >%deco
  -> <of body >
  => <of body >%deco
  -> <tc lnk body >
  => <tc lnk body >%deco
  -> <tp lnk body >
  => <tp lnk body >%deco
  -> <al lnk pms body >
  => <al lnk pms body >%deco
  -> <ar lnk pms body >
  => <ar lnk pms body >%deco
  -> body  [tron !2; trunflag !body ^inx]  TreeSee !body
      [//"Oops (Decorate)"//; 0=1] ; {~Decorate}

GetStrDec ^deco:str
  -> <st>%oft     [treestr !oft ^deco]
  -> <nm>%oft     [treestr !oft ^deco]
  -> <cl ..>%oft  [treestr !oft ^deco]
  -> oft  [tron !2; trunflag !oft ^inx]  TreeSee !oft
      [//"Oops (GetStrDec)"//; 0=1] ; {~GetStrDec}

GetDecor ^deco:int
  -> <of ..>%oft  [treeint !oft ^deco]
  -> <rp>%oft     [treeint !oft ^deco]
  -> <gl>%oft     [treeint !oft ^deco]
  -> <pt>%oft     [treeint !oft ^deco]
  -> <tc ..>%oft  [treeint !oft ^deco]
  -> <tp ..>%oft  [treeint !oft ^deco]
  -> <ot>%oft     [treeint !oft ^deco]
  -> <io>%oft     [treeint !oft ^deco]
  -> <sz ..>%oft  [treeint !oft ^deco]
  -> <nn ..>%oft  [treeint !oft ^deco]
  -> <fn ..>%oft  [treeint !oft ^deco]
  -> <ty ..>%oft  [treeint !oft ^deco]
  -> <cs ..>%oft  [treeint !oft ^deco]
  -> <cn>%oft     [treeint !oft ^deco]
  -> <ch>%oft     [treeint !oft ^deco]
  -> <nm>%oft     [treeint !oft ^deco]
  -> oft  [tron !2; trunflag !oft ^inx]  TreeSee !oft
      [//"Oops (GetDecor)"//; 0=1] ; {~GetDecor}

GetItsType ^clsym:table ^exty:tree ^loval:int ^hival:int
  -> <vr lnk exty par data ..> {var/field}
      exty:GetItsType ^clsym ^typ ^loval ^hival
  -> <dc lnk exty <cn>%data > {const}
      [clsym=vacant; treeint !data ^loval; hival=loval]
  -> <dc lnk exty <ch>%data > {const}
      [clsym=vacant; treeint !data ^loval; hival=loval]
  -> <dc lnk exty <tc ..>> {const}
      exty:GetItsType ^clsym ^typo ^loval ^hival
  -> <dc lnk exty <ac ..>> {const}
      exty:GetItsType ^clsym ^typo ^loval ^hival
  -> <dc lnk <ty data siz rnty ..> <vr>>      {for-var}
      rnty:GetItsType ^clsym ^exty ^loval ^hival
  -> <cl lnk exty sup elts symtr siz >
      [treetab !symtr ^clsym]
      Unbounded ^loval ^hival
  -> <tc lnk exty:<ty ..> ..>
      exty:GetItsType ^clsym ^typo ^loval ^hival
  -> <fn lnk exty:<ty ..> ..>
      exty:GetItsType ^clsym ^typo ^loval ^hival
  -> <fn lnk <xf exty ..> ..>
      exty:GetItsType ^clsym ^typo ^loval ^hival
  -> <fn lnk <fn> exty >
      exty:GetItsType ^clsym ^typo ^loval ^hival
  -> exty:<tv>
      exty:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> rnty:<rn llo hhi exty >
      rnty:GetTypeRange ^typo ^loval ^hival
      [clsym=vacant]
  -> <en exty elts >
      exty:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> exty:<ch>
      exty:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> exty:<tf>
      exty:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> exty:<fl>
      exty:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> typ:<ar ity ety exty >
      typ:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> exty:<st >
      exty:GetTypeRange ^rnty ^loval ^hival
      [clsym=vacant]
  -> exty:<no >
      Unbounded ^loval ^hival
      [clsym=vacant]
  -> exty:<nl >
      Unbounded ^loval ^hival
      [clsym=vacant]
  -> exty:<vd>
      Unbounded ^loval ^hival
      [clsym=vacant]
  -> exty:<sm>
      Unbounded ^loval ^hival
      [clsym=vacant]
  -> exty:<st>
      Unbounded ^loval ^hival
      [clsym=vacant]
  -> exty:<ty lnk siz <>>
      Unbounded ^loval ^hival
      [clsym=vacant]
  -> exty:<ty lnk siz typ ..>
      typ:GetItsType ^clsym ^typo ^loval ^hival
  -> exty:<pt typ >
      typ:GetItsType ^clsym ^typo ^loval ^hival
  -> exty
      [tron !2; trunflag !exty ^inx]  TreeSee !exty
      [//"Oops (GetItsType)"//; 0=1] ;  {~GetItsType}

GetTblCon !inx:int ^belo:int ^valu:int ^extr:tree
  -> <tc link numt <>>
      numt:GetTblCon !inx ^belo ^valu ^extr
  -> <tc link typ numt:<tc ..>>
      numt:GetTblCon !inx ^belo ^valu ^extr
  -> <in link >%numt
      link:GetTblCon !inx ^belx ^valx ^extr
      ([inx=belx; treeint !numt ^valu]|[otherwise; valu=valx])
      [belo=belx+1]
  -> <ls link tctr:<tc typ <st>>%numt >
      link:GetTblCon !inx ^belx ^valx ^extx
      ([inx=belx; treeint !numt ^valu; extr=tctr]
      |[otherwise; valu=valx; extr=extx])
      [belo=belx+1]
  -> <sz>
      [belo=0; valu=0; extr=<>]
  -> <>
      [belo=0; valu=0; extr=<>]
  -> link
      [belo=0; valu=0; extr=<>]
      [tron !2; trunflag !link ^inx]  TreeSee !link
      [//"Oops (GetTblCon)"//; 0=1] ; {~GetTblCon}

GetTypeRange ^rnty:tree ^loval:int ^hival:int    {return type range}
  -> <ty lnk siz rnty:<rn <cn>%tlo <cn>%thi typ >>   {-- subrange/int}
     [treeint !tlo ^loval; treeint !thi ^hival] 
  -> <ty lnk siz exty:<en ..>>                       {-- enum}
     exty:GetTypeRange ^rnty ^loval ^hival
  -> <ty lnk siz rnty:<ch>>                          {-- char}
     [loval=0; hival=255]
  -> <ty lnk siz rnty:<tf>>                          {-- Char4}
     [loval=0]  Unbounded ^noval ^hival
  -> rnty:<rn <cn>%tlo <cn>%thi exty >
     [treeint !tlo ^loval; treeint !thi ^hival]
  -> rnty:<en exty <dc lnk tlo <cn ..>%thi >>
     [loval=0; treeint !thi ^hival]
  -> rnty:<ch>
     [loval=0; hival=255]
  -> rnty:<tf>
     [loval=0]  Unbounded ^noval ^hival
  -> exty                                            {all others}
     [loval=0; hival=-1; rnty=<>] ; {~GetTypeRange}

InsertName !theTree:tree
  -> <xf typ par loc lnk nms body >%deco
  => <xf typ par loc lnk theTree body >%deco ;

InsertSyms !symtb:table
  -> <xf rtn pms loc ptr nms sym >%deco
      [tabtree !symtb ^bodsy]
  => <xf rtn pms loc ptr nms bodsy >%deco ;

IsLoop ^theLoop:tree
  -> <yk lnk ..>%bod
     bod:IsLoop ^theLoop {might fail}
  -> <yk lnk ..>
     lnk:IsLoop ^theLoop {might fail}
  -> theLoop:<wh ..>
  -> theLoop:<lp ..>
  -> theLoop:<fr ..> ;

IsObject ^tname:int ^osiz:int ^ptyp:tree ^clsym:table
    {returns <cl..>; fails if not; caller posts error}
  -> ptyp:<cl lnk typ sup elts symt <sz>%sizt >%tnt
      [treeint !tnt ^tname; treeint !sizt ^osiz; treetab !symt ^clsym]
  -> <ty lnk siz ptyp:<cl ..>..> ptyp:IsObject ^tname ^osiz ^typ ^clsym
  -> <ty lnk siz typ:<pt ..>..>  typ:IsObject ^tname ^osiz ^ptyp ^clsym
  -> <pt typ >                 typ:IsObject ^tname ^osiz ^ptyp ^clsym  ;

IsScalar
  -> <rn <cn> <cn> typ >
  -> <en typ ..>
  -> <ch>
  -> <tf>
  -> <ty lnk siz typ >
      typ:IsScalar ; {~IsScalar}

IsString ^sfg:tree
  -> <ty link info sfg:<st> ..>
  -> <vr link info ..>
      info:IsString ^sfg ;  {fails otherwise}

MemberGet !vartree:tree !inloc:tree ^loctr:tree
    ^clsym:table ^outyp:tree ^loval:int ^hival:int
  -> vtree:<vr lnk typ par locn ..>
     vtree:GetItsType ^clsym ^outyp ^loval ^hival
     ([locn:<of <>>%offt; loctr=<ki <of inloc >%offt >] {instance var (fld)}
     |[otherwise; loctr=locn])   {static var or I/O}
  -> <cn>%offt
      [clsym=vacant; outyp=<>; treeint !offt ^loval; hival=loval]
      [loctr=<>]
  -> <dc lnk typ vtree adr >
      vtree:GetItsType ^clsym ^outyp ^loval ^hival
      [loctr=<>] ; {~MemberGet}

NameOfType ^name:str
  -> <ty .. >%namt [treestr !namt ^name]
  -> <cl .. >%namt [treestr !namt ^name] ;

NewProcNo !theFn:tree ^pno:int
  -> <fn body >%opnt   [treeint !opnt ^opn; pno=opn+1]
  => <fn <fd body theFn >%pno >%pno ;

NoFun         {fails if <fn ..>}
  -> <ty ..>|<cl ..>|<vr ..>|<dc ..>|<no ..>|<nc ..>
  -> <as ..>|<ze ..>|<zz ..>|<dn ..>|<pk ..>
  -> <> ; {~NoFun}

OptDeref
  -> <dr <ki more >>%sizt
  => <ki <dr more >%sizt >
  -> more ;

PaRoot !mods:int ^locOK:bool ^root:tree
  -> <cl lnk atyp root ..>  [root:<io>; locOK=false]
  -> <cl ..>                [root=<ot>; locOK=true]
  -> <as ..>                [root=<ot>; locOK=true]
  -> <io>                   [root=<io>; locOK=false]
  -> <fn ..>                [root=<>; locOK=true]
  -> <>                     [mods=130; root=<sy>; locOK=true]
  -> <>                     [mods=2; locOK=true; root=<>] {gets replaced}
  -> <>                     [root=<gl>; locOK=true];

PoorManConstor !fast:bool !symtb:table !axes:tree !intree:tree
        ^fust:bool ^vtree:tree
  -> fld:<vr link ..> 
      link:PoorManConstor !fast !symtb !axes !intree ^fist ^atree
      ConstrValue !symtb !axes !fld !atree !fist ^vtree
      [fust=false]  {fust is used by ConstrVal to look for a ','}
  -> <as link .. >
      link:PoorManConstor !fast !symtb !axes !intree ^fust ^vtree
  -> <ze link .. >
      link:PoorManConstor !fast !symtb !axes !intree ^fust ^vtree
  -> <zz link .. >
      link:PoorManConstor !fast !symtb !axes !intree ^fust ^vtree
  -> <nn link .. >
      link:PoorManConstor !fast !symtb !axes !intree ^fust ^vtree
  -> <up>%ptyp
      ptyp:IsObject ^xname ^siz ^ctyp ^clsym
      [ctyp:<cl lnk xtyp par elts ..>]
      par:PoorManConstor !fast !symtb !axes !intree ^fist ^atree
      elts:PoorManConstor !fist !symtb !axes !atree ^fust ^vtree
  -> <>  [fust=fast; vtree=intree]; {~PoorManConstor}

PreCountAry        {fail if can't; alloc now always precounts}
  -> <al ..>
  -> <ar ..>
  -> <fc ..>
  -> <cn ..> ;

PutInTable !nutb:tree ^gotit:bool  {insert nutb if not in table list}
  -> body:<tc link <>>
      link:PutInTable !nutb ^gotit
      ([gotit=false; gotit@=true]
        nutb:InsertStuff !link      {nutb:<tc}
        body:InsertStuff !nutb )?   {body:<tc}
  -> body:<tc link ..>
      [body=nutb; gotit=true]
  -> <tc link ..>
      link:PutInTable !nutb ^gotit
  -> <>  [gotit=false]
  -> link
      [tron !2; trunflag !link ^inx]  TreeSee !link
      [gotit=false; //"Oops (PutInTable)"//; 0=1] ; {~PutInTable}

Resize !newly:int
  -> <ty lnk siz:<sz> bod >
      siz:Decorate !newly  {siz:<sz>}
  -> <ty lnk siz bod >%nam
  => <ty lnk <sz>%newly bod >%nam ; {~Resize}

sTouchAll !tbls:tree
  -> <ls link body ..>
      link:sTouchAll !tbls
      body:sTouchAll !tbls
  -> body:<tc link stm <no>>
      body:StringTouch !tbls
  -> body:<tc link <st>%stn <>>
      [treestr !stn ^nst]
      tbls:aFindString !nst ^def
      ([body=def]
      |[otherwise]
       tbls:PutInTable !body ^gotit )
  -> <in link ..>
      link:sTouchAll !tbls
  -> <sz> 
  -> <> 
  -> link
      [tron !2; trunflag !link ^inx]  TreeSee !link
      [gotit=false; //"Oops (sTouchAll)"//; 0=1] ; {~sTouchAll}

StringTouch !tbls:tree
  -> <ca <tc link <st>%stm ..> <tc lank <st>%stn ..>>
      [treestr !stm ^sxm; treestr !stn ^sxn]
      StrCatCon !sxm !sxn ^nst
      tbls:aFindString !nst ^def
      ([def:<tc ..>; body=def]
       body:StringTouch !tbls
      |[otherwise; body=<tc <> <st>%nst <>>]
       tbls:PutInTable !body ^gotit )
  => <nc body <>>
  -> body:<tc link stm:<ls ..> ..>
      stm:sTouchAll !tbls
  -> body:<tc link stm:<st>%stn <no>>%deco
      [treestr !stn ^nst]
      tbls:aFindString !nst ^def
      ([body=def; lank=link]
      |[otherwise]
       tbls:PutInTable !body ^gotit
       [body:<tc lank ..>])
  => <tc lank stm <>>%deco
  -> <tc ..> ;

TempVar !symtb:table !varn:int ^theV:tree     {only called from TempAlloc}
   {varn>0, in wds, came from  !-9 !symtb; find or create it..}
  -> <tp link theV:<of ..>>%deco
      [treeint !deco ^offn; offn=varn]
  -> <tp <> link >%deco
      [from !-4 !symtb ^adrt]
      adrt:UpdateLoc !-1 ^offs    {offs<0 in words, old loc 1 extra, = new}
      [theV=<of <>>%offs*4]
  => <tp <tp <> theV >%varn link >%deco
  -> <tp link offt >
      link:TempVar !symtb !varn ^theV ; {~TempVar}

TvAssn !varef:tree ^outree:tree  {fails if not a matching <as..}
  -> outree:<as link vart <vt expn varef ..> pty >%deco
  => <dn <as link vart expn pty >%deco vart pty >
  -> outree:<nn link >
      link:TvAssn !varef ^vart ;

TvDealloc !tvok:bool !intree:tree ^outree:tree  {called by DoTvDeallo}
  -> <tp link info >
      link:TvDealloc !tvok !intree ^body
      info:TvDealloc !tvok !body ^outree
  -> <of <>>
      [outree=intree]
  -> link:<of body >%info
      ([vart=link] intree:TvAssn !vart ^outree
        {** compiler bug: without vart=link, TvAssn doesn't get called **}
      |[//"Avoid complex string/pointer expressions in declarations"//]
       [tvok=true; outree=<dn intree link body >])
  => <of <>>%info
  -> <>  [outree=intree] ; {~TvDealloc}

TypeSize !dig:bool ^siz:int         {fails if not a type}
  -> <ty lnk sizt <pt typ > ..>
      [dig=true] typ:TypeSize !false ^siz
  -> <cl lnk typ sup elts sym <sz>%sizt > [treeint !sizt ^siz]
  -> <ty lnk <sz>%sizt ..> [treeint !sizt ^siz] ; {~TypeSize}

UpdateLoc !tsiz:int ^offs:int   {returns previous value}
  -> <lc ..>%offt   [treeint !offt ^offs; tsiz=0]
  -> <lc base >%offt   [treeint !offt ^offs; newoff=offs+tsiz]
  => <lc base >%newoff ; {~UpdateLoc}

ValRefer !theTy:tree ^vtree:tree ^prf:tree ^asrf:tree
    {determines if up-/down-ref needed for this assignment}
  -> etree:<cn ..>
      ValType !theTy ^asrf ^isPt
      [prf=<>; vtree=etree]  {const}
  -> etree:<tc ..>
      ValType !theTy ^asrf ^isPt
      [prf=<>; vtree=etree]  {table/string const}
  -> etree:<ca ..>
      theTy:IsString ^asrx
      [prf=<>; asrf=<dn asrx >; vtree=etree]  {string cat}
  -> etree:<fc ..>
      ValType !theTy ^asrx ^isPt
      [isPt=true; prf=<>; asrf=<dn asrx >; vtree=etree]  {func result}
  -> etree:<sy ..>
      ValType !theTy ^asrx ^isPt
      [isPt=true; prf=<>; asrf=<dn asrx >; vtree=etree]  {syscall res}
  -> etree:<mt ..>
      ValType !theTy ^asrx ^isPt
      [isPt=true; prf=<>; asrf=<dn asrx >; vtree=etree]  {coersion res}
  -> etree:<nc ..>
      ValType !theTy ^asrx ^isPt
      [prf=<>; asrf=<dn asrx >; vtree=etree]  {inline func res}
  -> etree:<al ..>
      [prf=<>; vtree=etree; asrf=<dn <pt>>]  {new obj}
  -> etree:<ar ..>
      [prf=<>; vtree=etree; asrf=<dn <pt>>]  {new array}
  -> etree:<dr ..>
      ValType !theTy ^asrf ^isPt
      [isPt=true; prf=asrf; vtree=etree] {ptr var}
  -> etree
      IsPointer !theTy ^asiz ^isPt ^iniz ^stx  [asrf=<>; vtree=etree]
      ([asiz=2; prf=<fp>]
      |[//"Invalid value reference"//; asiz<3; prf=stx]); {~ValRefer}

CasType ^whom:int
  -> <ty link siz <ch>>   [whom=3]
  -> link    [whom=1];

Cstring
  -> <tc lnk vxt:<st> ..>
      vxt:Cstring
  -> <st>%vxt
      [treestr !vxt ^vxs; stleng !vxs ^nsc; ixs=0]
      ([nsc=0; "Null_Str"]|[otherwise; "String("; ascii !34]
        ([ixs<nsc; charfrom !ixs !vxs ^ach]
         ([ach=10`ach=138; ascii !92; "n"]|[ach=9`ach=137; ascii !92; "t"]
         |[ach=13`ach=141; ascii !92; "r"]|[ach=34; ascii !92; ascii !34]
         |[ach=92; ascii !92; ascii !92]|[ach>31&ach<127; ascii !ach]
         |[otherwise; ascii !92; ascii !(ach/64)+48;
              ascii !(ach/8)\8+48; ascii !(ach\8)+48])
        [ixs@=ixs+1])* [ascii !34; ")"]);

GenTreeCode !loval:int !hival:int
  -> expn  [loval=hival & loval+hival#0]  HexOrDec !loval
  -> expn:<vr ..>  expn:VarSpell
  -> expn:<va link ..>
      {link:GenTreeCode !loval !hival}  {do expressions only}
      expn:VarSpell
  -> <fc link args <fn var exty expn <fp>>%xptr nby prnm > {native code call}
      {link:GenTreeCode !loval !hival}
      ([prnm:<sy>; "_FrameWork_::"]
      |[prnm:<nm ..>%pnmt; pnmt#<>; treestr !pnmt ^pnms]
       ["_"; spell !pnms; "_::"])?
      [treestr !xptr ^snam; spell !snam; "("]
      args:GenTreeCode !1 !0
      [")"]  {(exty:IsVoid    EndLn !true !false )?} {caller does}
  -> <at link expn var >%exty                         {seg'd <fc ..> removed}
      ([link#<>]  link:GenTreeCode !loval !hival  [", "])?
      ([exty:<ty xptr more <ch>>; whom=3]|[otherwise; whom=1])
      ([var:<pt>; "(int*)"])?
      expn:GenTreeCode !whom !0
  -> <ch>%xptr
      [treeint !xptr ^whom]  GenChar !whom
  -> <ys>   ["Null_Str"]
  -> <cn>%xptr
      [treeint !xptr ^whom]
      ([loval=3&hival=0]  GenChar !whom
      |[otherwise]  HexOrDec !whom )
  -> <tc link expn:<st> ..>
      expn:Cstring
  -> <tc link <ty ..> expn:<tc ..> args >%xptr
      NativeCodeQ ^natv                            {natv=true always}
      ([natv=true; " "]|[args=<>; " _glob_var_ "]
      |[otherwise; " myframe->"])
      [treestr !xptr ^snam; spell !snam]
      {expn:GenTreeCode !loval !hival}
  -> <tc link expn >%xptr    {table in code}
      ([expn:<in ..>]|[expn:<ls ..>])
      [treeint !xptr ^whom; "["; number !whom; "]"]
  -> <nm link >%xptr   {<nm <un <dr expn >>>%xptr}
      link:GenTreeCode !loval !hival
      ["->"; treestr !xptr ^snam; spell !snam]
  -> <as link <of <dr <>>> <cn>%xptr ..>
      [treeint !xptr ^whom; whom=0]
      link:GenTreeCode !loval !hival
  -> <as link var expn xptr >
      link:GenTreeCode !loval !hival
      ([loval=0 & hival+4=0; ","; ascii !00])?
      CheckLn !true  var:GenTreeCode !loval !hival
      [" = "] expn:GenTreeCode !loval !hival
      ([loval#0 ` hival+4#0&hival+7#0]  EndLn !true !false )?
  -> <nc link expn ..>
      link:GenTreeCode !loval !hival
      expn:GenTreeCode !loval !hival
  -> <dr expn >
      expn:GenTreeCode !loval !hival
  -> <rf expn >
      expn:GenTreeCode !loval !hival
  -> <nn link >
      link:GenTreeCode !loval !hival
  -> <yk link expn >%xptr
      link:GenTreeCode !loval !hival
      [treeint !xptr ^whom; "  *((int*)"]
      expn:VarSpell   [") = "]  HexOrDec !whom    EndLn !true !false
  -> <ax link expn more <in>>%xptr
      [treeint !xptr ^whom; whom=1; "_Bounds_ChkL_("]
      link:GenTreeCode !loval !hival  [","]  expn:GenTreeCode !1 !0   [")"]
  -> <ax link expn more <ty ..>>%xptr
      [treeint !xptr ^whom; whom=1; "_Bounds_ChkR_("]
      link:GenTreeCode !loval !hival  [","]  expn:GenTreeCode !1 !0   [")"]
  -> <ax link expn ..>
      link:GenTreeCode !loval !hival
      ["[2+("] expn:GenTreeCode !1 !0
      [")]"]
  -> <ng expn >
      ["(-"] expn:GenTreeCode !1 !0
      [")"]
  -> <ad link expn >
      ["("] link:GenTreeCode !1 !0
      ["+"] expn:GenTreeCode !1 !0
      [")"]
  -> <su link expn >
      ["("] link:GenTreeCode !1 !0
      ["-"] expn:GenTreeCode !1 !0
      [")"]
  -> <dv link expn >
      ["("] link:GenTreeCode !1 !0
      ["/"] expn:GenTreeCode !1 !0
      [")"]
  -> <md link expn >
      ["("] link:GenTreeCode !1 !0
      ["%"] expn:GenTreeCode !1 !0
      [")"]
  -> <mp link expn >
      ["("] link:GenTreeCode !1 !0
      ["*"] expn:GenTreeCode !1 !0
      [")"]
  -> <sl link expn >
      ["("]  link:GenTreeCode !1 !0
      [" << "] expn:GenTreeCode !1 !0
      [")"]
  -> <sr link expn >
      ["("]  link:GenTreeCode !1 !0
      [" >> "] expn:GenTreeCode !1 !0
      [")"]
  -> <an link expn >
      ["("] link:GenTreeCode !1 !0
      ["&"] expn:GenTreeCode !1 !0
      [")"]
  -> <or link expn >
      ["("] link:GenTreeCode !1 !0
      ["|"] expn:GenTreeCode !1 !0
      [")"]
  -> <xo link expn >
      ["("] link:GenTreeCode !1 !0
      ["^"] expn:GenTreeCode !1 !0
      [")"]
  -> <nt expn >
      ["(!"] expn:GenTreeCode !1 !0
      [")"]
  -> <lx expn >
      ["(~"] expn:GenTreeCode !1 !0
      [")"]
  -> <eq link expn >
      ["("]  link:GenTreeCode !1 !0
      [" == "] expn:GenTreeCode !1 !0
      [")"]
  -> <eq link expn >
      ["("]  link:GenTreeCode !1 !0
      [" == "] expn:GenTreeCode !1 !0
      [")"]
  -> <ne link expn >
      ["("]  link:GenTreeCode !1 !0
      [" != "] expn:GenTreeCode !1 !0
      [")"]
  -> <ge link expn >
      ["("]  link:GenTreeCode !1 !0
      [" >= "] expn:GenTreeCode !1 !0
      [")"]
  -> <le link expn >
      ["("]  link:GenTreeCode !1 !0
      [" <= "] expn:GenTreeCode !1 !0
      [")"]
  -> <gr link expn >
      ["("] link:GenTreeCode !1 !0
      [" > "] expn:GenTreeCode !1 !0
      [")"]
  -> <ls link expn >
      ["("] link:GenTreeCode !1 !0
      [" < "] expn:GenTreeCode !1 !0
      [")"]
  -> <ca link expn >
      ["_cat_("] link:GenTreeCode !1 !0
      [", "]      expn:GenTreeCode !1 !0
      [")"]
  -> <jm link expn >
      ["MAX("] link:GenTreeCode !1 !0
      [","] expn:GenTreeCode !1 !0
      [")"]
  -> <rx expn ..>           {ignore runtime range check}
      expn:GenTreeCode !loval !hival
  -> <un expn ..>          {ignore zero-ptr check address}
      expn:GenTreeCode !loval !hival
  -> <dn <> expn >                                          {unused}
      ["down__ptr("]  expn:GenTreeCode !loval !hival  [")"]
  -> <dn exty expn >
      ["("] exty:TypeSpell [")down__ptr("]
      expn:GenTreeCode !loval !hival  [")"]
  -> <al link exty ..>%expn
      [treeint !expn ^whom; "("]  exty:TypeSpell  [")"]
      ([link#<>; "(_tmp_0_ = "])?   {_tmp_0_ is global in TurkFrame.h}
      ["new_int_ary("; number !whom; ")"]  {whom>0, always precounted}
      ([link#<>] link:GenTreeCode !0 !-4 [", _tmp_0_)"])?
  -> <ar <> <ty <> <sz> <ar xptr exty ..>> expn >
      ["("] exty:TypeSpell ["*)new_int_ary("]
      expn:GenTreeCode !1 !0    [")"]
  -> <dy expn >
      expn:GenTreeCode !loval !hival
  -> <of <dr <>>>%xptr
      [treeint !xptr ^whom; "_tmp_0_[2+"; number !whom; "]"]
  -> <by expn >
      ["((int)(&"]  expn:GenTreeCode !loval !hival  ["))"]
  -> <ft link <fn ..>%xptr >
      [treestr !xptr ^snam; "((int)(&"; spell !snam; "))"]
  -> <op expn <>> {ORD}
      ["ORD("]  expn:GenTreeCode !loval !hival   [")"]
  -> <op expn exty >
      ["ORD("]   ([exty#<>; "("]  exty:TypeSpell  [")"])?
      expn:GenTreeCode !loval !hival   [")"]
  -> <pm expn > {PEEK}
      ["_PEEK_((int)"]  expn:GenTreeCode !loval !hival   [")"]
  -> <lg expn >        {LENGTH(ary)}
      ["((int)(*((int*)("]  expn:GenTreeCode !loval !hival  ["))))"]
  -> <sg expn >        {LENGTH(str)}
      ["_len_("]
      expn:GenTreeCode !loval !hival  [")"]
  -> <mt expn <sy>%xptr > {4:I->S,3:C->S,6:4->S,2:B->S}
      [treeint !xptr ^whom; "String("]
      ([whom=-4; "(int)"]|[whom=-2; "(bool)"]
      |[whom=-3; "(char)"]|[whom=-6; "(Char4)"])
      expn:GenTreeCode !loval !hival   [")"]
  -> <dc link xptr expn:<ac ..>>
      expn:GenTreeCode !loval !hival
  -> <ac link <cn>%xptr <nn>>   {chr4}   {0x80808080}
      [treeint !xptr ^whom; bitand !whom !-2139062144 ^anum; anum=0]
      ([whom=0; "Null4"] {|[whom=538976288; "NoName"]}  {0x20202020}
      |[whom>538976287; "Char4("; ascii !34]
       ([whom#0; ascii !whom/16777216; whom@=whom*256])*
       [ascii !34; ")"])
  -> <ac link expn <nn>>
      ["CHR4("]  expn:GenTreeCode !loval !hival  [")"]
  -> <ac link expn <at>>     {PackText}
      expn:PakTxt !24
  -> <ac link expn <ch> xptr > {TextChar}
      ["(char)((("] expn:GenTreeCode !loval !hival
      [")>>((("]   xptr:GenTreeCode !loval !hival
      [")&3)<<3))&255)"]
  -> <ac <> link <if> expn >%xptr {MIN=0/MAX=1}
      [treeint !xptr ^whom]  ([whom=0; "MIN("]|[otherwise; "MAX("])
      link:GenTreeCode !loval !hival
      [","] expn:GenTreeCode !loval !hival  [")"]
  -> <ac link expn <pl>> {ABS}
      ["ABS("]  expn:GenTreeCode !loval !hival  [")"]
  -> <xc expn xptr >
      CheckLn !true
      expn:GenTreeCode !loval !hival
      ([xptr:<ad>; "++"]|[xptr:<su>; "--"])
  -> <cp expn >
      ["CHR("]  expn:GenTreeCode !loval !hival  [")"]
  -> <sy link expn <> <nn>%xptr >     {system call??}
      [treeint !xptr ^whom; whom=-9; "Chr4Str("]
      expn:GenTreeCode !loval !hival    [")"]
  -> <zz link expn <nn>%xptr >            {nothing builds this node}
      link:GenTreeCode !loval !hival
      [treeint !xptr ^whom; "  set_ary_size((void*)"]
      expn:VarSpell   [",-"; number !whom; ")"]  EndLn !true !false
  -> <bg link > {DEBUG}
  -> <sm link expn >%xptr    {Signal or Wait}
  -> <pr expn <up>%xptr >
      ([xptr#<>; "("]  xptr:TypeSpell  [")"])?
      ["up__ptr("]
      expn:GenTreeCode !loval !hival  [")"]
  -> <pr expn ..>
      expn:GenTreeCode !loval !hival
  -> <ki ..>|<cl ..>
  -> <>
  -> expn
      [tron !2; trunflag !expn ^whom]  TreeSee !expn
      [//"Oops (GenTreeCode)"//; 0=1] ; {~GenTreeCode}

PreCodeTree !symtb:table
  -> <fc link args <fn var exty xptr <fp>> ..>             {native code call}
      {link:PreCodeTree !symtb}  {do expressions only}
      args:PreCodeTree !symtb
  -> expn:<fc link args <fn var <xf exty ..> ..>%xptr ..>  {seg'd funct call}
      {link:PreCodeTree !symtb}
      args:PreCodeTree !symtb
      CheckLn !true
      [treestr !xptr ^snam; "mystakframe = new "; spell !snam; "(myframe"]
      ([args#<>; ", "]  args:GenTreeCode !1 !0 )?
      [")"]  EndLn !true !true
      NewBlockNum ^whom
      GoToBlock !true !whom !symtb
      StartBasicBlock !whom !symtb
      exty:WhatType ^tyx
      ([tyx>-1; "-  "; getat !2 ^prev; varn=prev+1; putat !2 !varn]
       exty:TypeSpell   [vno=varn+1000; " _tmp_"; number !vno; "_;"]
       [ascii !00; "  myframe->_tmp_"; number !vno; "_ = "]
       ShoRetName !false !exty   EndLn !true !true
      |[vno=0])
  => <va link expn >%vno
  -> <dn link expn >
      expn:PreCodeTree !symtb
  -> <at link expn var >%exty
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> var:<va link expn:<fc xptr exty ..>>
      {link:PreCodeTree !symtb}  {do expressions only}
      exty:PreCodeTree !symtb
      CheckLn !false   ["  "]   var:VarSpell
      [" = "]   expn:GenTreeCode !1 !0
      EndLn !true !true
  -> <va link ..>
      {link:PreCodeTree !symtb}  {do expressions only}
  -> <vr ..>|<tc ..>|<of ..>|<ch>|<ys>|<cn>
  -> <nm link ..>
      link:PreCodeTree !symtb
  -> <as link var expn xptr >
      link:PreCodeTree !symtb
      var:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <nc link expn ..>
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <dr expn >
      expn:PreCodeTree !symtb
  -> <rf expn >
      expn:PreCodeTree !symtb
  -> <nn link >
      link:PreCodeTree !symtb
  -> <yk link ..>
      link:PreCodeTree !symtb
  -> <ax link expn ..>
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <ng expn >
      expn:PreCodeTree !symtb
  -> <ad link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <su link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <dv link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <md link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <mp link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <sl link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <sr link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <an link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <or link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <xo link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <nt expn >
      expn:PreCodeTree !symtb
  -> <lx expn >
      expn:PreCodeTree !symtb
  -> <eq link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <eq link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <ne link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <ge link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <le link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <gr link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <ls link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <ca link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <jm link expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <rx expn ..>
      expn:PreCodeTree !symtb
  -> <un expn ..>
      expn:PreCodeTree !symtb
  -> <al link ..>
      link:PreCodeTree !symtb
  -> <ar <> <ty ..> expn >
      expn:PreCodeTree !symtb
  -> <dy expn >
      expn:PreCodeTree !symtb
  -> <by expn >
      expn:PreCodeTree !symtb
  -> <op expn ..>
      expn:PreCodeTree !symtb
  -> <pm expn > {PEEK}
      expn:PreCodeTree !symtb
  -> <lg expn >        {LENGTH(ary)}
      expn:PreCodeTree !symtb
  -> <sg expn >        {LENGTH(str)}
      expn:PreCodeTree !symtb
  -> <mt expn <sy>%xptr > {4:I->S,3:C->S,6:4->S,2:B->S}
      expn:PreCodeTree !symtb
  -> <dc link xptr expn >
      expn:PreCodeTree !symtb
  -> <ac <> link <if> expn >
      link:PreCodeTree !symtb
      expn:PreCodeTree !symtb
  -> <ac link expn <ch> xptr > {TextChar}
      expn:PreCodeTree !symtb
      xptr:PreCodeTree !symtb
  -> <ac link expn ..>
      expn:PreCodeTree !symtb
  -> <xc expn ..>
      expn:PreCodeTree !symtb
  -> <cp expn >
      expn:PreCodeTree !symtb
  -> <sy link expn ..>
      expn:PreCodeTree !symtb
  -> <zz link ..>            {nothing builds this node}
      link:PreCodeTree !symtb
  -> <pr expn ..>
      expn:PreCodeTree !symtb
  -> <ft link ..>
  -> <ki ..>|<cl ..>|<bg ..>|<sm ..>
  -> <>
  -> expn
      [tron !2; trunflag !expn ^whom]  TreeSee !expn
      [//"Oops (PreCodeTree)"//; 0=1] ; {~PreCodeTree}

IsVoid                  {fails if not type void}
  -> <ty link <sz> <vd>>
  -> <xf link ..>
      link:IsVoid ;

PakTxt !shft:int  {Little-Endian version}
  -> <at link expn >
      ([link#<>]  link:PakTxt !shft-8  ["+"])?
      ["(((int)("]  expn:GenTreeCode !1 !0
      [")&255)<<"; number !shft; ")"] ;

StartupNames !pname:str
  -> <nm link >%namt
      ([treestr !namt ^snam; snam#pname]  StartupCaller !false !snam )?
      link:StartupNames !pname
  -> <no> ;

StringArrayZaps                              {from !-11 !sym..}
  -> <no link >
      link:StringArrayZaps
  -> <vr link var:<vr vlnk <ty tlnk tsz <ar rty
          <ty slnk ssz <st> ..> ..> ..> ..> ..>
      link:StringArrayZaps
      CheckLn !true  ["_2POKE0_((int*)"]
      var:VarSpell   [")"]  EndLn !true !false
  -> <vr link ..>
      link:StringArrayZaps
  -> <> ;

GlobArrayInits                               {from !-12 !sym..}
  -> <no link >
      link:GlobArrayInits
  -> <vr link var <ar>%nst >
      link:GlobArrayInits
      CheckLn !true   ["set_ary_size((void*)"]    var:VarSpell
      [treeint !nst ^vsz; ",-"; number !vsz; ")"]  EndLn !true !false
  -> <vr link var <ze>%nst >
      link:GlobArrayInits
      CheckLn !true    var:VarSpell   [" = "]
      [treeint !nst ^vsz; number !vsz]  EndLn !true !false
  -> <vr link var <ch>%nst >
      link:GlobArrayInits
      CheckLn !true    var:VarSpell   [" = "]
      [treeint !nst ^vsz]  GenChar !vsz    EndLn !true !false
  -> <vr link var nst:<st>>
      link:GlobArrayInits
      CheckLn !true    var:VarSpell   [" = "]
      nst:Cstring    EndLn !true !false
  -> <vr link var <nm>%nst >       {can't happen, cuz natv=false never}
      link:GlobArrayInits
      CheckLn !true
      [treestr !nst ^idn; "_glob_var_ "; spell !idn; " = __"; spell !idn]
      EndLn !true !false
  -> <vr link var <rc>%nst >       {can't happen, cuz natv=false never}
      link:GlobArrayInits
      CheckLn !true
      [treestr !nst ^idn; "_glob_var_ "; spell !idn;
           " = &(_glob_var_ _"; spell !idn; "_)"]
      EndLn !true !false
  -> <vr link ..>
      link:GlobArrayInits
  -> <vr link var <ys>>                    {init not needed for ""..}
      link:GlobArrayInits
      {CheckLn !true   var:VarSpell  [" = Null_Str"]  EndLn !true !false}
  -> <> ;

StringFrom ^sname:str          {fails if not string literal}
  -> <tc lnk <st>%strt ..>
      [treestr !strt ^sname];

SwitchCases !symtb:table
  -> <cs lnk <> ..>%numtr
      lnk:SwitchCases !symtb
      [treeint !numtr ^nint; "  default:"]  EndLn !false !true
      GoToBlock !false !nint !symtb
  -> <cs lnk lbls ..>%numtr
      lnk:SwitchCases !symtb
      lbls:SwitchCases !symtb
      [treeint !numtr ^nint]
      GoToBlock !false !nint !symtb
  -> <cn lnk >%numtr
      lnk:SwitchCases !symtb
      [treeint !numtr ^nint; "  case "; number !nint; ":"]
      EndLn !false !true
  -> <> ;

TablElts !natv:bool !strn:bool !eltn:int !nelts:int !xtyp:int
  -> <in lnk >%vxt
      lnk:TablElts !natv !strn !eltn-1 !nelts !xtyp
      [treeint !vxt ^vxn; ", "]
      ([eltn\8=0; ascii !00] ([natv=false; "+"])? ["    "])?
      ([strn=true; "Null_Str"]
      |[xtyp=2&vxn=0; "false"]|[xtyp=2&vxn#0; "true"]
      |[xtyp=3&vxn=39; "'"; ascii !92; "''"]
      |[xtyp=3&vxn>31&vxn<127; "'"; ascii !vxn; "'"]
      |[xtyp=3; "(char)"] HexOrDec !vxn
      |[xtyp=4; "CHR4("]  HexOrDec !vxn  [")"]
      | HexOrDec !vxn )
  -> <ls lnk vxt >
      lnk:TablElts !natv !strn !eltn-1 !0 !xtyp
      [","; ascii !00] ([natv=false; "+"])? ["    "]  vxt:Cstring
  -> <sz>  ([xtyp=4; "CHR4("; number !nelts; "),CHR4(0x20202020)"]
           |[strn=true; "Null_Str,Null_Str"]
           |[otherwise; number !nelts; ",-1"]) ;

TypeSpell
  -> <ty lnk sizt <ar rng typ > ..>%tnam
      [tnam=<>] typ:TypeSpell ["*"]
  -> <ty lnk sizt <pt typ > ..>%tnam
      [tnam=<>] typ:TypeSpell ["*"]
  -> <ty <ty <> ..> ..>
      ["int"]
  -> <ty lnk sizt <ch>>
      ["char"]
  -> <cl ..>%tnam
      [treestr !tnam ^snam; spell !snam]
  -> <ty <ty <ty <> ..> ..> sizt <en ..>>
      ["bool"]
  -> <ty ..>%tnam
      [treestr !tnam ^snam; spell !snam]
  -> <fn ..>%tnam
      [treestr !tnam ^snam; spell !snam]
  -> <>  ;

UndefThese !didit:bool
  -> <nm link >%tnam
      [treeint !tnam ^inum]
      link:UndefThese !((inum>0)`didit)
      ([inum>0; "#undef "; intstr !inum ^snam; spell !snam; ascii !00])?
  -> <>  ([didit=true; ascii !00])? ;

VarSpell
  -> <> 
      NativeCodeQ ^natv   ([natv=false; "myframe->"])?
  -> <sy>
      ["_FrameWork_::"]
  -> <gl>
      {[" _glob_var_ "]}
  -> <nm ..>%tnam
      [treestr !tnam ^snam; "_"; spell !snam; "_::"]
  -> <vr link theTy adr <of locx > ..>%tnam
      locx:VarSpell
      [treestr !tnam ^snam; spell !snam]
  -> <ch>%tnam
      [treeint !tnam ^inum]  GenChar !inum
  -> <cn>%tnam
      [treeint !tnam ^inum]  HexOrDec !inum
  -> <va ..>%tnam
      [treeint !tnam ^inum]
      NativeCodeQ ^natv   ([inum>0 & natv=false; "myframe->"])?
      ([inum>0; "_tmp_"; number !inum; "_"])?
  -> <vr ..>%tnam
      NativeCodeQ ^natv   ([natv=false; "myframe->"])?
      [treestr !tnam ^snam; spell !snam];

WhatType ^whom:int
  -> <ty lnk sizt <ch>>
      [whom=3]
  -> <ty lnk sizt <st> ..>
      [whom=6]
  -> <ty lnk sizt <tf>>
      [whom=4]
  -> <ty lnk sizt <vd>>
      [whom=-1]
  -> <ty <ty <> ..> ..>
      [whom=1]
  -> <ty <ty <ty <> ..> ..> sizt <en ..>>
      [whom=2]
  -> <ty lnk sizt <en ..>>
      [whom=1]
  -> <ty ..>
      [whom=0];

InsertStuff !theTree:tree
  -> <ty lnk par <>>%deco
  => <ty lnk par theTree >%deco
  -> <ty lnk par body >%deco
  => <ty lnk par body theTree >%deco
  -> <fn <> <> <>>%deco
  => <fn <> <no> theTree >%deco
  -> <fn <> <no> body>%deco
  => <fn theTree <no> body >%deco
  -> <xf typ <> loc lnk <> body >%deco
  => <xf typ theTree loc lnk <> body >%deco
  -> <ar lnk body par >%deco
  => <ar lnk body par theTree >%deco
  -> <tc lnk body par >
  => <tc theTree body par >  {lnk is already in theTree by caller}
  -> deco:<fr lnk <> body par >
  => <fr lnk <sz theTree > body par >
  -> deco:<wh lnk <if <> par <nc <> <nc body <nx>>> <ex>>>
  => <lp lnk <if <> par <nc <sz theTree > <nc body <nx>%deco >> <ex>%deco >>
  -> <wh lnk <>>
  => <lp lnk <sz theTree > <>>
  -> <lp lnk <> <>>
  => <lp lnk <> theTree >
  -> <sw lnk loc <> body >%deco
  => <sw lnk loc theTree body >%deco
  -> <of <>>%deco
  => <of theTree >%deco
  -> <of <st>>
      [theTree:<st>]
  -> <of <pt>>
      [theTree:<pt>]
  -> body:<of ..>%deco
      [tron !2; trunflag !body ^inx]
      [trasci !165; trasci !165; trasci !165]          {}
      TreeSee !body
  => <of theTree >%deco
  -> <pt <>>
  => <pt theTree >
  -> <up <>>%deco
  => <up theTree >%deco
  -> <up body >
  -> <fp <>>%deco
  => <fp theTree >%deco
  -> <fp body >
  -> <pk lnk body par >%deco
  => <pk lnk body theTree >%deco
  -> <tp lnk body >
  => <tp <> <>>
  -> <nm body >%deco
  => <nm theTree >%deco
  -> <no lnk >
  => <no <vr lnk theTree >>  {pointer list}
  -> body  [tron !2; trunflag !body ^inx]
      TreeSee !body
      TreeSee !theTree
      [//"Oops (InsertStuff)"//; 0=1] ; {~InsertStuff}

ListStuff !theTree:tree !info:tree
  -> <no lnk >
  => <no <vr lnk theTree info >> ;

end Turk2C.

{tree node names, and what they mean...}
{ <ab -- array bounds check.. }
{ <ac -- action code (see below) }
{ <ad -- add: <ad lex rex > }
{ <ag -- argument.. }
{ <al -- allocate (class) mem: <al vals type >%siz }
{ <an -- logical and: <an lex rex > }
{ <ar -- array: <ar ixty elty <> typ >; const'r: <ar <> typ <cn>%nelts > }
{ <as -- assignment: <as lnk var expn stf >%exty }
{ <at -- argument with type: <at lnk expn stf >%exty }
{ <ax -- array index: <ax addr expn <rn ..>>%esiz }
{ <bf -- built-in funct.. }
{ <bg -- debugger: <bg lnk > }
{ <bs -- byte store.. }
{ <bt -- .. }
{ <by -- [byte] address of: <by var > }
{ <ca -- concatenate: <ca lex rex > }
{ <cc -- string const: <cc>%value }
{ <ch -- character in table: <ch lnk >%chr }
{ <cl -- class: <cl lnk typ sup body symtb siz >%name }
{ <cm -- comment }
{ <cn -- constant: <cn>%value }
{ <co -- copy words: <co lnk dst src >%nn }
{ <cp -- CHR() }
{ <cs -- case <cs lnk <cn lnk >%value body > }
{ <ct -- catch.. }
{ <cv -- control variable }
{ <dc -- declared const <dc lnk typ <cn>%val > }
{ <df -- end of init code: <df dclns > }
{ <dl -- declaration level.. }
{ <dn -- down-ref ptr/str var/fn res: [<dn lnk <of ..>>] / <dn typ <fc ..>> }
{ <do -- .. }
{ <dr -- dereference: <dr Lexpn >%siz }
{ <dv -- divide: <dv lex rex > }
{ <dy -- dynamic array size: <dy etree > }
{ <el -- else.. }
{ <en -- enumeration }
{ <eq -- equal: <eq lex rex > }
{ <er -- error.. }
{ <ex -- exit: <ex lnk >%btree }
{ <ez -- code }
{ <fc -- function call: <fc lnk args <fn ..>%fno <nn>%rsz > }
{ <fd -- function defn link: <fd lnk <fn ..>> }
{ <fk -- fork.. }
{ <fl -- floating point }
{ <fn -- function: <fn lnk <xf ..> <fn body <no> fun >%fno <up>%par >%nm }
{ <fp -- floating point, also used to flag native functions stead of <up> }
{ <fr -- for-loop: <fr lnk+init body upd extst > }
{ <ft -- function type, used for address of function: <ft lnk <fn ..>> }
{ <ge -- greater-equal: <ge lex rex > }
{ <gl -- global.. }
{ <go -- goto.. }
{ <gr -- greater: <gr lex rex > }
{ <hi -- high.. }
{ <hp -- help.. }
{ <if -- if-then-else <if lnk expn thn els > }
{ <in -- integer table elt: <in lnk >%n }
{ <io -- hard address: <io> }
{ <it -- iterate.. }
{ <jm -- max: <jm lex rex > (gen'd code only) }
{ <jp -- jump.. }
{ <jz -- jump zero.. }
{ <ki -- kill recursion: <ki expn > }
{ <lc -- location or address of <lc base >%offs }
{ <ld -- load.. }
{ <le -- less-equal: <le lex rex > }
{ <lg -- length: <lg ary > }
{ <lo -- low or location offset.. }
{ <lp -- (do-while) loop: <lp lnk body update/tst > }
{ <ls -- less: <ls lex rex > or literal string in table}
{ <lx -- bit-invert: <lx expn > }
{ <md -- modulus: <md lex rex > }
{ <mp -- multiply: <mp lex rex > }
{ <mt -- coerce: <mt expn <ty >%exty >%resType; <mt expn <sy>%syscall > }
{ <nc -- semicolon statement connector = ; <nc left right nogen > }
{ <ne -- unequal: <ne lex rex > }
{ <ng -- negative: <ng expn > }
{ <nl -- nil: <pt <nl>> }
{ <nm -- name of instance var x.y => <nm x >%y }
{ <nn -- line #: <nn lnk >%lino }
{ <no -- used when nothing else is appropriate "nop" }
{ <np -- null pointer check.. }
{ <nt -- signature name: <nt>%name ; logical not: <nt xtree > }
{ <nu -- null.. }
{ <nx -- next/continue: <nx lnk >%loop }
{ <of -- offset: <of base > }
{ <op -- ORD: <op exp > }
{ <or -- logical or: <or lex rex > }
{ <ot -- object type access <ot fld > }
{ <ov -- overflow.. }
{ <pk -- package: <pk <> basesyms pksymtb >%name }
{ <pl -- abs <pl> }
{ <pm -- peek memory: <pm adr > }
{ <pr -- up-ref param: <pr val <st>|<pt>|<up>> }
{ <pt -- pointer: <pt exty/expn > }
{ <qm -- question mark.. }
{ <qu -- question.. }
{ <rc -- record..: <rc <up>%par adr elts symtb > }
{ <rf -- reference: <rf <dr x >> = <dr <rf x >> = x}
{ <rg -- read-mod-write: <rg lnk addr n > }
{ <rn -- range: <rn <cn>%lo <cn>%hi typ > }
{ <rp -- ref param/var <rp> }
{ <rt -- return: <rt lnk >%func (expn is now an asn) }
{ <rx -- runtime range check: <rx access index >%topn }
{ <sa -- shift algebraic.. }
{ <sg -- length: <sg str > }
{ <sh -- shift: <sh expn nbits > -- not used}
{ <sl -- shift left: <sl expn nbits > }
{ <sm -- semaphore op <sm lnk loc >%opn or type <sm> }
{ <sr -- shift right: <sr expn nbits > }
{ <st -- free string.. }
{ <su -- subtract: <su lex rex > }
{ <sw -- switch <sw lnk expn cases range >%type }
{ <sy -- system call <sy lnk prms pmx <nn>%op >%pop }
{ <sz -- size: <sz>%nb }
{ <tc -- table constant: <tc lnk elts loc > }
{ <tf -- Char4 tag <tf> }
{ <th -- throw: <th lnk expn > }
{ <tk -- instanceof operator: <tk expn >%typ }
{ <tp -- temp var for later dispose: <tp link <of <>>>%tvn }
{ <tr -- throw.. }
{ <tv -- temp variable, this: <tv npt >%'this' }
{ <ty -- type: <ty lnk <sz> typ .. >%name }
{ <un -- null pointer check: <un access <>> }
{ <up -- up-link: <up>%par or ptr up-ref}
{ <va -- temp variable: <va>%vnum }
{ <vd -- void.. }
{ <vr -- local variable: <vr lnk typ info adr stf >%name }
{ <vt -- save temp copy for down-ref: <vt expn addr ty > }
{ <wd -- word.. }
{ <wh -- while: <wh lnk body > }
{ <xc -- ++/--: <xc var <ad>> }
{ <xf -- funct info: <xf rtnty pmlst <nn>%nlocvs ptrlst ntc symt >%npms }
{ <xo -- exclusive or: <xo lex rex > }
{ <yk -- init array size: <yk lnk var > or break: <yk lnk <cn>%cntr >%body }
{ <ys -- Null_Str <ys> }
{ <ze -- zero: <ze lnk >%loc }
{ <zz -- zero whole static array: <zz lnk <nn>%nlts >%loc }

{ -1  function/class decln }
{ -2  breakabl/loop list }
{ -3  executable code+declns tree }
{ -4  current var alloc }
{ -5  function list }
{ -6  constants tables }
{ -7  the name 'main' }
{ -8  "false" string constant }
{ -9  temp vars list }
{ -10  program name }
{ -11  list of string arrays for StringArrayZaps }
{ -12  list of GlobArrayInits }
{ -13  list of UndefThese }

{ Other needed tree nodes.. }
